' $segment
' $linesize: 132
' $title: 'RBBS-PC 17.4, Copyright 1992 by D. Thomas Mack'
' WARNING !!! DO NOT CHANGE, BYPASS OR Remove LINES 3-29
' by D. Thomas Mack, 39 Cranbury Drive, Trumbull, CT 06611 (up to 16)
'    Jon Martin, 4396 N Prairie Willow Ct, Concord, CA 94521 (up to 17.2B)
'    Ken Goosens, 5020 Portsmouth Road, Fairfax, VA 22032
'    Doug Azzarito, 2399 NW 30th Road, Boca Raton, FL 33431
'
' *******************************NOTICE*************************************
' *  A limited license is granted to all users of this program and it's    *
' *  companion program, CONFIG (version 17.4), to make copies of this      *
' *  program and distribute the copies to other users, on the following    *
' *  conditions:                                                           *
' *    1.   The notices contained in lines 3 through 29 of the program     *
' *         are not altered, bypassed, or removed.                         *
' *    2.   The program is not to be distributed to others in modified     *
' *         form (i.e. the line numbers must remain the same).             *
' *    3.   No fee is to be charged (or any other consideration received)  *
' *         for copying or distributing these programs without an express  *
' *         written agreement with the authors.                            *
' *                                                                        *
' *       Copyright (c) 1983-1992 T. Mack, J. Martin, K. Goosens, CPCUG    *
' **************************************************************************
'
' $INCLUDE: 'RBBS-VAR.BAS'
'
' $SUBTITLE: 'Main-line RBBS-PC Program'
'
'   CALL SetFileHandles (30)

    ZCrLf$ = CHR$(13) + CHR$(10)
    WasJ = 60
    DIM ZOptSec(WasJ)
    ZConfigFileName$ = "RBBS-PC.DEF"
    CALL GetCommand (ZDebug,ZNetTime$,ZNetBaud$,ZNetReliable$)
    ZSubParm = -62
    ZBulletinMenu$ = ""
    CALL ReadDef (ZConfigFileName$)
    IF ZErrCode > 0 THEN
       ZExitCode = 10
       GOTO 204
    END IF
    IF ZCallerID$ <> "" THEN
       CALL CallerID (ZCallerID$)
    END IF
'
' * SET UP FOR VGA 25/43/50 Screen Lines
'
    SCREEN 0
    WIDTH 80,ZLocalPageLength

    CLEAR,,ZSizeOfStack

    ZExitCode = 0

    CALL VarInit
    IF ZErrCode > 0 THEN
       ZExitCode = 11
       GOTO 204
    END IF
    IF ZNetWorkType = 6 THEN
       CALL CheckShare
       IF NOT ZOK THEN
          ZExitCode = 12
          GOTO 204
       END IF
    END IF
    OrigUpgradeSec = ZAutoUpgradeSec
    OrigMainSec = ZMinLogonSec
    CALL BreakFileName (ZOrigMsgFile$,Drive$,OrigMsgName$,ZWasY$,ZFalse)
    IF OrigMsgName$ = "MESSAGES" THEN
       OrigMsgName$ = "MAIN"
    ELSEIF RIGHT$(OrigMsgName$,1) = "M" THEN
       OrigMsgName$ = LEFT$(OrigMsgName$,LEN(OrigMsgName$)-1)
    END IF
    ConfFileName$ = OrigMsgName$
    OrigNewsFileName$ = ZWelcomeFileDrvPath$ + OrigMsgName$ + ".NWS"
    ZNewsFileName$ = OrigNewsFileName$
    CALL GetMenu0Info
    IF ZNetMail$ <> "NONE" AND VAL(ZNetTime$) > 0 THEN
       ZLimitMinsPerSession = VAL(ZNetTime$)
       ZExpectActiveModem = ZTrue
       IF NOT ZKeepInitBaud THEN
          ZModemInitBaud$ = ZNetBaud$
       END IF
    END IF
    IF ZFossil THEN
       ZComPortNum = VAL(RIGHT$(ZComPort$,1)) - 1
       IF ZComPortNum < 0 THEN
          GOTO 108
       ELSE
          CALL FOSinit(ZComPortNum,Result)
          IF Result = -1 THEN
             ZSnoop = ZTrue
             '* "ERROR INITIALIZING FOSSIL"
             CALL FormatString (1,ZTrue,ZFalse,0,ZFalse,0,"")
             ZExitCode = 14
             GOTO 204
          END IF
       END IF
    END IF
'
108 CALL BBSFileSetup
'
' *****  INITIALIZE NetBIOS INTERFACE   ****
'
    IF ZNetworkType = 6 AND NOT ZSubBoard THEN
       CALL InitIBM
       IF NOT ZOK THEN
          ZExitCode = 13
          GOTO 204
       END IF
    END IF
'
' *****  ESTABLISH NEXT CALLERS FILE RECORD AVAILABLE   ***
'
    CALL SetCall
    CALL BBSTimeSetup
'
' *****  TEST FOR MESSAGE FILE PRESENT (Abort IF NOT PRESENT)  ****
'
    IF ZCurDef$ = ZOrigCnfg$ THEN
       ZActiveMessageFile$ = ZMainMsgFile$
       ZActiveUserFile$ = ZMainUserFile$
    END IF
    GOSUB 4910
    IF ZConfMode THEN
       GOTO 150
    END IF
    CALL GetLastCaller (ZTrue)
    ZLocalUserMode = (RIGHT$(ZComPort$,1) < "1")
    GET 1,ZNodeRecIndex
    ZWasY$ = MID$(ZMsgRec$,77,2)
    CALL UnPackDate (ZWasY$,WasX,WasL,WasI,ZOldDate$)
    ZOldDate$ = LEFT$(ZOldDate$,6) + MID$(STR$(WasX),2)
    ZHourMinToDropToDos = - (ZHourMinToDropToDos > 0) * ZHourMinToDropToDos
    HourX = INT(ZHourMinToDropToDos / 100)
    WasMN = ZHourMinToDropToDos - HourX * 100
    ZTimeToDropToDos! = HourX * 3600! + WasMN * 60!
'
' ******  TEST FOR TIMED EXIT ACTIVE   *****
'
    IF ZHourMinToDropToDos > 0 AND ZOldDate$ <> DATE$ AND _
       TIMER >= ZTimeToDropToDos! AND TIMER < 86340 THEN
       GOTO 206
    END IF
'
' **** GET CURRENT STATUS OF SYSOP AVAIL, SYSOP ANNOY, SYSOP NEXT, & PRINTER
'
150 IF ZSubBoard THEN
       GOSUB 12987
       GOSUB 5135
       GOTO 170
    END IF
    ZSysopAvail = VAL(MID$(ZMsgRec$,32,2))
    ZSysopAnnoy = VAL(MID$(ZMsgRec$,34,2))
    ZSysopNext = VAL(MID$(ZMsgRec$,36,2))
    MID$(ZMsgRec$,36,2) = STR$(ZFalse)
    ZExitToDoors = (MID$(ZMsgRec$,40,2) = "-1" AND ZNetBaud$ = "" _
                    AND INSTR(COMMAND$," LOCAL") = 0)
    ZEightBit = VAL(MID$(ZMsgRec$,42,2))
    ZBPS = -VAL(MID$(ZMsgRec$,44,2))
    ZSnoop = VAL(MID$(ZMsgRec$,58,2))
    MID$(ZMsgRec$,57,1) = "I"
    ZPrivateDoor = (MID$(ZMsgRec$,72,2) = "-1")
    IF ZPrivateDoor THEN
       ZHasPrivDoor = ZTrue
    END IF
    MID$(ZMsgRec$,72,2) = STR$(ZFalse)
    ZLocalUser = (MID$(ZMsgRec$,101,2) = ZCarriageReturn$+ZCarriageReturn$) OR _
                 ZLocalUserMode
    IF ZExitToDoors OR ZPrivateDoor THEN
       ZHasDoored = ZTrue
       ZTurboLogon = ZTrue
    END IF
    PUT 1,ZNodeRecIndex
    GOSUB 12985
    GET 1,1
    ZCallsToDate! = VAL(MID$(ZMsgRec$,11,10))
    IF ZCallsToDate! < 11 THEN
       CALL CopyRight
       IF NOT ZOK THEN
          ZExitCode = 15
          GOTO 204
       END IF
    END IF
170 FOR FunctionKeyIndex = 1 TO 10
       KEY FunctionKeyIndex,""
    NEXT
'
' ******  INITIALIZE FILE MANAGEMENT SYSTEM, CHECK FOR LOCAL BBS MODE
'
    GOSUB 5344
    CALL BBSFMSSetup
    ZSecsPerSession! = ZMinsPerSession * 60!
    LogIndex = 1
    IF NOT ZLocalUserMode THEN
       IF NOT ZExitToDoors THEN
          GOTO 180
       ELSEIF NOT ZLocalUser THEN
          GOTO 180
       END IF
    END IF
    ZLocalUser = ZTrue
    ZBPS = -7
    ZBaudTest! = 9600
    '* "9600"
    LineNum = 1002
    GOSUB 49030
    ZCBaud$ = Strng$
    ZCBPS = -7
    ZEightBit = ZTrue
    ZSnoop = ZTrue
    IF ZExitToDoors THEN
       CALL AMorPM
       CALL ReadProf
       GOTO 410
    END IF
    GOSUB 178
    IF ZLocalUser AND ZEscapeInsecure THEN
       GOTO 822
    ELSE
       GOTO 345
    END IF
178 IF NOT ZSubBoard THEN
       RETURN
    END IF
    IF ZNewUser THEN
       GOSUB 758
       RETURN 790
    END IF
    IF OrigFirstName$ = ZSysopFirstName$ AND ZLastName$ = ZSysopLastName$ THEN
       RETURN 832
    ELSE
       RETURN 790
    END IF
180 ZSubParm = 2
    CALL Line25
    CALL SingleNodeDoorClear
    GOSUB 178
'
' ******  WAIT FOR THE PHONE TO RING AND ANSWER IT   ****
'
    ZSubParm = 1
200 ZToggleOnly = ZTrue
    CALL AnswerIt
    GET 1,ZNodeRecIndex
    ZSnoop = VAL(MID$(ZMsgRec$,58,2))
    IF NOT ZSnoop THEN
       '* "(Snoop is OFF Press <F9> To ReActivate)"
       CALL FormatString (2,ZTrue,ZFalse,0,ZFalse,0,"")
    END IF
    ZToggleOnly = ZFalse
    IF ZErrCode > 1 THEN
       GOTO 13000
    END IF
    IF ZSubParm < 0 THEN
       GOTO 202
    END IF
    ON ZSubParm GOTO   410, _   '  1 = ANSWERED PHONE & CARRIER FOUND
                       330, _   '  2 = CARRIER FOUND BEFORE ANSWERING
                       822, _   '  3 = SysOp GETS SYSTEM NEXT
                     10595, _   '  4 = ANSWERED PHONE BUT NO CARRIER
                     13540, _   '  5 = NOT USED
                       202, _   '  6 = LOCAL SYSOP KEY PRESSED
                       206, _   '  7 = TIME TO DROP TO DOS
                     13538      '  8 = No CALLS! TIME TO RECYCLE
202 ZFF = -ZSubParm
    ON ZFF GOTO 10595, _   '  -1 = CARRIER DROPPED
                 4700, _   '  -2 = SYSOP INITIATED CHAT
                  205, _   '  -3 = FORCE SYSTEM TO ANSWER THE PHONE
                  204, _   '  -4 = EXIT TO DOS IMMEDIATELY
                  204, _   '  -5 = EXIT TO DOS AFTER CLEAN-UP
                10698, _   '  -6 = INDICATE ACCESS IS DENIED AND LOGOFF USER
                10620      '  -7 = UPDATE CALLERS FILE AND LOGOFF USER
204 IF ZFossil THEN
       CALL FOSExit(ZComPortNum)
    END IF
    CLS
    LOCATE ZLocalPageLength-1,1
    END ZExitCode
205 ZSubParm = 4
    GOTO 200
206 CALL TimedOut
    ZExitCode = 0
    GOTO 204
330 CALL CheckCarrier
    IF ZSubParm = -1 THEN
       GOTO 10595
    END IF
    CALL EofComm (Char)
    IF Char = -1 THEN
       GOTO 335
    END IF
    CALL FlushCom (ZWasDFF$)
    IF ZSubParm = -1 THEN
       GOTO 10595
    END IF
    GOTO 330
335 ZExitToDoors = ZFalse
    ZPrivateDoor = ZFalse
    IF ZExpectActiveModem = ZTrue THEN
       GOTO 345
    END IF
    LOCATE 16,55,1
    '* "CONNECT"
    LineNum = 1001
    GOSUB 49030
    WasD$ =ZSysopColor$ + Strng$ + _
        STR$(ZBaudTest!) + _
        SPACE$(5) + ZEmphasizeOffDef$
    GOSUB 1315
'
' *****  DISPLAY WELCOME LINE  ****
'
345 ZSubParm = 1
    CALL Line25
    CALL SayWelcome
    IF ZRIPGraphics THEN
       CALL CheckRIPIcons
    END IF
    GOSUB 466
    IF ZSubParm = -1 THEN
       GOTO 13540
    END IF
    ZFF = ZFalse
'
' *****  GET USER NAME
' *****  C - COMMAND FROM NEWUSER REGISTER OPTIONS (CHANGE NAME OR ADDRESS)
'
400 ZEscapeInsecure = 0
    ZUpperCase = ZFalse
    CALL SetExpert
    '* "What is your "
    LineNum = 3
    GOSUB 49030
    WasA1$ = Strng$
    CALL FlushCom (ZWasDFF$)
    GOSUB 12500
    CALL CommInfo
    IF ZFF THEN
       ZLogonErrorIndex = 1
       ZExitCode = 20
       GOTO 10620
    END IF
    IF ZMinOldCallerBaud! > ZBaudTest! THEN
       '* "Sorry {MS BPS not allowed"
       LineNum = 4
       CRCount = 1
       GOSUB 49010
       '* "OLD CALLER BAUD RESTRICTION"
       LineNum = 5
       GOSUB 49030
       ZWasLG$(7) = Strng$
       ZLogonErrorIndex = 7
       ZExitCode = 21
       GOTO 10620
    END IF
    IF (ZBBSOptions AND 16) > 0 AND RIGHT$(ZBaudParity$,3) <> "8,1" THEN
       '* "Sorry, {PA Parity not allowed. Please call back using N,8,1"
       LineNum = 6
       CRCount = 1
       GOSUB 49010
       '* "BAUD/PARITY RESTRICTION"
       LineNum = 7
       GOSUB 49030
       ZWasLG$(7) = Strng$
       ZLogonErrorIndex = 7
       ZExitCode = 22
       GOTO 10620
    END IF
    IF ZNoBlocking AND ZCallerIDBlockActive THEN
       '* Sorry, CALLER ID Blocking not allowed.{CRPlease call back without blocking CALLER ID!"
       LineNum = 1100
       CRCount = 1
       GOSUB 49010
       '* CALLER ID BLOCK RESTRICTION"
       LineNum = 1101
       GOSUB 49030
       ZWasLG$(7) = Strng$
       ZLogonErrorIndex = 7
       ZExitCode = 23
       GOTO 10620
    END IF
    CALL CheckCallerID (Found)
    IF Found THEN
       '* Sorry, calls from {ID not allowed!"
       LineNum = 1131
       CRCount = 1
       GOSUB 49010
       '* CALLER ID NUMBER RESTRICTION"
       LineNum = 1132
       GOSUB 49030
       ZWasLG$(7) = Strng$
       ZLogonErrorIndex = 7
       ZExitCode = 24
       GOTO 10620
    END IF
    LogIndex = 4 - (ZLenIndiv > 0 AND ZStartIndiv > 0)
    ZTurboLogon = (LEFT$(ZUserInAra$(LogIndex),1) = "!")
    SkipWelcomeScreen = (LEFT$(ZUserInAra$(LogIndex),1) = "$")
'
' *****  CHECK IF SAME USER ON ANOTHER NODE   ***
'
410 IF ZExitToDoors THEN
       ZCurDate$ = MID$(ZMsgRec$,119,2) + _
                       "-" + _
                       MID$(ZMsgRec$,121,2) + _
                       "-" + _
                       MID$(ZMsgRec$,123,2)
       ZTime$ = MID$(ZMsgRec$,125,2) + _
              ":" + _
              RIGHT$(ZMsgRec$,2)
       IF LEFT$(ZTime$,2) < "12" THEN
          '* "{SPAM"
          LineNum = 431
       ELSE
          '* "{SPPM"
          LineNum = 430
       END IF
       GOSUB 49030
       ZTime$ = ZTime$ + Strng$
    END IF
    NodeIndex = 2
    WasXX = ZMaxNodes + 1
    WasX$ = LEFT$(ZActiveUserName$+SPACE$(2),30)
412 IF NodeIndex > WasXX THEN
       GOTO 430
    END IF
    GET 1,NodeIndex
    IF INSTR(ZMsgRec$,WasX$) THEN
       GOTO 420
    END IF
    NodeIndex = NodeIndex + 1
    GOTO 412
420 IF MID$(ZMsgRec$,57,1) = "A" THEN
       ZLogonErrorIndex = 6
       ZWasLG$(6) = ZWasLG$(6) + LEFT$(ZMsgRec$,25)
       '* "{C2The name {CE{AN {C2is in use on another node{RC{RI"
       LineNum = 8
       GOSUB 49000
       GOSUB 12976
       ZExitCode = 26
       GOTO 10620
    END IF
    ZFirstName$ = LEFT$(ZMsgRec$,INSTR(ZMsgRec$, SPACE$(1)) - 1)
    IF NOT ZPrivateDoor THEN
       '* "{CR{CF{G1Welcome back {FN!{RC"
       LineNum = 9
       CRCount = 1
       GOSUB 49010
    END IF
    IF ZExitToDoors THEN
       GOTO 457
    END IF
'
' *****  TEST FOR REMOTE SYSOP LOGGING ON   ***
'
430 GET 1,ZNodeRecIndex
    SameUser = (ZActiveUserName$ = LEFT$(ZMsgRec$,LEN(ZActiveUserName$)))
'
' *****  TEST FOR SYSOP NAME ATTEMPT  ***
'
    '* "SYSOP"
    LineNum = 131
    GOSUB 49030
    IF INSTR(ZActiveUserName$,Strng$) THEN
       GOTO 446
    END IF
    TempSecretName$ = ZSecretName$
    IF ZActiveUserName$ = ZSysopFullName$ AND _
       TempSecretName$ <> ZSysopFullName$ THEN
       GOTO 446
    END IF
    IF ZActiveUserName$ = ZSecretName$ THEN
       ZActiveUserName$ = ZSysopFullName$
    END IF
    GOTO 455
446 ZLogonErrorIndex = 2
    ZExitCode = 27
    GOTO 10620
'
' *****  CHECK FOR INVALID CHARACTERS FROM USER NAME  ***
'
455 '* "ABCDEFGHIJKLMNOPQRSTUVWXYZ '-./0123456789"
    LineNum = 265
    GOSUB 49030
    FOR icount = 1 TO LEN(ZActiveUserName$)
       IF INSTR(Strng$,MID$(ZActiveUserName$,icount,1)) = 0 THEN
          ZActiveUserName$ = ""
          GOTO 400
       END IF
    NEXT icount
'
' ****  CHECK FOR ACTIVE USER   ***
'
457 CALL SkipLine (1)
    GOSUB 12840
    GOSUB 12850
    GOSUB 12598
    CALL RegToCurrent
    CALL CompDate (ZTodayRegYY,ZTodayRegMM,ZTodayRegDD,TodayComputeDate!)
    IF NOT Found THEN
       GOTO 700
    END IF
    GOSUB 12984
'
' *****  ACTIVE USER FOUND  ****
'
    GOSUB 9500
    ZLastDateTimeOnSave$ = ZLastDateTimeOn$
    ZMinsInDoors = 0
    IF ZExitToDoors THEN
       TempHoldTime! = VAL(LEFT$(ZTime$,2))*3600! + VAL(MID$(ZTime$,4,2))*60!
       CALL CheckTime(TempHoldTime!, TempTime!, 2)
       ZMinsInDoors = TempTime! / 60
       CALL TimeRemain (MinsRemaining)
    END IF
    ZUserFileIndex = LOC(5)
    GOSUB 5135
'
' ***  COMPUTE THE NUMBER OF DAYS REMAINING UNTIL REGISTRATION EXPIRES **
'
    GOSUB 462
460 UserSecLevel$ = STR$(ZUserSecLevel)
    IF ZUserSecLevel > -1 THEN
       UserSecLevel$ = MID$(UserSecLevel$,2)
    END IF
    IF ZUserSecLevel >= ZMinLogonSec THEN
       GOTO 470
    END IF
    IF (NOT ZExitToDoors) AND (NOT ZSubBoard) THEN
       '* "{CR{CF{G4Sorry, {AN, this is a closed system!{RC"
       LineNum = 1168
       CRCount = 1
       GOSUB 49010
    END IF
    IF NOT ZPrivateDoor THEN
       GOSUB 465
       CALL DelayTime (8 + ZBPS)
    END IF
    IF ZLogonErrorIndex < 9 AND ZErrCode = 0 THEN
       ZLogonErrorIndex = 8
    END IF
    ZExitCode = 30
    GOTO 10620
462 CALL RegistrationCheck (TodayComputeDate!)
    RETURN
'
' ***  DISPLAY LOG-ON MESSAGE FOR SPECIFIC SECURITY LEVEL  **
'
465 ZTurboLogon = ZTurboLogon AND (ZExitToDoors OR _
                  (ZUserSecLevel >= ZAllowCallerTurbo))
    IF (ZCurDate$ <> LEFT$(ZLastDateTimeOn$,8)) AND _
       NOT ZExitToDoors AND ZTurboOnFirstCall = 0 THEN
       ZTurboLogon = ZFalse
       SkipWelcomeScreen = ZFalse
    END IF
    IF ZTurboLogon THEN
       GOSUB 47100
       RETURN
    END IF
    GOSUB 47000
    ZFileName$ = ZWelcomeFileDrvPath$ + _
                 ZNodeId$ + _
                 "LG" + _
                 UserSecLevel$ + _
                 ".DEF"
    CALL FindIt (ZFileName$)
    IF NOT ZOK THEN
       ZFileName$ = ZWelcomeFileDrvPath$ + _
                    "LG" + _
                    UserSecLevel$ + _
                    ".DEF"
    END IF
466 ZBypassTimeCheck = ZTrue
    GOSUB 43025
    RETURN
470 GOSUB 12989
    ZWasCI$ = ZCityState$
    CALL Trim (ZWasCI$)
    ZAttemptsAllowed = 4
    ZPswdSave$ = ZPswd$
    TempSysop = (ZUserSecLevel >= ZSysopSecLevel)
    ZMsgPswd = ZFalse
    IF NOT ZSubBoard THEN
       ZElapsedTimeVal = CVI(ZElapsedTime$)
    END IF
    IF (NOT ZExitToDoors) AND _
       (ZCurDate$ <> LEFT$(ZLastDateTimeOn$,8)) AND _
       (ZElapsedTimeVal > 0 OR NOT ZKeepTimeCredits) THEN
       ZElapsedTimeVal = 0
    END IF
    IF ZPrivateDoor AND ZTransferFunction = 3 THEN
       GOSUB 755
       GOTO 800
    END IF
    IF ZPswdSave$ = SPACE$(LEN(ZPswdSave$)) THEN
       GOSUB 755
       GOTO 800
    END IF
    CALL SetSysOp
    IF ZPrivateDoor OR (ZWasA AND ZEscapeInsecure) OR ZDoorSkipsPswd THEN
       ZWasZ$ = ZPswdSave$
       ZPswdFailed = 0
       GOTO 644
    END IF
    ZSubParm = 4
    CALL PassWrd
    LogonPswdFailed = ZPswdFailed
    ZAnsIndex = LogIndex
    IF NOT LogonPswdFailed THEN _
       GOSUB 41070 : _
       GOTO 644 _
    ELSE IF ZExitToDoors THEN _
            GOTO 644
    GOSUB 12991
    ZFileName$ = ZHelpPath$ + "FORGOT" + ZHelpExtension$
    GOSUB 1790
    '* "{CR{CDForget password?  Leave the Sysop a message?{RC (Y,[N])"
    LineNum = 10
    GOSUB 49000
    GOSUB 12999
    IF ZYes THEN
       '* "FORGOT PASSWORD"
       LineNum = 11
       GOSUB 49030
       OrigSubject$ = Strng$
       GOSUB 1810
    END IF
    ZFirstName$ = ""
    ZExitCode = 29
    GOTO 902
644 ZNewUser = ZFalse
    CALL UnPackDIRDate (ZListNewDate$, WasWK$, "/")
    ZWasLM$ = RIGHT$(WasWK$,2) + _                           ' YY
          LEFT$(WasWK$,2) + _                                ' MM
          MID$(WasWK$,4,2)                                   ' DD
    GOTO 800
670 CALL CheckTrashCan (Found)
    IF Found THEN
       GOSUB 12984
       ZExitCode = 28
       GOTO 10621
    END IF
    RETURN
'
' ****  ACTIVE USER NOT FOUND (NEWUSER ROUTINE)  ***
'
700 ZExpertUser = ZFalse
    CALL SetExpert
    IF ZMinNewCallerBaud! > ZBaudTest! THEN
       '* "Sorry, {MS BPS only for registered users"
       LineNum = 12
       CRCount = 1
       GOSUB 49010
       '* "NEW CALLER BAUD RESTRICTION"
       LineNum = 13
       GOSUB 49030
       ZWasLG$(7) = Strng$
       ZLogonErrorIndex = 7
       ZExitCode = 21
       GOTO 10620
    END IF
    '* "{CR{CF{G2{FN {LN not found!{RC"
    LineNum = 14
    CRCount = 2
    GOSUB 49010
    ZLastIndex = 0
    GOSUB 12558
    IF ZNo THEN
       GOSUB 13700
       Attempts = 0
       ZFF = ZFalse
       GOTO 400
    END IF
    CALL Line25
    ZWasZ$ = ZFirstName$
    GOSUB 670
    ZWasZ$ = ZLastName$
    GOSUB 670
    ZWasZ$ = ZActiveUserName$
    GOSUB 670
    ZTurboLogon = ZFalse
    IF ZUserFileIndex = 0 AND NOT ZSurviveNoUserRoom THEN _
       GOTO 13540
    CALL SetSysOp
    IF ZWasA THEN _
       ZUserSecLevel = ZSysopSecLevel _
    ELSE ZUserSecLevel = ZDefaultSecLevel
    IF ZUserSecLevel < ZMinLogonSec THEN
       ZLogonErrorIndex = 1
       GOTO 460
    END IF
    IF ZFirstName$ = ZLastName$ THEN
       '* "{CF{G4Sorry, First Name and Last Name cannot be the same!{RC"
       LineNum = 15
       CRCount = 1
       GOSUB 49010
       ZLogonErrorIndex = 3
       GOTO 10620
    END IF
    IF NOT ZRememberNewUsers THEN _
       GOSUB 13700 : _
       ZUserFileIndex = 0 : _
       GOSUB 12960 : _
       PrevLastOn$ = "00-00-00" : _
       GOTO 735
    ZNewUser = ZTrue
    ZNewUserDGS = ZTrue
    CALL OpenUser (ZHighestUserRecord)
    GOSUB 9450
    GOSUB 12630
    '* "NEWUSER"
    LineNum = 32
    GOSUB 49030
    MID$(ZUserRecord$,ZStartHash,ZLenHash) = LEFT$(Strng$,ZLenHash)
    IF ZStartIndiv > 0 THEN _
       MID$(ZUserRecord$,ZStartIndiv,ZLenIndiv) = ZIndivValue$
    GOSUB 9440
    GOSUB 12960
735 ZBypassTimeCheck = ZTrue
    GOSUB 758
    '* "{CELogging you as: {CA{AN {CEfrom {CA{CT{G7{RC"
    LineNum = 16
    CRCount = 2
    GOSUB 49010
740 '* "C)hange Name/City and State, D)isconnect, [R]egister"
    LineNum = 17
    GOSUB 49000
    GOSUB 12995
    IF ZWasQ = 0 THEN
       '* "R"
       LineNum = 955
       GOSUB 49030
       ZWasZ$ = Strng$
    ELSE
         ZWasZ$ = UCASE$(ZUserInAra$(1))
    END IF
    '* "CDR"
    LineNum = 956
    GOSUB 49030
    ZWasS = INSTR(Strng$,ZWasZ$)
    IF NOT ZRememberNewUsers THEN _
       ON ZWasS GOTO 748,752,754
    ON ZWasS GOTO 747,750,760
    GOTO 740
747 '* "{AN from {CT changed Name/Address"
    LineNum = 18
    CRCount = 2
    GOSUB 49020
    MID$(ZUserRecord$,ZStartHash,ZLenHash) = STRING$(ZLenHash,0)
    GOSUB 9440
    GOSUB 12991
748 ZFF = ZFalse
    ZLastIndex = 0
    GOTO 400
'
' ***  D - COMMAND FROM NEWUSER ROUTINE (DISCONNECT - REFUSE TO REGISTER) **
'
750 DO
       '* "{CEReally DISCONNECT{RC (Y,[N])"
       LineNum = 19
       GOSUB 49000
       GOSUB 12995
       ZUserIn$ = UCASE$(ZUserIn$)
    LOOP UNTIL ZWasQ = 0 OR INSTR("YN",ZUserIn$) <> 0
    IF ZUserIn$ <> "Y" THEN
       GOTO 740
    END IF
    '* "{AN from {CT didn't register"
    LineNum = 20
    CRCount = 2
    GOSUB 49020
    MID$(ZUserRecord$,ZStartHash,ZLenHash) = STRING$(ZLenHash,0)
    GOSUB 9440
    GOSUB 12991
752 ZFF = ZFalse
    ZUserFileIndex = 0
    GOTO 13540
'
' *****  GET AND VERIFY PASSWORD   ****
'
754 '* "{CR{CBGUEST {C3access granted.  Re-register on next call.{C7"
    LineNum = 21
    CRCount = 1
    GOSUB 49010
    CALL SmartPause(ZTrue)
    ZUserSecSave = ZUserSecLevel
    CALL SetPrivileges
    CALL SetPrompt
    GuestUser = ZTrue
    GOTO 832
755 IF ZPrivateDoor THEN _
       ZUserIn$ = ZPswd$ : _
       ZWasZ$ = ZUserIn$ : _
       RETURN
    GOSUB 12800
    '* "{C2Re-Enter your password for Verification {C7{G0"
    LineNum = 22
    GOSUB 49000
    GOSUB 45010
    SWAP ZWasZ$,ZUserIn$
    ZWasZ$ = UCASE$(ZWasZ$)
    IF ZUserIn$ <> ZWasZ$ THEN
       '* "CF{G4Passwords Don't Match!{RC"
       LineNum = 23
       CRCount = 1
       GOSUB 49010
       GOTO 755
    END IF
    RETURN
758 CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
    CALL Line25
    ZFileName$ = ZNewUserFile$
    ZMorePromptLF = ZFalse
    ZStopInterrupts = ZTrue
    IF ZRIPGraphics THEN
       CALL ResetGraphics
    END IF
    GOSUB 1790
    CALL SkipLine(1)
    RETURN
'
' ***  R - COMMAND FROM NEWUSER ROUTINE - REGISTER   **
'
760 CALL SaveUserActivity("L", ZNodeRecIndex, ZFalse,WasAV)
    ZLastIndex = 0
    ZFileName$ = ZHelpPath$ + "PASSWRD" + ZHelpExtension$
    GOSUB 1790
    GOSUB 755
    ZWasZ$ = UCASE$(ZWasZ$)
    LSET ZPswd$ = ZWasZ$
    '* "{CR{CF{G5Please REMEMBER your password{C7{G0"
    LineNum = 24
    CRCount = 1
    GOSUB 49010
    ZMenuNewUsers = ZMenuNewUsers + 1
    CALL SetNewGR
    ZTempSecLevel = ZUserSecLevel
    CALL Protocol
    ZUserXferDefault$ = ZDefaultNewUserProto$
    CALL XferType (2,ZTrue)
    LSET ZListNewDate$ = CHR$(91) + CHR$(1) + CHR$(1)
    CALL SetToggles
    IF ZNewUserSetsDefaults THEN
       ZBypassTimeCheck = ZTrue
       IF (ZNewUserSelect AND 4096) > 0 THEN
          GOSUB 43000
       END IF
       IF (ZNewUserSelect AND 8192) > 0 THEN
          GOSUB 42800
       END IF
       CALL NewUserToggles
       ZBypassTimeCheck = ZFalse
    END IF
    CALL SetGraphic (ZWasGR)
    CALL SetNewUserDef
    GOSUB 5135
    CALL FindIt(ZWelcomeFileDrvPath$ + "NEWUSER.TXT")
    IF ZOK THEN
       CALL ReadDir (2,1)
       ZMsgFrom$ = ZOutTxt$
       CALL ReadDir (2,1)
       IF NOT EOF(2) THEN
          '* "{CR{CBPlease Wait..."
          LineNum = 1148
          CRCount = 1
          GOSUB 49010
          OrigSubject$ = ZOutTxt$
          ZSubject$ = OrigSubject$
          ZMsgTo$ = ZActiveUserName$
          GOSUB 5344
          QuotedReply = ZFalse
          ZSysopMsg = ZFalse
          GOSUB 1893
          GOTO 2001
       END IF
    END IF
770 CALL DefaultU
790 IF NOT ZNewUser THEN _
       GOTO 800
    ZFileName$ = ZNewUserQuestionnaire$
    GOSUB 11520
    LSET ZSecLevel$ = MKI$(ZUserSecLevel)
    UserSecLevel$ = STR$(ZUserSecLevel)
    CALL Remove (UserSecLevel$,SPACE$(1))
'
' ****  LOGIN ALL USERS  ***
'
800 IF ZAdjustedSecurity THEN _
       GOSUB 5135
    IF ZOrigCnfg$ = ZCurDef$ THEN _
       ZMainUserFileIndex = ZUserFileIndex : _
       ZOrigSec = ZUserSecLevel : _
       OrigFirstName$ = ZFirstName$ : _
       ZOrigUserNameDgs$ = ZActiveUserName$ : _
       ZUserSecSave = ZUserSecLevel : _
       ZOrigUserName$ = ZActiveUserName$
    ZTimesLoggedOn = CVI(MID$(ZUserOption$,1,2)) - _
       ((ZOrigCnfg$ <> ZCurDef$ OR NOT ZSubBoard) AND _
        (NOT ZPrivateDoor) AND (NOT ZExitToDoors))
    DgsAlias$ = ""
    CALL AliasDgs (ZConfName$,ZOrigUserNameDgs$,DgsAlias$)
    IF ZGlobalSysop AND DgsAlias$ = "N" THEN
       ZActiveUserName$ = ZSysopFullName$
    END IF
    GOSUB 9500
    IF ZLocalUser THEN
       '* "9600"
       LineNum = 1002
       GOSUB 49030
       ZCBaud$ = Strng$
    END IF
    IF (NOT ZExitToDoors) AND (NOT ZSubBoard) THEN
       '* "{AN from {CT Lvl {SL {DT {LT"
       LineNum = 25
       CRCount = 2
       GOSUB 49020
       '* "Connect Speed: {BC BPS"
       LineNum = 26
       GOSUB 49020
       '* "Caller Number:"
       LineNum = 27
       GOSUB 49030
       CALL UpdtCalr (Strng$ + STR$(ZCallsToDate!+1),2)
       '* "Graphics Mode: {GR"
       LineNum = 28
       GOSUB 49020
       IF ZCallerIDNumStr$ <> "NONE" AND ZCallerIDNumStr$ <> "" THEN
          '* "Caller ID: {ID"
          LineNum = 1149
          GOSUB 49020
       END IF
    END IF
    PrevLastOn$ = ZLastDateTimeOn$
    IF ZLocalUser THEN
       '* "9600"
       LineNum = 1002
       GOSUB 49030
       ZTalkToModemAt$ = Strng$
       ZModemInitBaud$ = Strng$
       '* "9600 BAUD,N,8,1"
       LineNum = 1003
       GOSUB 49030
       ZBaudParity$ = Strng$
       ZSnoop = ZTrue
       ZLineFeeds = ZTrue
    END IF
    CALL SetCrLf
    CALL SetPrompt
    CALL XferType (2,ZTrue)
    IF NOT ZSubBoard THEN _
       BoardCheckDate$ = PrevLastOn$
    DgsAlias$ = ""
    CALL SetSysOp
    IF ZWasA AND DgsAlias$ = "N" THEN
       ZActiveUserName$ = ZSysopFullName$
       ZFirstName$ = ZSysopFirstName$
    END IF
    IF ZExitToDoors OR ZSubBoard THEN _
       GOTO 815
    CALL ExpiredPswd
    '* "{CR{CCLogging {CE{AN {CCFrom {CE{CT{RC"
    LineNum = 29
    CRCount = 1
    GOSUB 49010
    IF (ZBBSOptions AND 2) > 0 AND ZWasGR > 1 AND NOT ZTurboLogon THEN
       CALL SmartPause (ZTrue)
    END IF
    CALL SaveUserActivity("L", ZNodeRecIndex, ZFalse,WasAV)
'
' * reset graphics if RIP was detected but user
' * does not have RIP graphics as default graphics
'
    IF ZRIPGraphics AND ZWasGR <> 4 THEN
         CALL PutCom (ZRIPGraphicsReset$)
    END IF
    ZMenuNewCalls = ZMenuNewCalls + 1
    IF ZReselectAll THEN
       CALL ReselectAll
       GOTO 805
    END IF
    IF ZReselectGraphics THEN
       CALL ReselectGraphics
    END IF
    IF ZReselectProto THEN
       '* "{CR{C2You must re-select your {CBFile Transfer Protocol!{RC"
       LineNum = 30
       CRCount = 2
       GOSUB 49010
       GOSUB 42800
       ZReselectProto = ZFalse
    END IF
805 GOSUB 465
    IF ZMaxNodes > 1 THEN
       CALL LogNewForChat (ZMaxNodes)
    END IF
    Attempts = 0
    '* "{AN on at {SD, {TM from {CT,{SP"
    LineNum = 31
    GOSUB 49030
    Temp$ = STR$(ZBaudTest!) + MID$(ZBaudParity$,INSTR(ZBaudParity$," B"))
    ZWasZ$ = Strng$ + Temp$
    ZWasNG$ = ZWasZ$ + SPACE$(128 - LEN(ZWasZ$))
'
' *  ALWAYS RECORD THE HASH/INDIVIDUATING FIELD TO EACH RECORD LOGGED OUT
'
    WasX$ = "{" + HashValue$ + "/" + ZIndivValue$ + "}"
    IF LEN(ZWasZ$) < 65 THEN _
       WasX = 65 _
    ELSE WasX = LEN(ZWasZ$) + 2
    MID$(ZWasNG$,WasX) = WasX$
    CALL Printit (SPACE$(2) + ZWasZ$)
    IF ZNewUser THEN
       '* "NEWUSER"
       LineNum = 32
       CRCount = 1
       GOSUB 49020
    END IF
815 CALL SetUserUpDn
    IF ZCurDate$ <> LEFT$(ZLastDateTimeOnSave$,8) THEN  _
       ZDLToday! = 0 : _
       ZBytesToday! = 0
    IF ZExitToDoors THEN _
       ZBankTimeVal = ZTempBankTime
    CALL SetGlobalUpDn
    GOSUB 827
    LSET ZUserOption$ = MKI$(ZTimesLoggedOn) + _
                        MID$(ZUserOption$,3)
    LSET ZLastDateTimeOn$ = ZCurDate$ + _
                              SPACE$(1) + _
                              ZTimeLoggedOn$
    MID$(ZUserRecord$,ZStartHash,ZLenHash) = HashValue$
    IF ZStartIndiv > 0 THEN _
       MID$(ZUserRecord$,ZStartIndiv,ZLenIndiv) = ZIndivValue$
    LSET ZUserName$ = ZOrigUserName$
    IF (NOT ZExitToDoors) AND NOT (ZOrigMsgFile$ = ZActiveMessageFile$ AND ZSubBoard) THEN _
       CALL AutoPage
    IF NOT ZSubBoard THEN _
       ZOrigUserFileIndex = ZUserFileIndex
    IF NOT ZConfMode THEN _
       IF ZOrigDateTimeOn$ = "" THEN _
          ZOrigDateTimeOn$ = ZLastDateTimeOn$ : _
          ZOrigTimeLoggedOn$ = ZTimeLoggedOn$ _
       ELSE ZLastDateTimeOn$ = ZOrigDateTimeOn$ : _
            ZTimeLoggedOn$ = ZOrigTimeLoggedOn$
    GOSUB 9440
    GOSUB 12991
    GOSUB 41000
    CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
    CALL Trim (ZWasCI$)
    IF ZNodeRecIndex > 1 THEN
       GOSUB 4910
       GOSUB 24000
       GET 1,ZNodeRecIndex
       MID$(ZMsgRec$,1,31) = ZActiveUserName$ + _
                                    SPACE$(31 - LEN(ZActiveUserName$))
       MID$(ZMsgRec$,40,2) = " 0"
       MID$(ZMsgRec$,44,2) = RIGHT$(STR$(-ZBPS),2)
       MID$(ZMsgRec$,55,2) = " 0"
       MID$(ZMsgRec$,57,1) = "A"
       MID$(ZMsgRec$,60,5) = ZTalkToModemAt$ + _
                                    SPACE$(5 - LEN(LEFT$(ZTalkToModemAt$,5)))
       MID$(ZMsgRec$,72,2) = " 0"
       MID$(ZMsgRec$,79,5) = ZCBaud$ + SPACE$(5 - LEN(LEFT$(ZCBaud$,5)))
       MID$(ZMsgRec$,93,24) = ZWasCI$ + _
                                     SPACE$(24)
       PUT 1,ZNodeRecIndex
       GOSUB 12985
    END IF
    CALL Line25
    IF NOT ZTurboLogon THEN
       IF SkipWelcomeScreen AND _
          (ZUserSecLevel >= ZAllowCallerTurbo) THEN
          GOTO 818
       END IF
       IF NOT SameUser OR _
          ZCurDate$ <> LEFT$(ZLastDateTimeOnSave$,8) THEN
          CALL DisplayWelcome
          GOSUB 1791
       END IF
       ZBypassTimeCheck = ZFalse
       ZStopInterrupts = ZTrue
818    CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
       IF ZRemindProfile THEN
          GOSUB 5400
          CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
       END IF
    END IF
    IF ZExitToDoors THEN _
       IF ZTransferFunction = 3 THEN _
          ZNewUser = ZTrue : _
          ZTurboLogon = ZFalse : _
          SameUser = ZFalse : _
          ZTransferFunction = 0 : _
          GOTO 832 _
       ELSE GOTO 832
    CALL NewsScan (3,BoardCheckDate$,SameUser,WasZ)
    IF (ZSubBoard AND (ZOrigMsgFile$ = ZActiveMessageFile$)) _
       OR ((ZUserSecLevel > ZMaxRegSec) AND (NOT ZNewUser)) THEN _
       GOTO 832
    ZWasZ$ = ZRegProgram$
    ZWasP$ = ZWasZ$
    ZTransferFunction = 3
    CALL DoorExit (ZFalse)
    ZTransferFunction = 0
    GOTO 832
'
' ****  ESC PRESSED ON LOCAL CONSOLE ENTERS HERE   ***
'
822 LOCATE ZLocalPageLength-1,1,1
    CALL TakeOffHook
    ZLocalUser = ZTrue
    ZSnoop = ZTrue
    ZBPS = -7
    ZCBPS = -7
    CALL CommInfo
    IF ZEscapeInsecure = 0 THEN
       GOTO 345
    END IF
    IF ZEscapeInsecure = 2 THEN
       ZTurboLogon = ZTrue
    END IF
    ZActiveUserName$ = ZSysopFullName$
    ZFirstName$ = ZSysopFirstName$
    ZLastName$ = ZSysopLastName$
    CALL TestANSI
    ZUserLogonTime! = TIMER
    ZTimeLoggedOn$ = TIME$
    ZLinesPrinted = 0
    ZSysop = ZTrue
    GOTO 457
827 IF ZLastMsgRead > ZHighMsgNumber THEN _
       ZLastMsgRead = ZHighMsgNumber : _
    IF ZLastMsgRead < ZLowMsgNumber THEN _
       ZLastMsgRead = ZLowMsgNumber : _
    ZFileWaiting = ZFileWaiting AND _
                   ((ZUserSecLevel >= ZOptSec(6)) AND _
                   (ZUserSecLevel >= ZOptSec(19)))
    CALL DefaultU
    RETURN
832 IF ZTurboLogon OR ZExitToDoors OR ZSubBoard THEN _
       GOTO 834
    IF (NOT ZRememberNewUsers) AND GuestUser THEN
       CALL DisplayWelcome
       GOSUB 1791
    END IF
    CALL RegistrationExpires
834 IF (NOT ZReqQuesAnswered) AND _
       ZReqQues$ <> "" THEN _
         ZFileName$ = ZReqQues$ : _
         GOSUB 11520 : _
         IF ZOK THEN _
            ZReqQuesAnswered = ZTrue
    CALL SetSessionTime
    ZSysop = (ZUserSecLevel >= ZSysopSecLevel)
    GOSUB 12987
    IF ZSubBoard THEN _
       GOTO 850
    GOSUB 12986
    GOSUB 23000
    ZCallsToDate! = ZCallsToDate! + 1 + (ZSysop OR ZHasDoored)
    GOSUB 24000
    GOSUB 12985
850 ZSubParm = 2
    CALL Line25
    IF ZTurboLogon OR ZExitToDoors THEN _
       GOTO 900
    IF NOT ZBulletinsOptional OR ZCheckBulletLogon THEN
       ZStopInterrupts = ZFalse
       ZAnsIndex = 0
       ZBulletinSave$ = ZBulletinMenu$
       GOSUB 9760
       GOTO 851
    END IF
851 IF ZNewUser OR (NOT ZNewFilesCheck) OR ZSkipFilesLogon THEN _
       GOTO 852
    CALL SkipLine (1)
    DO
       '* "{CBCheck for NEW FILES{RC ([Y],N)"
       LineNum = 33
       GOSUB 49000
       GOSUB 12999
       ZUserIn$ = UCASE$(ZUserIn$)
    LOOP UNTIL ZWasQ = 0 OR INSTR("YN",ZUserIn$) <> 0
    IF ZUserIn$ = "N" THEN
       GOTO 852
    END IF
    CALL LoadNew (ZMsgPtr())
    CALL CountNewFiles (ZWasLM$,ZMsgPtr(),LastNew,ListDateSearch$)
    IF LastNew > 0 THEN
       IF ZFMSDirectory$ <> "" THEN
          '* "{CB{TF {CENEW {C2file(s) since last checked!{RC"
          LineNum = 34
          GOSUB 49000
          GOSUB 12977
       ELSE
          GOTO 852
       END IF
    ELSE
       '* "{C2No New Files!{RC"
       LineNum = 35
       GOSUB 49000
       GOSUB 12977
       GOTO 852
    END IF
    IF ZNewUser OR LastNew < 1 OR NOT ZNewFilesCheck THEN _
       GOTO 852
    WasL = LEN(ZDnldDrives$)
    SecNum = 19
    IF (NOT ZSkipFilesLogon) AND _
       ZUserSecLevel >= ZOptSec(SecNum) THEN
       '* "{C6List new files to download?{RC ([Y],N)"
       LineNum = 36
       GOSUB 49000
       GOSUB 12999
       IF NOT ZNo THEN
          ZLastIndex = 2
          ZAnsIndex = 1
          ZWasQ = 2
          ZUserInAra$(2) = ListDateSearch$
          ZWasY$ = ZUserInAra$(3)
          CALL BreakFileName (ZFMSDirectory$,DR$,ZWasY$,WasX$,ZFalse)
          ZUserInAra$(3) = ZWasY$
          TimeLockExempt = ZTrue
          GOSUB 20185
          GOSUB 47000
          ZLastIndex = 0
          TimeLockExempt = ZFalse
       END IF
    END IF
852 ZStopInterrupts = ZFalse
    ZSysop = (ZUserSecLevel >= ZSysopSecLevel)
    IF ZUserSecLevel < ZOptSec (2) OR _
       ZActiveBulletins < 1 OR _
       ZSysop OR _
       SameUser THEN _
          GOTO 900
    IF ZBulletinMenu$ = ZBulletinSave$ THEN _
        GOTO 900
    ZBulletinSave$ = ZBulletinMenu$
    CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
    IF ZBulletinsOptional AND NOT ZNewUser THEN _
       GOTO 856
    ZStopInterrupts = ZTrue
    ZNewUser = ZFalse
    GOSUB 9700
    ZStopInterrupts = ZFalse
    GOTO 900
856 IF NOT ZCheckBulletLogon THEN _
       ZAnsIndex = 0 : _
       GOSUB 9760 : _
       GOTO 900
    '* "{CR{C2Skip the bulletins?{RC (Y,[N])"
    LineNum = 37
    GOSUB 49000
    GOSUB 12999
    IF ZYes THEN _
       GOTO 900
    ZNewUser = ZFalse
    GOSUB 9700
900 ZNewUser = ZFalse
    ActionFlag = (ZLogonMailLevel$ = "S")
    LogonMailNew = (ZLogonMailLevel$ = "N")
    GOSUB 1895
    LogonMailNew = ZFalse
    ZSubParm = 2
    CALL Line25
    ZSection$ = SPACE$(4)
    ZOutTxt$ = ""
    IF (ZSubBoard OR NOT ZConfMode) AND _
       NOT ZTurboLogon AND NOT ZSkipMailCheck AND _
       NOT ZSkipConfCheck THEN _
       MailCheckConfirm = ZTrue : _
       LinkNew = ZTrue : _
       GOSUB 5800
    MailCheckConfirm = ZFalse
    ZWasQQ! = ZMinsInDoors * 60
    ZMinsInDoors = 0
902 IF LogonPswdFailed THEN _
       ZExitToDoors = ZFalse : _
       CALL UpdateU (ZTrue) : _
       ZLogonErrorIndex = 4 : _
       GOTO 10620
    IF ZExitToDoors and ZDooredTo$ <> "" THEN _
       CALL GraphicDisplayFile (ZOutTxtAra$(7))
    ZDoorCarrierDropOK$ = "N"
    ZExitToDoors = ZFalse
    IF ZHomeConf$ = "" THEN _
       GOSUB 2350
    IF NOT ZPrivateDoor THEN _
       GOTO 955
    GOSUB 20165
    CALL SetSection
    ZPrivateDoor = ZFalse
    GOTO 1205
955 IF NOT ZTurboLogon THEN _
       IF NOT ZConfMode THEN _
             GOSUB 4850
    IF NOT ZTurboLogon THEN _
       IF STR$(ZLastMsgRead) < STR$(ZHighMsgNumber) AND _
          ZUserSecLevel => MsgSec THEN _
          GOSUB 4275
    SkipMain = ZFalse
    ZTurboLogon = ZFalse
'
' *                           COMMAND PROCESSING
'
1200 CLOSE 1
     GOSUB 1280
1205 IF ZSubParm < 0 THEN _
        GOTO 202
     ZSubParm = 1
     ZStopInterrupts = ZFalse
     ZExitFromChat = ZFalse
     ZWasQ = 0
     '* "MAIN"
     LineNum = 166
     GOSUB 49030
     IF (NOT ConfMailJoin) AND (ZHomeConf$ = "" OR ZHomeConf$ = Strng$) THEN _
        GOTO 1209
     ZTurboLogon = LinkNext OR (NOT ConfMailJoin)
     ConfMailJoin = ZFalse
     ZFF = 8
     IF ZHomeConf$ = Strng$ THEN
        ZHomeConf$ = "M"
     END IF
     ZUserInAra$(ZAnsIndex) = ZHomeConf$
     IF LinkNext THEN _
        ZUserInAra$(ZAnsIndex + 1) = "R" : _
        ZLastIndex = ZAnsIndex + 1
     ZLastIndex = -ZLastIndex*(ZLastIndex > ZAnsIndex)-ZAnsIndex*(ZLastIndex <= ZAnsIndex)
     ZAnsIndex = ZAnsIndex - 1
     ZHomeConf$ = ""
     ZWasQ = ZLastIndex
     ZStoreParseAt = 1
     ZLastCommand$ = SPACE$(2)
     GOTO 1240
1209 CALL SkipLine (1)
1210 GOSUB 41000
     IF ZHasDoored THEN
        ZHasDoored = ZFalse
        GOSUB 10974
     END IF
     IF ZAnsIndex < ZLastIndex THEN _
        GOTO 1232
     CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
     IF ZExpertUser THEN _
        GOTO 1230
1212 ZLinesPrinted = -((ZDisplayOptions AND 1) > 0) * ZLinesPrinted
     IF ZCustomPUI THEN _
        GOTO 1230
     IF ZSubSection < ZBegFile THEN _
        IF ZUserSecLevel >= ZSysopMenuSecLevel AND ZWasGR <> 4 THEN _
           ZFileName$ = ZMenu$(1) : _
           GOSUB 43025
     CALL ConfMenu
     IF NOT ZOK THEN
        ZFileName$ = ZMenu$(ZMenuIndex)
        ZDeleteInvalid = ZTrue
        ZStopInterrupts = ZTrue
        GOSUB 1790
     ELSE
        GOSUB 1791
     END IF
     ZDeleteInvalid = ZFalse
     ZStopInterrupts = ZFalse
1230 CALL Line25
     IF ZExitFromChat THEN
        ZExitFromChat = ZFalse
        GOTO 1212
     END IF
     IF ZSysopNext THEN
        CALL SysopNextMsg
     END IF
     IF ZLogOffPlease THEN
        CALL LogOffPlease
     END IF
     CALL CBCheck(WillChat)
     IF WillChat THEN
        GOTO 1600
     END IF
     CALL SaveUserActivity("I", ZNodeRecIndex, ZFalse,WasAV)
1232 MID$(ZLastCommand$,2,1) = SPACE$(1)
     IF ZCustomPUI THEN
        CALL UserFace
        GOSUB 12997
        GOTO 1235
     END IF
     IF ZAnsIndex < 2 OR ZLastIndex = 0 OR ZAnsIndex = ZLastIndex THEN
        CALL DispSectionAndTime
        '* "{CF{CP{RC"
        LineNum = 39
        GOSUB 49000
     END IF
     GOSUB 12930
     IF ZWasQ = 0 THEN
        IF (ZDisplayOptions AND 4) THEN
           GOTO 1212
        ELSE
           GOTO 1230
        END IF
     END IF
1235 ZWasZ$ = ZUserInAra$(ZAnsIndex)
     IF ZWasZ$ = SPACE$(LEN(ZWasZ$)) THEN _
        GOTO 1230
     CALL SearchCmd (ZSubSection,ZFF)
     IF ZFF > 0 THEN _
        GOTO 1240
     IF ZWasQ > 0 THEN
        '* "{CAUnknown command {CE<{CB{ZZ{CE>{RC"
        LineNum = 40
        GOSUB 49000
        GOSUB 12979
     END IF
     CALL FlushKeys
     GOTO 1230
1240 IF ZUserSecLevel < ZOptSec(ZFF) THEN _
       ZViolation$ = ZSection$ + _
                     SPACE$(1) + _
                     ZWasZ$ : _
        GOSUB 1380 : _
        GOTO 1205
     ZDirExtension$ = ZMainDirExtension$
     ON ZFF GOSUB _
              1400, _      ' 1  A)nswer questionnaire 1
              9700, _      ' 2  B)ulletins
              1800, _      ' 3  C)omments
              10970, _     ' 4  D)oor (exit to)
              2000, _      ' 5  E)nter a message
              1275, _      ' 6  F)ile system (exit to)
              1760, _      ' 7  I)nitial welcome redisplayed
              5300, _      ' 8  J)oin a conference
              3900, _      ' 9  K)ill a message
              4700, _      '10  O)perator page
              1892, _      '11  P)ersonal mail (look for)
              4330, _      '12  R)ead messages
              4340, _      '13  S)can message headers
              4320, _      '14  T)opic msg scan
              1285, _      '15  U)tilities (exit to)
              5800, _      '16  V)iew a conference
              9800, _      '17  W)ho's on other nodes displayed
             10570, _      '18  G)oodbye
             20160, _      '19  D)ownload
             10570, _      '20  G)oodbye
             20155, _      '21  L)ist
             20185, _      '22  N)ew
             20180, _      '23  P)ersonal files
             20175, _      '24  S)can
             20170, _      '25  U)pload
             20140, _      '26  V)iew ARC Contents
              5500, _      '27  B)ank Time
              9100, _      '28  W)ho Uploaded What
              42850, _     '29  E)cho selection
              42800, _     '30  F)ile transfer protocol
              43000, _     '31  G)raphics
              5200, _      '32  L)ines per page
              10925, _     '33  M)essage margin
              5110, _      '34  P)ersonal Info. Change
              5400, _      '35  R)eview preferences
              4850, _      '36  S)tatistics displayed
              1500, _      '37  T)oggle
              10090, _     '38  U)serlog displayed 12
              30000, _     '39  A)rchive a Library disk 1
              30000, _     '40  C)hange a Library disk
              30000, _     '41  D)ownload Library files
              10570, _     '42  G)oodbye
              30000, _     '43  L)ist a Library directory
              30000, _     '44  S)can a Library disk directory
              20140, _     '45  V)iew arc contents 7
              1325, _      '46  H)elp 1
              1330, _      '47  ?)help
              1250, _      '48  Q)uit
              4240, _      '49  X)expert toggle on/off 4
              10070, _     '50  1) List comments file 1
              10090, _     '51  2) List callers file
              10390, _     '52  3) Recover a message
              10530, _     '53  4) Erase comments
              11000, _     '54  5) User file maintenance
               4130, _     '55  6) Toggle page bell on/off
              10930, _     '56  7) Exit to DOS 2.x or above 7
              10950        '57  8) Sysop FMS Maintenance
     GOTO 1205
'
' ***       NEWS file scan        ***
'
1241 CALL NewsScan (1,BoardCheckDate$,SameUser,WasZ)
     RETURN
'
' ****           QUIT COMMAND (GLOBAL)              ***
'
1250 IF ZExpertUser THEN
        ZOutTxt$ = ZQuitPromptExpert$
     ELSE
        ZOutTxt$ = ZQuitPromptNovice$
     END IF
     IF ZConfName$ = OrigMsgName$ THEN
        IF ZExpertUser THEN
           ZOutTxt$ = MID$(ZOutTxt$,1,5) + MID$(ZOutTxt$,10)
        ELSE
           ZOutTxt$ = MID$(ZOutTxt$,1,5) + MID$(ZOutTxt$,20)
        END IF
        CALL Bracket (ZOutTxt$,INSTR(ZOutTxt$,"M"),INSTR(ZOutTxt$,"M"),"[","]")
        CALL GlobalSrchRepl (ZOutTxt$,")ain","ain",ZFalse)
     END IF
     ZStackC = ZTrue
     GOSUB 12930
     IF ZWasQ = 0 THEN
        IF ZConfName$ = OrigMsgName$ THEN
           ZUserInAra$(ZAnsIndex) = "M"
        ELSE
           ZUserInAra$(ZAnsIndex) = "C"
        END IF
     END IF
     '* "MAIN"
     LineNum = 166
     GOSUB 49030
     ZWasZ$ = ZUserInAra$(ZAnsIndex)
     ZWasZ$ = UCASE$(ZWasZ$)
     IF ZWasZ$ = "C" THEN _
        ZWasZ$ = "M" : _
        GOTO 5323
     IF ZWasZ$ <> SPACE$(LEN(ZWasZ$)) THEN _
        ON INSTR(ZQuitList$,ZWasZ$) GOTO 1275,1280,1285,10570,1283
     GOTO 1250
1275 ZMenuIndex = 3
     GOTO 1295
1280 ZMenuIndex = 2
     GOTO 1295
1283  ZWasQ = 0
      GOTO 1250
1285 ZMenuIndex = 4
1295 ZPrevPui$ = ""
     CALL SetSection
     RETURN
1300 '* "{C2Message base {CE{CN{RC"
     LineNum = 41
     CRCount = 1
     GOSUB 49010
     RETURN
'
' **** COMMON LOCAL DISPLAY PRINT  ***
'
1315 CALL LPrnt(WasD$,1)
     RETURN
'
' ******            HELP (GLOBAL)           ****
'
1325 '* "MAINFILEUTILMAINLIBR"
     LineNum = 1004
     GOSUB 49030
     CALL ViewHelp (ZSubSection, MID$(Strng$,4 * ZMenuIndex - 7,4))
     IF ZSubParm = -1 THEN _
        RETURN 10595
     RETURN
1330 IF ZExpertUser THEN _
        RETURN 1212
     GOTO 1325
'
' *****  RECORD SECURITY VIOLATIONS   ****
'
1380 CALL SecViolation
     IF NOT ZDenyAccess THEN _
        RETURN
1386 CALL DenyAccess
     ZExitCode = 25
     GOTO 10620
1397 '* "{CF{G4Sorry, {FN,{SP"
     LineNum = 42
     GOSUB 49030
     ZOutTxt$ = Strng$ + ZOutTxt$ + ZEmphasizeOff$
     GOTO 12975
'
' ***  A - answer questionnaire
'
1400 WasA1$ = ZAnsMenu$
     ReturnToPrompt = (ZWasQ > 1)
1401 ZStackC = ZTrue
     '* "Which Questionnaires, L)ist"
     LineNum = 43
     GOSUB 49030
     CALL SubMenu (Strng$ + ZPressEnterExpert$, _
        WasA1$,ZQuesPath$,".DEF","",ZTrue,ZFalse,ZTrue,"",WasX,ZTrue)
     IF ZWasQ = 0 THEN _
        RETURN
     IF ZSubParm = -1 THEN _
        RETURN 10595
     QuestHold$ = ZWasZ$
     GOSUB 11520
     CLOSE 2
     '* "{SPquestionnaire{SP"
     LineNum = 1005
     GOSUB 49030
     Strng1$ = Strng$
     '* "answeredaborted"
     LineNum = 1006
     GOSUB 49030
     Strng2$ = Strng$
     CALL UpdtCalr (QuestHold$ + Strng1$ + _
        MID$(Strng2$,1 - 8 * ZQuestAborted,8),2)
     CALL SkipLine (1)
     IF ReturnToPrompt THEN _
        RETURN
     GOTO 1401
'
' *****    Toggle COMMAND (UTILITIES)     ****
'
1500 CALL CmndToggle
     RETURN
'
1600 CALL CBTrueChat (ZMaxNodes)
     GOSUB 5344
     GOTO 1205
'
' ****  I - COMMAND FROM MAIN MENU (DISPLAY INITIAL WELCOME)  ***
'
1760 CALL InitialMenus
     GOTO 1791
1790 CALL GraphicDisplayFile (ZFileName$)
1791 CALL CheckCarrier
     IF ZSubParm = -1 THEN _
        RETURN 10595
     RETURN
'
' ***  C - COMMAND FROM MAIN MENU (LEAVE COMMENT FOR SYSOP)   **
'
1800 '* "COMMENT"
     LineNum = 1007
     GOSUB 49030
     OrigSubject$ = Strng$
1805 '* "MAIN"
     LineNum = 166
     GOSUB 49030
     IF (ZBBSOptions AND 1) = 0 AND ZConfName$ <> Strng$ AND _
         ZCmntsAsMsgs THEN
        '* "Sorry, COMMENTS not allowed in {CN"
        LineNum = 44
        CRCount = 1
        GOSUB 49010
        CALL SmartPause (ZTrue)
        IF GetOut = ZTrue THEN
           GetOut = ZFalse
           RETURN 10571
        ELSE
           RETURN
        END IF
     END IF
1810 ZMsgTo$ = ZSysopFullName$
     ZSubject$ = OrigSubject$
     ZMsgFrom$ = ZActiveUserName$
     GOSUB 1893
     IF (ZActiveMessages >= ZMaxMsgs OR _
        ((NOT ZMsgsCanGrow) AND _
        (ZNextMsgRec + 5 > ZHighestMsgRecord)) OR _
        NOT ZCmntsAsMsgs ) THEN
        '* "{CEWant a Reply?  {C2Use {CDE {C2instead!  {CEReally leave a COMMENT?{RC (Y,[N])"
        LineNum = 45
        GOSUB 49000
        GOSUB 12999
        IF NOT ZYes THEN
           CALL SkipLine (1)
           RETURN
        ELSE
           ZSysopComment = ZTrue
             GOTO 2007
        END IF
     END IF
     ZSysopComment = ZFalse
     ZSysopMsg = ZTrue
     '* "Comment"
     LineNum = 46
     GOSUB 49030
     ZMsgHeader$ = Strng$
     GOTO 2010
1850 WasBX = &H3
     ZWasEN$ = ZCmntsFile$
     GOSUB 12992
     CALL OpenWorkA (2,ZCmntsFile$)
     '* "{FN, Thanks for Your Comments!"
     LineNum = 47
     GOSUB 49000
     GOSUB 12976
     CALL AMorPM
     ' "{SPnode{SP"
     LineNum = 256
     GOSUB 49030
     CALL PrintWorkA (2,ZActiveUserName$ + SPACE$(1) + ZCurDate$ + _
                        SPACE$(1) + ZTime$ + Strng$ + ZNodeID$)
     FOR WasX = 1 TO ZLinesInMsg
        CALL PrintWorkA (2,ZOutTxtAra$(WasX))
     NEXT
     CALL PrintWorkA (2,ZCarriageReturn$)
     CLOSE 2
     IF ZErrCode <> 0 THEN _
        ZWasEL = 1850 : _
        GOTO 13000
     WasBX = &H3
     ZWasEN$ = ZCmntsFile$
     GOSUB 12993
     '* "Left comment"
     LineNum = 48
     CRCount = 1
     GOSUB 49020
     REDIM ZOutTxtAra$(ZMsgDim)
     IF ZLogOff$ = "G" THEN
        GetOut = Ztrue
        ZLogOff$ = "L"
        GOTO 10563
     END IF
     RETURN
'
' ****  P - COMMAND FROM MAIN MENU (DISPLAY PERSONAL MAIL)  ****
'
1892 ActionFlag = ZFalse
     GOTO 1900
1893 ActionFlag = ZTrue
     GOTO 1897
1895 IF ZTurboLogon or ZSkipMailCheck OR ZNonStop THEN _
        RETURN
     CALL SkipLine (1)
     GOSUB 47100
     '* "{CBCheck mail in {CN?{RC ([Y],N)"
     LineNum = 49
     GOSUB 49000
     GOSUB 12930
     IF ZNo THEN _
        SkipMain = ZTrue : _
        RETURN
     '* "NEW{SP"
     LineNum = 1008
     GOSUB 49030
     ZUserInAra$(0) = LEFT$(Strng$,-4*LogonMailNew)
1897 IF ZActiveMessageFile$ = ZPrevBase$ THEN _
        ActionFlag = ZFalse : _
        RETURN
1900 GOSUB 5344
     IF ZPrivateDoor THEN _
        ActionFlag = ZTrue
     ZPrevBase$ = ZActiveMessageFile$
     ShowActive = ZFalse
     IF NOT ActionFlag THEN
        '* "{C9Checking messages in {CB{CN{RC"
        LineNum = 50
        ShowActive = ZTrue
     ELSE
        '* "Loading messages in {CB{CN{RC"
        LineNum = 51
     END IF
     CRCount = 0
     IF NOT ZNewUser THEN
        GOSUB 49010
     END IF
     WasA1$ = ""
     MsgCt = 0
     MsgsFromUser = ZFalse
     ZActiveMessages = 0
     MailReported = ActionFlag
     FirstOld = ZTrue
     GOSUB 23000
     MsgRec = FirstMsgRecord
     ZMaxMsgs = VAL(MID$(ZMsgRec$,89,7))
     NumDots = 0
1905 GET 1,MsgRec
     CALL CheckInt (MID$(ZMsgRec$,117,4))
     IF ZErrCode <> 0 THEN _
        ZWasEL = 1905 : _
        GOTO 13000
     NumRecsInMsg = VAL(MID$(ZMsgRec$,117,4))
     IF NumRecsInMsg < 1 THEN _
        NumRecsInMsg = 1
     IF NOT ZNewUser AND (ActionFlag OR (FirstOld AND NOT MailReported)) THEN _
        CALL MarkTime (NumDots)
     CALL CheckCarrier
     IF ZSubParm = -1 THEN _
        RETURN 10595
     IF MsgRec >= ZNextMsgRec THEN _
        ZLowMsgNumber = ZMsgPtr(1,2) : _
        GOTO 1950
     GOSUB 4660
     IF MID$(ZMsgRec$,116,1) <> ZActiveMessage$ THEN _
        GOTO 1946
     WasX$ = MID$(ZMsgRec$,121,2)
     IF WasX$ <> SPACE$(2) THEN _
        IF CVI(WasX$) > ZUserSecLevel THEN _
           GOTO 1945
     IF ActionFlag THEN _
        GOTO 1935
'
' ** ALLOW USERS WITH NAMES LONGER THAN 22 CHARS TO RECEIVE PRIVATE MAIL *
'
     IF NOT UserInHeader THEN _
        GOTO 1945
     IF MsgToCaller THEN _
        GOTO 1925
     GOTO 1940
1925 ZWasA = VAL(MID$(ZMsgRec$,2,4))
     IF LogonMailNew THEN _
        IF ZWasA <= ZLastMsgRead THEN _
           GOTO 1935
     IF NOT ShowActive THEN _
        GOTO 1930
     MailReported = ZTrue
     FirstNew = (ZWasA > ZLastMsgRead)
     IF FirstNew THEN
        MsgCt = 0
        '* "{CR{CF{G2New mail for you (* = Private){RC"
        LineNum = 52
        CRCount = 1
        GOSUB 49010
     ELSEIF FirstOld THEN
        '* "{CR{CF{G6Old mail for you (* = Private){RC"
        LineNum = 53
        CRCount = 1
        GOSUB 49010
        FirstOld = ZFalse
     END IF
     ShowActive = NOT FirstNew
1930 CALL QuickTPut (ZFG2$ + LEFT$(ZMsgRec$,5) + ZEmphasizeOff$,0)
     MsgCt = MsgCt + 1
     IF MsgCt MOD 15 = 0 THEN _
        CALL SkipLine (1) : _
        CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
1935 IF NOT MsgFromCaller THEN _
        GOTO 1945
1940 MsgsFromUser = MsgsFromUser + 1
     WasA1$ = WasA1$ + LEFT$(ZMsgRec$,5)
1945 ZActiveMessages = ZActiveMessages + 1
     ZMsgPtr(ZActiveMessages,1) = MsgRec
     ZMsgPtr(ZActiveMessages,2) = VAL(MID$(ZMsgRec$,2,4))
1946 MsgRec = MsgRec + NumRecsInMsg
     GOTO 1905
1950 CALL SkipLine (1)
     IF NOT MailReported THEN
        IF LogonMailNew THEN
           '* "{CBSorry, {C2{FN, No {C2NEW {CBmail for you{RC"
           LineNum = 54
        ELSE
           '* "{CBSorry, {C2{FN, No mail for you{RC"
           LineNum = 55
        END IF
        GOSUB 49000
        GOSUB 12975
     END IF
     IF MsgsFromUser = 0 OR NOT ZMsgReminder THEN _
        GOTO 1961
     IF ActionFlag THEN _
        GOTO 1961
     '* "{CF{G5Mail you left:{RC"
     LineNum = 56
     GOSUB 49000
     GOSUB 12976
     WasK = 1
     FOR MsgCt = 1 TO MsgsFromUser
        ZOutTxt$ = ZFG2$ + MID$(WasA1$,WasK,5)
        WasK = WasK + 5
        GOSUB 12978
        IF MsgCt MOD 15 = 0 THEN _
           CALL SkipLine (1) : _
           CALL QuickTPut (ZEmphasizeOff$,0) : _
           CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
     NEXT
     WasA1$ = ""
     CALL SkipLine (1)
     IF ZUserSecLevel >= ZOptSec(9) AND (ZBBSOptions AND 128) > 0 THEN
        '* "{CR{CF{G4Please K)ill your old messages{RC"
        LineNum = 57
        CRCount = 1
        GOSUB 49010
     END IF
1961 IF NOT ActionFlag THEN
        CALL SmartPause (ZFalse)
     END IF
     ActionFlag = ZFalse
     RETURN
'
' ****  E - COMMAND FROM MAIN MENU (ENTER MESSAGE)  ***
'
2000 QuotedReply = ZFalse
     ZMsgFrom$ = ZActiveUserName$
     ZSysopMsg = ZFalse
     GOSUB 1893
2001 IF (ZLowMsgNumber > 0 AND ZActiveMessages >= ZMaxMsgs) _
        OR ZHighMsgNumber >= 9999 THEN
        IF ZActiveMessageFile$ = ZMainMsgFile$ AND _
           ZActiveMessages = 1 THEN
           IF ZNewUser THEN
              GOTO 770
           ELSE
              GOTO 5300
           END IF
        ELSE
           '* "{CF{G4Message base full!  Try again tomorrow{RC"
           LineNum = 58
           GOSUB 49000
           GOSUB 12975
           GOTO 3650
        END IF
     END IF
     IF ZNewUser THEN
        GOTO 2010
     END IF
     IF NOT (ZReply OR ZMsgFwd) THEN _
        MsgPswd$ = ""
     ZSysopComment = ZFalse
     IF ZReply OR ZMsgFwd THEN SaveAnsIndex = ZAnsIndex
     IF ZMsgFwd OR NOT ZReply THEN _
        IF ZUserSecLevel >= ZOptSec(5) THEN ZMsgTo$ = ""
2007 IF ZSysopComment THEN
        ZWasZ$ = ZCmntsFile$
        '* "comment"
        LineNum = 59
     ELSE
        ZWasZ$ = ZActiveMessageFile$
        '* "message"
        LineNum = 60
     END IF
     GOSUB 49030
     ZMsgHeader$ = Strng$
2008 IF ZSysopComment OR ZMsgsCanGrow THEN
        '* "No room on disk for {MH"
        LineNum = 61
        GOSUB 49000
        CALL FindFree
        GOTO 2009
     END IF
     IF ZNextMsgRec + 5 < ZHighestMsgRecord THEN _
        GOTO 2010
     LineNum = 62
     '* "No room in file for {MH"
     ZFreeSpace$ = "1"
2009 IF VAL(ZFreeSpace$) >= 2000 THEN _
        GOTO 2010
     GOSUB 12979
     GOTO 3650
2010 IF NOT QuotedReply THEN _
        ZLinesInMsg = 0 : _
        WasL = 0 : _
        WasX = 0 : _
        REDIM ZOutTxtAra$(ZMsgDim)
     IF ZGetExtDesc THEN _
        GOTO 2100
     GOSUB 1893
     RcvrRecNum = 0
     CALL SoftAlias (MsgFromAlias$)
     GOSUB 12997
     CALL SetWhoTo (-ZEnableCC*(ZUserSecLevel>=ZOptSec(5)),ZMsgTo$,ZMsgFrom$,RcvrRecNum,Found,INSTR(ZMsgSecCats$,"U")>0)
     IF ZMsgTo$ = "" THEN _
        RETURN
     IF ZNewUser THEN
        CALL MsgImport (ZMaxMsgLines,ZRightMargin,ZLinesInMsg,ZOutTxtAra$())
        GOTO 3400
     END IF
     IF ZSysopComment OR ZSysopMsg THEN _
        GOTO 2100
     IF ZNetMailSystem THEN
        DO
           ZUserIn$ = ZNetMailAddr$
           '* "Enter Your Full NetMail Address [{ZU]"
           LineNum = 1134
           GOSUB 49000
           GOSUB 12995
           IF ZUserIn$ = "" THEN
              ZUserIn$ = ZNetMailAddr$
           END IF
           CALL CheckInt (ZUserIn$)
        LOOP UNTIL ZTestedIntValue
        ZFromAddr$ = ZUserIn$
        DO
           CALL FindFidoUser (Found)
           '* "Enter Full Destination NetMail Address [{ZU]"
           LineNum = 1135
           GOSUB 49000
           GOSUB 12995
           IF ZUserIn$ = "" THEN
              ZUserIn$ = ZToAddr$
           END IF
           CALL CheckInt (ZUserIn$)
        LOOP UNTIL ZTestedIntValue
        IF NOT Found THEN
           CALL AddToFidoUser
        END IF
        ZToAddr$ = ZUserIn$
     END IF
     IF ZReply OR ZMsgFwd THEN
        Found = ZTrue
        CALL Trim (ZMsgTo$)
        GOTO 2035
     ELSE
        ZSubject$ = ""
     END IF
     GOSUB 2065
2035 IF QuotedReply THEN _
        RETURN
     GOTO 2100
'
' *****  SET/CHANGE SUBJECT FOR A MESSAGE   ***
'
2065 IF ZSubject$ <> "" THEN
        '* "Change subject to"
        LineNum = 63
     ELSE
        '* "Subject{EX"
        LineNum = 64
     END IF
     GOSUB 49000
     ZMacroMin = 99
     ZParseOff = ZTrue
     GOSUB 12932
     IF LEN(ZUserIn$) > 25 THEN
        '* "Subject must be LESS than 25 Characters!"
        LineNum = 65
        GOSUB 49000
        GOSUB 12979
        GOTO 2065
     END IF
     IF ZWasQ = 0 THEN _
        IF ZSubject$ <> "" THEN _
           RETURN _
        ELSE GOSUB 2435 : _
             IF ZYes THEN _
                RETURN 5160 _
             ELSE GOTO 2065
     IF ZAnsIndex < ZLastIndex THEN
        FOR icount = ZAnsIndex + 1 TO ZLastIndex
           ZUserIn$ = ZUserIn$ + " " + UCASE$(ZUserInAra$(icount))
        NEXT icount
        ZAnsIndex = 0
        ZLastIndex = 0
     END IF
     ZSubject$ = ZUserIn$
     OrigSubject$ = ZSubject$
     RETURN
'
' *****  ENTER MAIN BODY OF MESSAGE  ****
'
2100  IF ZGetExtDesc THEN GOTO 2120
      CALL SaveUserActivity("M", ZNodeRecIndex, ZFalse,WasAV)
      IF NOT ZFullScreenEditor THEN
         GOSUB 43030
         IF NOT ZYes THEN
            ANSIEdActive = ZFalse
            GOTO 2120
         ELSE
            ANSIEdActive = ZTrue
         END IF
      END IF
2110 CALL Ansied (ZMsgTo$, OrigSubject$, MsgLockLines)
     I = ZSubParm
     CALL SkipLine (1)
     IF I = -2 THEN      ' Sleep Disconnect
        GOTO 10590
     ELSEIF I = -1 THEN  ' Lost Carrier
        GOTO 10595
     ELSEIF I = 1 THEN   ' Save Message
        GOTO 3400
     ELSEIF I = 2 THEN   ' Abort Message
        GOTO 2430
     END IF
2120 IF ZGetExtDesc THEN
        '* "FILE_ID.DIZ"
        LineNum = 66
        GOSUB 49030
        CALL FindIt (ZNodeWorkDrvPath$ + Strng$)
        IF ZOK THEN RETURN
        IF ZWasGR > 1 THEN
           '* "{CR{CEUse the {CBFull Screen Editor {CEfor Your{CR{CB{MH{RC"
           LineNum = 67
           CRCount = 0
           GOSUB 49010
           ZOutTxt$ = ZYesPrompt$
           GOSUB 12930
           IF ZNO THEN
              GOTO 2121
           END IF
        END IF
        CALL Ansied (ZRBBSName$, ZMsgHeader$, MsgLockLines)
        I = ZSubParm
        CALL SkipLine (1)
        IF I = -2 THEN      ' Sleep Disconnect
           GOTO 10590
        ELSEIF I = -1 THEN  ' Lost Carrier
           GOTO 10595
        ELSEIF I = 1 THEN   ' Save Message
           GOTO 3400
        ELSEIF I = 2 THEN   ' Abort Message
           GOTO 2430
        END IF
     END IF
2121 MsgParm = 0
2122 CALL LineEditMessage (MsgParm,WasL)
     I = ZSubParm
     CALL SkipLine (1)
     IF I = -2 THEN      ' Sleep Disconnect
        GOTO 10590
     ELSEIF I = -1 THEN  ' Lost Carrier
        GOTO 10595
     ELSEIF I = 1 THEN   ' Save Message
        GOTO 3400
     ELSEIF I = 2 THEN   ' Abort Message
        GOTO 2430
     END IF
'
' *****  SET CURRENT PUI  ****
'
2350 IF ZCurPUI$ = "" OR ZSubBoard THEN _
        ZCurPUI$ = ZMainPUI$
     CALL FindIt (ZCurPUI$)
     ZCustomPUI = ZOK
     IF NOT ZOK THEN _
        ZCurPUI$ = ""
     ZPrevPUI$ = ""
     RETURN
'
' *****  MESSAGE ABORTED  ****
'
2430 '* "{MH Aborted."
     LineNum = 78
     GOSUB 49000
     GOSUB 12975
     GOTO 3650
'
' *****  PROMPT TO ABORT  ****
'
2435 '* "Really Abort Your {MH? (Y,[N])"
     LineNum = 79
     GOSUB 49000
     GOSUB 12930
     RETURN

'
' ****  SAVE MESSAGE   ***
'
3400 IF ZGetExtDesc THEN _
        ZSysopComment = ZFalse : _
        RETURN
     IF ZSysopComment THEN _
        ZSysopComment = ZFalse : _
        GOTO 1850
     IF ZSysopMsg OR ZNewUser THEN
        MsgPswd$ = "^READ^"
     ELSE
        Temp$ = MsgPswd$
        CALL MsgProt (ZMsgTo$,Found,MsgPswd$,ZFalse,FileAttachName$)
        IF MsgPswd$ = "" THEN
           MsgPswd$ = Temp$
           IF ZFullScreenEditor OR ANSIEDActive THEN
              GOTO 2110
           ELSE
              MsgParm = 1
              GOTO 2122
           END IF
        END IF
     END IF
     IF ZAllowFileAttach AND FileAttachName$ <> "" THEN
        ZSubject$ = UCASE$(LEFT$(ZSubject$,25-LEN(FileAttachName$)) + "@" + FileAttachName$)
        OrigSubject$ = ZSubject$
     END IF
     IF ZMsgTo$ = ZActiveUserName$ THEN
        ZMailWaiting = ZTrue
     END IF
     SaveReplyStatus = ZReply
     ZReply = ZTrue
     ZSysopMsg = ZFalse
     ZReply = SaveReplyStatus
     GOSUB 4910
     MsgRecSave$ = ZMsgRec$
     MsgCorrected = ZFalse
     GOSUB 23100
     ZWasSL = 0
     ZWasN$ = ""
     ZLastIndex = 0
     ZHighMsgNumber = ZHighMsgNumber + 1
     ZMenuNewMsgs = ZMenuNewMsgs + 1
     CALL TossLog
     ZActiveMessages = ZActiveMessages + 1
     MsgNum$ = STR$(ZHighMsgNumber) + _
                       SPACE$(5 - LEN(STR$(ZHighMsgNumber)))
     IF MsgPswd$ = "^READ^" THEN _
        MID$(MsgNum$,1,1) = STRING$(1,42) : _
        SecForMsg = ZPrivateReadSec _
     ELSE SecForMsg = ZPublicReadSec
     IF (NOT ZMsgFwd) AND (NOT ZNewUser) THEN _
        ZMsgFrom$ = LEFT$(ZActiveUserName$ + SPACE$(31),31) _
     ELSE _
        ZMsgFrom$ = LEFT$(ZMsgFrom$ + SPACE$(31),31)
     IF MsgFromAlias$ <> "" THEN
        ZMsgFrom$ = LEFT$(MsgFromAlias$ + SPACE$(31),31)
        MsgFromAlias$ = ""
     END IF
     MsgTo$ = ZMsgTo$
     ZMsgTo$ = LEFT$(ZMsgTo$ + SPACE$(31),31)
     MsgTime$ = TIME$
' ***  change time field from : to . for tossers
     IF ZNetMailSystem THEN
        MID$(MsgTime$,6,1) = "."
' *** NoSnail kludge
        IF UCASE$(LEFT$(ZOutTxtAra$(1),3)) = "TO:" THEN
           IF INSTR(ZMsgTo$,"@") = 0 AND INSTR(ZMsgTo$,".") = 0 THEN
              MID$(MsgTime$,6,1) = ":"
           END IF
        END IF
     END IF
     MID$(ZMsgTo$,23,8) = MsgTime$
     MID$(ZMsgTo$,31,1) = CHR$(ZNumHeaders)
     ZSubject$ = LEFT$(OrigSubject$ + SPACE$(25),25)
     MsgPswd$ = LEFT$(MsgPswd$ + SPACE$(15),15)
     IF QuotedReply AND _
        ZLinesInMsg > ZMaxMsgLines THEN _
           ZLinesInMsg = ZMaxMsgLines
     FOR WasJ = 1 TO ZLinesInMsg
        ZOutTxtAra$(WasJ) = ZOutTxtAra$(WasJ) + _
                CHR$(227)
        ZWasSL = ZWasSL + LEN(ZOutTxtAra$(WasJ))
     NEXT
     NumRecs = ZWasSL \ 128 + ZNumHeaders - (ZWasSL MOD 128 <> 0)
     ZWasN$ = STR$(NumRecs)
     Temp = ZNextMsgRec
     ZNextMsgRec = Temp + VAL(ZWasN$)
     LSET ZMsgRec$ = MsgRecSave$
     GOSUB 24000
     GET 1,Temp
     ZMsgPtr(ZActiveMessages,1) = Temp
     ZMsgPtr(ZActiveMessages,2) = ZHighMsgNumber
     LSET ZMsgRec$ = MsgNum$ + _
                     ZMsgFrom$ + _
                     ZMsgTo$ + _
                     ZCurDate$ + _
                     ZSubject$ + _
                     MsgPswd$ + _
                     ZActiveMessage$ + _
                     ZWasN$ + _
                     SPACE$(4 - LEN(ZWasN$)) + _
                     MKI$(SecForMsg)
' ---[ write out list of people msg is to ]---
     UserFileIndexSave = ZUserFileIndex
     UserRecordHold$ = ZUserRecord$
     '* "Mail"
     LineNum = 1009
     GOSUB 49030
     CALL OpenWork (2,ZNodeWorkFile$)
     WHILE NOT EOF(2)
        CALL ReadParms (ZWorkAra$(),2,1)
        MID$(ZMsgRec$,37,22) = LEFT$(ZWorkAra$(1)+ SPACE$(22),22)
        RcvrRecNum = VAL(ZWorkAra$(2))
        PUT 1,Temp
        Temp = Temp + 1
        NumRecs = NumRecs - 1
' ---[ notify receiver that has new mail waiting ]---
        CALL SetUserFlag (RcvrRecNum, 512, Strng$)
     WEND
     ZWasN$ = ""
     IF ZNetMailSystem THEN
        CALL SaveNetMail (MsgTo$)
     END IF
     IF NOT ZNewUser THEN
        '* "Saving Your Message as #"
        LineNum = 92
        GOSUB 49000
        ZOutTxt$ = ZOutTxt$ + STR$(ZHighMsgNumber)
        CALL UpdtCalr (ZOutTxt$,1)
        GOSUB 12978
     END IF
     FOR WasJ = 1 TO ZLinesInMsg
        ZWasN$ = ZWasN$ + _
             ZOutTxtAra$(WasJ)
        IF LEN(ZWasN$) > 127 THEN _
           LSET ZMsgRec$ = ZWasN$ : _
           PUT 1 : _
           ZWasN$ = MID$(ZWasN$,129)
     NEXT
     IF LEN(ZWasN$) > 0 THEN _
        LSET ZMsgRec$ = ZWasN$ : _
        PUT 1
     REDIM ZOutTxtAra$(ZMsgDim)
     IF MsgCorrected THEN _
        MsgCorrected = ZFalse : _
        ActionFlag = ZTrue : _
        CALL SkipLine (1) : _
        GOSUB 1900
     CALL SkipLine (1)
     GET 1,1
     GOSUB 12985
     ZUserFileIndex = UserFileIndexSave
     LSET ZUserRecord$ = UserRecordHold$
3650 ANSIEdActive = ZFalse
     IF ReadMsgs THEN
        RIPFile$ = "RIPWINM.RIP"
        GOSUB 47010
     END IF
     QuotedReply = ZFalse
     MsgLockLines = 0
     CALL KillWork (ZNodeWorkFile$)
     IF ZNewUser THEN
        ZPrevBase$ = ""
        GOTO 770
     END IF
     IF ZReply OR ZMsgFwd THEN _
        ZReply = ZFalse : _
        ZAnsIndex = SaveAnsIndex : _
        GOTO 5344
     IF ZGetExtDesc THEN _
        ZLinesInMsg = 0
     IF ZLogOff$ = "G" THEN
        Getout = Ztrue
        ZLogOff$ = "L"
        GOTO 10560
     END IF
     RETURN
'
' ****  K - COMMAND FROM MAIN MENU (KILL MESSAGE)  ***
'
3900 ZKillMessage = ZFalse
     CALL SkipLine (1)
3930 IF ZMarkedMsgs$ <> "" THEN
        '* "Kill Which Messages, M)arked {EX"
        LineNum = 93
     ELSE
        '* "Kill Which Messages {EX"
        LineNum = 94
     END IF
     GOSUB 49000
     GOSUB 12932
     IF ZWasQ = 0 THEN _
        RETURN
     GOSUB 1893
     ZWasZ$ = ZUserInAra$(ZAnsIndex)
     CALL UnMarkItems (ZMarkedMsgs$,ZAnsIndex,ZLastIndex,Found,ZTrue)
     CALL CheckInt (ZUserInAra$(ZAnsIndex))
     IF ZErrCode <> 0 THEN _
        GOTO 3930
     MsgToKill = ZTestedIntValue
3950 GOSUB 5344
     CALL KillMsg (MsgToKill,ZActiveMessages,ZconfName$,FileAttachName$)
     IF ZKillMessage THEN _
        RETURN
     GOTO 3930
'
' ****  Sysop Available toggle
'
4130  CALL SysopToggles
      RETURN
'
' ****  X)pert Toggle
'
4240 CALL Toggle(9)
     RETURN
'
' **** New Message Read Option
'
4275 IF ZUserSecLevel < ZOptSec(12) THEN _
        RETURN
'
' * IF CONFIG is set to skip new mail and the user doesn't want to
' * read new mail then go back
'
     IF ZSkipMailCheck AND NOT ZReadNewMail THEN
        RETURN
     END IF
     GOSUB 47000
     DO
        '* "{CR{C2Read All New Messages{RC ([A]ll,Y)ours,Q)uit){RC"
        '* "{CR{C2Read All New Messages{RC ([A]ll,Q)uit){RC"
        IF ZMailWaiting THEN
           LineNum = 95
           WasA$ = "AYQ"
        ELSE
           LineNum = 1153
           WasA$ = "AQ"
        END IF
        GOSUB 49000
        GOSUB 12999
        ZUserIn$ = UCASE$(ZUserIn$)
     LOOP UNTIL ZWasQ = 0 OR INSTR(WasA$,ZUserIn$) <> 0
     IF ZUserIn$ = "Q" THEN
        RETURN
     ELSEIF ZWasQ = 0 OR ZUserIn$ = "A" THEN
        ZLastIndex = 2
        ZAnsIndex = 1
        ZWasQ = 2
        ZUserInAra$(2) = "*"
     ELSEIF ZUserIn$ = "Y" THEN
        ZLastIndex = 3
        ZAnsIndex = 1
        ZWasQ = 3
        ZUserInAra$(2) = "M"
        ZUserInAra$(3) = "*"
     END IF
     GOTO 4330
'
' ****  T)opic - QUICK SCAN MESSAGES  ***
'
4320 QuickScanMsgs = ZTrue
     ReadMsgs = ZFalse
     ScanMsgs = ZFalse
     MsgStart = 76
     MsgEnd = 100
     SecIndex= 0
     GOTO 4350
'
' ****  R - COMMAND FROM MAIN MENU (READ MESSAGES)  ****
'
4330 IF LinkNext THEN _
        LinkNext = ZFalse : _
        GOSUB 1893 : _
        GOSUB 5344 : _
        NumMsgsSelected = 1 : _
        ZAnsIndex = 1 : _
        MsgIndex = 1 : _
        ZLastIndex = 1 : _
        CanKill = (ZSysop OR ZUserSecLevel >= ZSecKillAny) : _
        IF LinkForward THEN _
           ZCurMsg = ZLastMsgRead + 1 : _
           GOTO 4450 _
        ELSE ZCurMsg = ZHighMsgNumber : _
             GOTO 4490
     QuickScanMsgs = ZFalse
     ReadMsgs = ZTrue
     Forward = ZFalse
     ZGlobalRead = ZFalse
     HiLiteRec = -1
     ScanMsgs = ZFalse
     MsgStart = 6
     MsgEnd = 100
     IF ZLocalUserMode OR NOT ZLocalUser THEN
        IF ReadMsgIn$ <> ZActiveMessageFile$ THEN
           ReadMsgIn$ = ZActiveMessageFile$
           '* "Read Messages in {CN"
           LineNum = 96
           CRCount = 1
           GOSUB 49020
        END IF
     END IF
     GOSUB 1300
     GOTO 4350
'
' ****  S - COMMAND FROM MAIN MENU (SCAN MESSAGE HEADERS)  ***
'
4340 IF ZWasQ < 2 THEN _
        GOSUB 1300
     ZGlobalRead = ZFalse
     QuickScanMsgs = ZFalse
     ReadMsgs = ZFalse
     ScanMsgs = ZTrue
     MsgStart = 6
     MsgEnd = 100
     SecIndex = 0
'
' ** MESSAGE READ MAINLINE (QUICK SCAN, READ & SCAN) ALL USE THIS ROUTINE *
'
4350 IF (ZBBSOptions AND 256) > 0 THEN
        SuspendTime = ZTrue
        StartTime! = TIMER
     END IF
     SearchHeader$ = ""
     SubInHeader$ = ""
     RIPFile$ = "RIPWINM.RIP"
     GOSUB 47010
4352 ZSearchString$ = ""
     DontPrint = ZFalse
     JustReplied = ZFalse
     QuotedReply = ZFalse
     CanKill = (ZSysop OR ZUserSecLevel >= ZSecKillAny)
     GOSUB 1893
     GOSUB 5344
     ZWasZ$ = ""
     GOSUB 827
     FOR WasI = 2 TO ZLastIndex
        IF INSTR("Ss*",ZUserInAra$(WasI)) > 0 THEN _
           ZUserInAra$(WasI) = MID$(STR$(ZLastMsgRead+1),2) + "+"
        IF INSTR("Ll",ZUserInAra$(WasI)) > 0 THEN _
           ZUserInAra$(WasI) = MID$(STR$(ZHighMsgNumber),2) + "-"
        IF INSTR("Gg",ZUserInAra$(WasI)) > 0 THEN _
           GOSUB 4640
     NEXT
     ZWasLG$(11) = ZWasZ$
     NumMsgsSelected = ZLastIndex
     MsgIndex = ZAnsIndex
     ZLastIndex = 0
     AddressedToUser = ZFalse
     ToRequested = ZFalse
     FromRequested = ZFalse
     LinkNext = ZFalse
     CALL SaveUserActivity("M", ZNodeRecIndex, ZFalse,WasAV)
4370 MsgIndex = MsgIndex  + 1
4371 IF MsgIndex <= NumMsgsSelected THEN _
        IF LEN(ZUserInAra$(MsgIndex)) = 1 AND _
           INSTR("Cc",ZUserInAra$(MsgIndex)) > 0 THEN _
           GOTO 4370 _
        ELSE _
        CALL CheckInt (ZUserInAra$(MsgIndex)) : _
        IF ZErrCode <> 0 THEN _
           ZWasEL = 4371 : _
           GOTO 13000 _
        ELSE ZCurMsg = ZTestedIntValue : _
             ZAnsIndex = MsgIndex : _
             GOTO 4415
4380 AlreadyPrinted = ZFalse
     '* "{CFMsg # {CE{MB{CF-{CE"
     LineNum = 97
     GOSUB 49030
     Strng1$ = Strng$
     IF ZLinkedConf$ = "" OR ZGlobalRead THEN
        '* "{SP(H)lp,S)ince,L)ast"
        LineNum = 98
     ELSE
        '* "{SP(H)lp,S)ince,L)ast,G)lobal"
        LineNum = 99
     END IF
     GOSUB 49030
     Strng2$ = Strng$
     WasA1$ = Strng1$ + _
              MID$(STR$(ZMsgPtr(ZActiveMessages,2)),2) + ZEmphasizeOff$ + _
              Strng2$
     CALL SkipLine (-QuickScanMsgs)
     IF ZGlobalRead THEN
        '* "{C9Display Messages Globally in Linked Conferences.{RC"
        LineNum = 100
        CRCount = 1
        GOSUB 49010
     END IF
     IF AddressedToUser OR ToRequested OR FromRequested THEN
        IF ToRequested AND NOT FromRequested THEN
           '* "{C5Display Messages Only {CETO {C5You.{CR{C2Read what msgs? {CB(? for help)"
            LineNum = 101
        ELSEIF FromRequested AND NOT ToRequested THEN
           '* "{C5Display Messages Only {CEFROM {C5You.{CR{C2Read what msgs? {CB(? for help)"
            LineNum = 102
        ELSE
           '* "{C5Display Messages Only {CETO or FROM {C5You.{CR{C2Read what msgs? {CB(? for help)"
            LineNum = 103
        END IF
        CRCount = 1
        GOSUB 49010
     ELSE
        IF ReadMsgs AND ZMarkedMsgs$ <> "" THEN
           '* ",T)o,F)rom,M)arked"
           LineNum = 104
        ELSE
           '* ",T)o,F)rom,M)ine"
           LineNum = 105
        END IF
        GOSUB 49030
        WasA1$ = WasA1$ + Strng$
     END IF
     IF ZSearchString$ = "" THEN
        '* ", TEXT"
        LineNum = 106
        GOSUB 49030
        WasA1$ = WasA1$ + Strng$
     ELSE
        '* "{C5Include only msgs with text {CB{SS.{CRRead what msgs? {C3(? for help){RC"
        LineNum = 107
        CRCount = 1
        GOSUB 49010
     END IF
4390 '* ", [Q]uit)"
     LineNum = 108
     GOSUB 49030
     ZOutTxt$ = WasA1$ + Strng$
     ZMacroMin = 99
     ZTurboKey = 0
     GOSUB 12932
     IF ZWasQ = 0 THEN
        IF (ZBBSOptions AND 256) > 0 THEN
           GOSUB 48000
        END IF
        ZPswdFailed = ZFalse
        RETURN
     ELSE
        IF (ZBBSOptions AND 256) > 0 THEN
           StartTime! = TIMER
           SuspendTime = ZTrue
        END IF
     END IF
     IF LEN(ZUserInAra$(ZAnsIndex)) = 1 THEN _
        WasY = INSTR("QqHh?",ZUserInAra$(ZAnsIndex)) : _
        IF WasY > 2 THEN _
            ZFileName$ = ZHelpPath$ + "MR" + ZHelpExtension$ : _
            GOSUB 1790 : _
            GOTO 4390 _
        ELSE IF WasY > 0 THEN _
                RETURN
     MsgIndex = 0
     NumMsgsSelected = ZWasQ
     GOTO 4370
4415 Forward = ZFalse
     Reverse = ZFalse
     FOR WasI = ZAnsIndex to ZLastIndex
        IF INSTR("Gg",ZUserInAra$(WasI)) > 0 THEN _
           GOSUB 4640
     NEXT
     IF ZAnsIndex <= ZLastIndex OR LEN(ZUserInAra$(ZAnsIndex)) = 1 THEN _
        IF INSTR("Ss*",ZUserInAra$(ZAnsIndex)) > 0 THEN _
           ZCurMsg = ZLastMsgRead + 1 : _
           Forward = ZTrue : _
           GOTO 4430 _
        ELSE IF INSTR("Ll",ZUserInAra$(ZAnsIndex)) > 0 THEN _
                ZCurMsg = ZHighMsgNumber : _
                Reverse = ZTrue : _
                GOTO 4490 _
        ELSE IF INSTR("Gg",ZUserInAra$(ZAnsIndex)) > 0 THEN _
                ZGlobalRead = ZTrue : _
                GOTO 4370
     IF INSTR("Mm",ZUserInAra$(ZAnsIndex)) = 0 THEN _
        GOTO 4418
     IF ReadMsgs THEN _
        ZWasZ$ = "M" : _
        CALL UnMarkItems (ZMarkedMsgs$,MsgIndex,NumMsgsSelected,Found,ReadMsgs) : _
        MsgIndex = MsgIndex + Found _
     ELSE Found = ZFalse
     AddressedToUser = NOT Found
     GOTO 4370
4418 ZWasA = INSTR("FfTt",ZUserInAra$(ZAnsIndex))
     IF ZWasA > 0 THEN _
        ToRequested = (ZWasA > 2) : _
        FromRequested = (ZWasA < 3) : _
        GOTO 4370
     IF ZCurMsg = 0 THEN _
        IF SearchHeader$ <> "" THEN _
           GOTO 4370 _
        ELSE ZSearchString$ = ZUserInAra$(ZAnsIndex) : _
             SearchCt = 0 : _
             ZSearchString$ = UCASE$(ZSearchString$) : _
             CALL Remove (ZSearchString$,CHR$(34) + CHR$(39)) : _
             SearchHeader$ = ZSearchString$ : _
             SubInHeader$ = SearchHeader$ : _
             GOTO 4370
     CALL SkipLine (-ReadMsgs)
4430 IF RIGHT$(ZUserInAra$(ZAnsIndex),1) = "+" THEN _
        Forward = ZTrue
     IF RIGHT$(ZUserInAra$(ZAnsIndex),1) = "-" THEN _
        Reverse = ZTrue : _
        GOTO 4490
4450 ZMsgDimIndex = 1    ' search FORWARD/EXACT for current msg
4452 IF ZMsgDimIndex > ZActiveMessages THEN _
        GOTO 4515
     IF ReadMsgs AND _
        ZMsgPtr(ZMsgDimIndex,2) = ZCurMsg THEN _
        GOTO 4520
     IF ((ReadMsgs AND Forward) OR _
        QuickScanMsgs OR ScanMsgs) AND _
        ZMsgPtr(ZMsgDimIndex,2) >= ZCurMsg THEN _
        GOTO 4520
     ZMsgDimIndex = ZMsgDimIndex + 1
     GOTO 4452
4490 ZMsgDimIndex = ZActiveMessages  ' search REVERSE for current msg
4492 IF ZMsgDimIndex < 1 THEN _
        GOTO 4515
     IF ZMsgPtr(ZMsgDimIndex,2) <= ZCurMsg THEN _
        GOTO 4540
     ZMsgDimIndex = ZMsgDimIndex - 1
     GOTO 4492
4515 IF Forward THEN
        '* "{CR{CE{G5 No new messages {RC"
        LineNum = 109
        GOSUB 49000
        ZLastMsgRead = ZHighMsgNumber
        ZMailWaiting = ZFalse
     ELSE
        '* "{CE{G5 No such msg #{CM {RC"
        LineNum = 110
        GOSUB 49000
     END IF
     IF SubInHeader$ = "" THEN _
        GOSUB 12979
     ZLastIndex = 0
     GOTO 4637
4520 EndingMsgIndex = ZMsgDimIndex   ' read a single message
     IF ReadMsgs AND NOT Forward THEN _
        GOTO 4560
     StartMsgIndex = ZMsgDimIndex
     EndingMsgIndex = ZActiveMessages
     WasSO = 1
     GOTO 4550
4540 StartMsgIndex = ZMsgDimIndex
     EndingMsgIndex = 1
     WasSO = -1
4550 WasXXX = EndingMsgIndex + WasSO
     ZMsgDimIndex = StartMsgIndex
4552 IF ZMsgDimIndex = WasXXX THEN _    ' top msg read loop end is 4635
        CALL CheckCarrier : _
        GOTO 4637
4560   CurHeader = ZMsgPtr(ZMsgDimIndex,1)
       IF CurHeader < 1 THEN _
          GOTO 4515
       CALL CheckKBStop
       IF ZRet THEN _
         GOTO 4637
       GET 1,CurHeader
       ZPswdFailed = ZFalse
       UserInHeader = ZFalse
       ZWasZ$ = MID$(ZMsgRec$,101,15)
       MsgPswd$ = ZWasZ$
       CALL Trim(MsgPswd$)
       FileAttach = ZFalse
       CanViewAttach = ZFalse
       CanDnldAttach = ZFalse
       FileAttachName$ = ""
       ZSubject$ = UCASE$(MID$(ZMsgRec$,76,25))
       IF ZAllowFileAttach THEN
          Attach = INSTR(ZSubject$,"@")
          IF Attach > 1 THEN
             FileAttachName$ = UCASE$(MID$(ZSubject$,Attach+1))
             CALL Trim (FileAttachName$)
             CALL FindFile (ZFileAttachPath$ + FileAttachName$,FileAttach)
             IF NOT FileAttach THEN
                FileAttachName$ = ""
             ELSE
                ZSubject$ = MID$(ZSubject$,1,Attach-1)
                IF ZUserSecLevel >= ZOptSec(26) THEN
                   CanViewAttach = ZTrue
                END IF
                IF ZUserSecLevel >= ZOptSec(19) THEN
                   CanDnldAttach = ZTrue
                END IF
             END IF
          END IF
       END IF
       OrigSubject$ = LEFT$(ZSubject$ + SPACE$(25),25)
       ZSubject$ = OrigSubject$
       GOSUB 4660
       GOSUB 4655
       IF NOT CanKill THEN _
          IF INSTR(ZMsgRec$,"^READ^") > 0 AND NOT UserInHeader THEN _
             FileAttachName$ = "" : _
             FileAttach = ZFalse : _
             ZPswdFailed = ZTrue : _
             IF Forward OR Reverse THEN _
                GOTO 4635
       ZCurMsg = VAL(MID$(ZMsgRec$,2,4))
       OutRe$ = ZSubject$
       OutFrom$ = MID$(ZMsgRec$,6,31)
       OutTo$ = RTRIM$(MID$(ZMsgRec$,37,22))
       OutNum$ = RTRIM$(MID$(ZMsgRec$,2,4))
       OutDate$ = MID$(ZMsgRec$,68,8) + _
                  SPACE$(1) + _
                  MID$(ZMsgRec$,59,5)
       OutRcvd$ = MID$(ZMsgRec$,123,6)
       IF LEFT$(ZMsgRec$,1) = SPACE$(1) THEN
          '* "Public"
          LineNum = 111
       ELSEIF LEFT$(ZMsgRec$,1) = "*" THEN
          '* "Private"
          LineNum = 112
       ELSE
          '* "Password"
          LineNum = 113
       END IF
       GOSUB 49030
       OutStatus$ = Strng$
       OutNumRecs=val(MID$(ZMsgRec$,117,4))
       IF ToRequested THEN _
          IF NOT MsgToCaller THEN _
             GOTO 4629
       IF FromRequested THEN _
          IF NOT MsgFromCaller THEN _
             GOTO 4629
       IF AddressedToUser AND NOT UserInHeader THEN _
          GOTO 4629
       WasX$ = MID$(ZMsgRec$,121,2)
       IF WasX$ = SPACE$(2) THEN _
          MsgSec = ZMinLogonSec _
       ELSE MsgSec = CVI(WasX$)
       IF ZUserSecLevel < MsgSec THEN _
          GOTO 4629
       IF INSTR(ZMsgRec$,ZWasLG$(11)) = 0 THEN _
          GOTO 4635
       IF MID$(ZMsgRec$,116,1) = ZDeletedMsg$ THEN _
          GOTO 4630
       ZJustSearching = ZFalse
       IF SearchHeader$ <> "" THEN _
          ZFF = INSTR(ZMsgRec$,SearchHeader$) : _
          IF ZFF >= MsgStart AND ZFF <= MsgEnd THEN _
             HiLitePos = ZFF : _
             SearchCt = 0 : _
             GOTO 4582 _
          ELSE IF ReadMsgs AND ZSearchString$ <> "" THEN _
               ZJustSearching = ZTrue : _
                  GOTO 4582 _
               ELSE GOTO 4629
4582   WasPG = ZFalse
       IF MID$(ZWasZ$,1,1) = "!" THEN _
          IF NOT CanKill THEN _
             WasPG = ZTrue : _
             ZPswdSave$ = MID$(ZWasZ$,2) + _
                              SPACE$(1) : _
             ZAttemptsAllowed = 0 : _
             ZSubParm = 1 : _
             CALL PassWrd
       IF ZPswdFailed AND _
          (QuickScanMsgs OR (ScanMsgs AND NOT WasPG)) THEN _
          GOTO 4635
       IF ZPswdFailed THEN
          IF WasPG THEN
             '* "<PASSWORD>"
             LineNum = 114
          ELSE
             '* "<PRIVATE>"
             LineNum = 115
          END IF
          GOSUB 49030
          WasSJ$ = Strng$
       ELSE
          WasSJ$ = ZSubject$
       END IF
       IF QuickScanMsgs THEN
          IF AlreadyPrinted THEN
             CALL WipeLine (79)
             AlreadyPrinted = ZFalse
             PrevTI! = TIMER
             SecIndex = 0
          END IF
          ZOutTxt$ = ZFG2$ + LEFT$(ZMsgRec$,5) + _
               SPACE$(1) + _
               ZFGB$ + LEFT$(WasSJ$,19) + _
               SPACE$(1) + ZEmphasizeOff$
          CALL CheckColor (ZOutTxt$,SubInHeader$,ZEmphasizeOff$)
          GOSUB 12978
          SecIndex = SecIndex + 1
          IF SecIndex = 3 THEN
             SecIndex = 0
             CALL SkipLine (1)
             GOTO 4630
          ELSE
             GOTO 4630
          END IF
       END IF
       IF ScanMsgs THEN
          IF AlreadyPrinted THEN
             CALL WipeLine (79)
             AlreadyPrinted = ZFalse
          END IF
          GOSUB 8020
          PrevTI! = TIMER
          GOTO 4630
       END IF
       IF NOT ZJustSearching THEN _
          GOSUB 8000 : _
          IF QuotedReply THEN _
             QuotedReply = ZFalse : _
             GOTO 4602
       IF ZRet THEN _
          GOTO 4630
       CanChangeSec = (ZUserSecLevel => ZSecChangeMsg)
       ShowKill =  - ((ZUserSecLevel >= ZOptSec(9)) AND (UserInHeader OR CanKill))
       IF ZNewUserDgs = ZTrue THEN ShowKill= ZFalse
       IF ZExpertUser THEN _
          WasA1$ = ",H" + _
                MID$(",R",1,- (ZUserSecLevel >= ZOptSec(5)) * 2) + _
                MID$(",X",1,- ((ZUserSecLevel >= ZOptSec(5)) AND ZCanXPost) * 2) + _
                ",D,T,M,=,+,-" + _
                MID$(",V",1, - (FileAttach AND CanViewAttach) * 2) + _
                MID$(",@",1, - (FileAttach AND CanDnldAttach) * 2) + _
                MID$(",F",1,- (UserInHeader OR CanChangeSec) * 2) + _
                MID$(",K",1, ShowKill * 2) + _
                MID$(",U",1,- (ZUserSecLevel >= ZOptSec(54)) * 2) + _
                MID$(",S",1, - CanChangeSec * 2) + _
                MID$(",P",1, - ZSysop * 2) : _
          GOTO 4601
       GOSUB 4617
4601   IF ZJustSearching OR NOT JustReplied THEN _
          GOTO 4602
       JustReplied = ZFalse
       CALL AskMore (WasA1$,ZTrue,ZFalse,ZAnsIndex,ZFalse)
       CALL SkipLine (1)
       IF ZNo THEN _
          RETURN
       ZUserInAra$(1) = UCASE$(ZUserInAra$(1))
       ZReply = (ZReply OR ZUserInAra$(1) = "R")
       IF ZUserInAra$(1) <> "=" THEN _
          GOTO 4605
       CALL SkipLine (1)
4602   IF NOT ZPswdFailed THEN _
          GOTO 4603
       IF WasPG AND (NOT ZNonStop) THEN _
          ZAttemptsAllowed = 2 : _
          ZSubParm = 2 : _
          CALL PassWrd
       IF ZPswdFailed THEN _
          GOTO 4629
       '* "{SPSubj:{SP{SP"
       LineNum = 116
       GOSUB 49030
       CALL QuickTPut1 (Strng$ + MID$(ZMsgRec$,76,25))
4603   GOSUB 9000
       IF NOT JustReplied AND NOT ZJustSearching THEN
          CALL QuickTPut (ZCrLf$ + ZFG9$ + STRING$(74,45-(151*(ZWasGR>0))) + ZEmphasizeOff$,1)
       END IF
       JustReplied = ZFalse
       DontPrint = ZFalse
       IF ZJustSearching THEN _
          GOTO 4629
       IF ZAnsIndex > NumMsgsSelected THEN _
          GOTO 4650
       CALL SkipLine (1)
       GOSUB 41000
       ZKillMessage = ZFalse
       ZReply = ZFalse
4604   ZTurboKey = -ZTurboKeyUser
       ' * check to see who message is to and prompt to kill if allowed
       IF (ZBBSOptions AND 128) > 0 AND _
          MsgToCaller AND _
          ShowKill THEN
          '* "{COMessage has been received, please K)ill your old messages{RC"
          LineNum = 117
          CRCount = 2
          GOSUB 49010
       END IF
       AlreadyPrinted = ZFalse
       CALL AskMore (WasA1$,ZTrue,ZFalse,WasXX,ZFalse)
       IF ZNo THEN
          IF (ZBBSOptions AND 256) > 0 THEN
             GOSUB 48000
          END IF
          IF WasXX >= 32000 THEN
             WasXX = 0
             ZAnsIndex = ZLastIndex + 1
             RETURN
          ELSE
             GOTO 4637
          END IF
       END IF
       IF ZNonStop THEN _
          GOTO 4629
       CALL AraAllCaps(ZUserInAra$(),1)
       ZReply = (ZReply OR ZUserInAra$(1) = "R")
4605   '* "{SPFUST+-KRH?=MPDX@V"
       LineNum = 1010
       GOSUB 49030
       ON INSTR(Strng$,LEFT$(ZUserInAra$(1),1)) GOTO _
          4620,4606,4607,4608,4609,4610,4610, _
          4611,4621,4612,4614,4615,4652,4651,4653,4654,4657,4658
       GOTO 4620
4606   IF NOT (UserInHeader OR CanChangeSec) THEN _   ' Forward
         GOTO 4620
       ZMsgFwd = ZTrue
       GOTO 4623
4607   IF ZUserSecLevel < ZOptSec(54) THEN _    ' User edit
          GOTO 4620
       EditFromRead = 1
       ZReply=ZTrue
       CALL PutMsgAttr
       TempHashValue$ = ZMsgFrom$
       CALL Trim (TempHashValue$)
       '* "SYSOP"
       LineNum = 131
       GOSUB 49030
       IF TempHashValue$ = Strng$ THEN _
          TempHashValue$ = ZSysopFullName$
       GOTO 11010
4608   IF CanChangeSec THEN _            ' Security to read
          CALL PutMsgAttr : _
          GOSUB 4665 : _
          ZReply = ZFalse : _
          QuotedReply = ZTrue : _
          CALL GetMsgAttr : _
          DontPrint = ZTrue : _
          ZUserIn$ = "=" : _
          JustReplied = ZTrue : _
          GOTO 4560
       GOTO 4620
4609   CALL SetThread (ZCurMsg, OrigSubject$)     ' Thread
       IF ZWasQ > 0 THEN _
          SearchHeader$ = ZUserInAra$(2) : _
          SubInHeader$ = SearchHeader$ : _
          CALL Trim (SubInHeader$) : _
          GOTO 4352
       GOTO 4620
4610   ZWasA = INSTR(" +-",ZUserInAra$(1))      ' +/- read direction
       ZCurMsg = ZCurMsg + 5 - 2 * ZWasA
       Forward = (ZWasA = 2)
       Reverse = (NOT Forward)
       ZSearchString$ = ""
       IF Reverse THEN _
          GOTO 4490 _
       ELSE GOTO 4450
4611   IF ((UserInHeader and NOT ZNewUserDgs) OR CanKill) THEN
          IF ZUserSecLevel >= ZOptSec(9) THEN
             CALL PutMsgAttr
             MsgToKill = ZCurMsg
             Temp = ZWasQ
             GOSUB 3950
             CALL GetMsgAttr
             GOTO 4629
          ELSE
             '* "MORE KILL"
             LineNum = 118
             GOSUB 49030
             ZViolation$ = Strng$
             GOSUB 1380
             GOTO 4629
          END IF
       END IF
       GOTO 4620
4612   ZFileName$ = ZHelp$(7)  ' H - help
       GOSUB 1790
4614   GOSUB 4617
       GOTO 4604
4615   CALL SkipLine (1) ' = read again
       GOTO 4560
4617   '* ",H)lp"
       LineNum = 119
       GOSUB 49030
       WasA1$ = Strng$
       IF ZUserSecLevel >= ZOptSec(5) THEN
          '* ",R)eply"
          LineNum = 120
          GOSUB 49030
          GOSUB 4619
       END IF
       '* ",D)ownload,T)hread,M)ark,=,+,- {CR{SP"
       LineNum = 121
       GOSUB 49030
       GOSUB 4619
       SecondLine = ZCanXPost OR CanViewAttach OR CanDnldAttach OR _
                    CanChangeSec OR ZUserSecLevel > ZOptSec(54) OR _
                    UserInHeader OR ZSysop
       IF ZTimesLoggedOn = 1 OR NOT SecondLine THEN
          CALL Remove (WasA1$,ZCrLf$)
       END IF
       IF SecondLine THEN
          WasA1$ = WasA1$ + SPACE$(4)
       END IF
       IF ZTimesLoggedOn > 1 AND ZCanXPost THEN
          '* "X)post"
          LineNum = 974
          GOSUB 49030
          GOSUB 4619
       END IF
       IF FileAttach AND CanViewAttach THEN
          '* "V)iew Attach"
          LineNum = 1163
          GOSUB 49030
          GOSUB 4619
       END IF
       IF FileAttach AND CanDnldAttach THEN
          '* "@)Download Attach"
          LineNum = 1157
          GOSUB 49030
          GOSUB 4619
       END IF
       IF ZTimesLoggedOn > 1 AND (UserInHeader OR CanChangeSec) THEN
          '* ",F)oward"
          LineNum = 122
          GOSUB 49030
          GOSUB 4619
       END IF
       IF ShowKill THEN
          '* ",K)ill"
          LineNum = 123
          GOSUB 49030
          GOSUB 4619
       END IF
       IF ZUserSecLevel >= ZOptSec(54) THEN
          '* ",U)ser"
          LineNum = 124
          GOSUB 49030
          GOSUB 4619
       END IF
       IF CanChangeSec THEN
          '* ",S)ec"
          LineNum = 125
          GOSUB 49030
          GOSUB 4619
       END IF
       IF ZSysop THEN
          '* ",P)rint"
          LineNum = 126
          GOSUB 49030
          GOSUB 4619
       END IF
       IF RIGHT$(WasA1$,1) = "," THEN
          WasA1$ = LEFT$(WasA1$,LEN(WasA1$)-1)
       END IF
       RETURN
4619   WasA1$ = WasA1$ + Strng$
       IF RIGHT$(WasA1$,1) <> "," AND RIGHT$(WasA1$,1) <> " " THEN
          WasA1$ = WasA1$ + ","
       END IF
       RETURN
4620   IF NOT ZReply THEN _
          GOTO 4629
4621   IF ZUserSecLevel < ZOptSec(5) THEN      ' Reply
          '* "MORE RE"
          LineNum = 127
          GOSUB 49030
          ZViolation$ = Strng$
          GOSUB 1380
          ZReply = ZFalse
          GOTO 4629
       END IF
       '* "(R)"
       LineNum = 128
       GOSUB 49030
       IF LEFT$(OrigSubject$,3) <> Strng$ THEN
          OrigSubject$ = Strng$ + LEFT$(OrigSubject$,22)
       END IF
       ZMsgTo$ = ZMsgFrom$
       CALL Trim (ZMsgTo$)
       ZMsgFrom$ = ZActiveUserName$
       FileAttachName$ = ""
4623   DontPrint = ZFalse
       CALL PutMsgAttr
       IF ZMsgFwd THEN GOTO 4624
       IF ZNoQuoting THEN GOTO 4627
       '* "{RCQuote {MT's message? (Y,[N])"
       LineNum = 129
       GOSUB 49000
       GOSUB 12999
       IF ZRet OR NOT ZYes THEN _
          GOTO 4627
4624   QuotedReply = ZTrue
       ZLinesInMsg = ZLinesInMsg - 1
       IF HiLitedLine > 0 THEN _
          ZOutTxtAra$(HiLitedLine) = ZOutTxtAra$(0) : _
          HiLitedLine = 0
       IF ZMsgFwd THEN _
          TempRightMargin = ZRightMargin _
       ELSE _
          TempRightMargin = ZRightMargin - 3
       CALL WordWrap (TempRightMargin,ZLinesInMsg,ZOutTxtAra$())
       IF ZLinesInMsg > ZMsgDim THEN
          ZLinesInMsg = ZMsgDim
          '* "{C2Original message truncated to {CE199 {C2Lines!{RC"
          LineNum = 130
          CRCount = 1
          GOSUB 49010
       END IF
       IF ZMsgFwd THEN GOTO 4625
       QuoteInit = INSTR(ZMsgTo$, SPACE$(1))
       QuoteInit = QuoteInit + 1
       QuoteMark$ = LEFT$(ZMsgTo$, 1) + _
          MID$(ZMsgTo$, QuoteInit, 1) + "> "
       '* "SYSOP"
       LineNum = 131
       GOSUB 49030
       IF ZMsgTo$ = Strng$ THEN
          QuoteMark$ = LEFT$(ZSysopFirstName$, 1) + _
                       LEFT$(ZSysopLastName$, 1) + "> "
       END IF
       FOR WasX = 1 TO ZLinesInMsg
          IF MID$(ZOutTxtAra$(WasX), 3, 2) = "> " THEN _
             ZOutTxtAra$(WasX) = ZOutTxtAra$(WasX) _
          ELSE ZOutTxtAra$(WasX) = QuoteMark$ + ZOutTxtAra$(WasX)
       NEXT
4625   WasX$ = ZMsgTo$
       GOSUB 2001
       IF (ZActiveMessages >= ZMaxMsgs) OR ZMsgTo$ = "" THEN _
          GOTO 4628
       IF ZMsgFwd THEN
          MsgFwd$ = ZActiveUserName$
          CALL Trim (MsgFwd$)
          CALL Trim (WasX$)
          '* "Msg was to{SP"
          LineNum = 132
          GOSUB 49030
          Strng1$ = Strng$
          '* ", forwarded by{SP"
          LineNum = 133
          GOSUB 49030
          MsgFwd$ = Strng1$ + WasX$ + Strng$ + MsgFwd$
       END IF
       IF (ZMsgFwd AND CanChangeSec AND NOT MsgFromCaller) THEN
          CALL Trim (ZMsgFrom$)
          '* "{RCMessage was from {MF, change to {AN? (Y,[N])"
          LineNum = 134
          GOSUB 49000
          GOSUB 12999
          IF ZYes THEN
             ZMsgFrom$ = ZActiveUserName$
             CALL Trim (ZMsgFrom$)
             GOTO 4626
          END IF
       END IF
       IF ZMsgFwd AND NOT MsgFromCaller THEN _
          FOR MsgFwdCount = ZLinesInMsg TO 1 STEP -1 : _
             ZOutTxtAra$(MsgFwdCount + 2) = ZOutTxtAra$(MsgFwdCount) : _
          NEXT MsgFwdCount : _
          ZOutTxtAra$(1) = MsgFwd$ : _
          ZOutTxtAra$(2) = "" : _
          ZLinesInMsg = ZLinesInMsg + 2 : _
          IF NOT CanChangeSec THEN _
             MsgLockLines = 1
4626   ZWasZ$ = "L"
       WasL = 1
       IF ZFullScreenEditor OR ANSIEdActive THEN
          GOSUB 2110
          GOTO 4628
       ELSE
          GOSUB 43030
          IF ZYes THEN
             ANSIEdActive = ZTrue
             GOSUB 2110
          ELSE
             ANSIEdActive = ZFalse
             IF ZLinesInMsg >= ZMaxMsgLines THEN
                '* "{C5Message must be less than {CE{LM {C5lines!{RC"
                LineNum = 135
                CRCount = 1
                GOSUB 49010
             END IF
             IF NOT ZMsgFwd THEN
                '* "{CEPlease delete unneeded quoted lines, then {CB[C] {CEcontunues reply{RC"
                LineNum = 136
                CRCount = 1
                GOSUB 49010
             END IF
             ZOutTxt$ = "[" + STRING$(ZRightMargin - 2,45) + "]"
             IF ZRemoteEcho OR ZLocalUser THEN _
                ZOutTxt$ = SPACE$(4) + _
                     ZOutTxt$
             GOSUB 12975
             IF ZGetExtDesc THEN WasL = 1
             FOR WasX = WasL TO ZLinesInMsg
                CALL AskMore ("",ZTrue,ZTrue,WasXX,ZFalse)
                IF ZNo OR ZRet THEN _
                   WasX = ZLinesInMsg + 1 _
                ELSE ZOutTxt$ = RIGHT$(STR$(WasX),3) + _
                          ": " + _
                          ZOutTxtAra$(WasX) : _
                     GOSUB 12979
             NEXT
             MsgParm = 1
             GOSUB 2122
          END IF
       END IF
       GOTO 4628
4627   GOSUB 2000
4628   ZReply = ZFalse
       JustReplied = ZTrue
       QuotedReply = ZTrue
       CALL GetMsgAttr
       DontPrint = ZTrue
       ZUserIn$ = "="
       QuotedReply = ZTrue
       ZMsgFwd = ZFalse
       GOTO 4560
4629   QuotedReply = ZFalse
       JustReplied = ZFalse
       IF NOT Forward AND NOT Reverse THEN _
          GOTO 4370
4630   '* ",M)ark, #(s) to read"
       LineNum = 137
       GOSUB 49030
       MsgTemp$ = Strng$
       CALL AskMore (MsgTemp$,ZTrue,ZTrue,WasXX,ZFalse)
       IF ZMsgDimIndex = EndingMsgIndex AND NOT ReadMsgs THEN
          CALL WipeLine (79)
          CALL SkipLine (-QuickScanMsgs)
          AlreadyPrinted = ZTrue
          PrevTI! = TIMER
          CALL AskMore (MsgTemp$,ZTrue,ZFalse,WasXX,ZFalse)
          IF UCASE$(ZUserInAra$(1)) <> "M" THEN
             '* "{CCScanning Messages{RC"
             LineNum = 138
             CRCount = 0
             GOSUB 49010
          END IF
       END IF
       IF ZJustSearching OR AddressedToUser OR ToRequested OR FromRequested THEN
          TimeNow! = TIMER
          IF TimeNow! - PrevTI! > 1 THEN
             IF NOT AlreadyPrinted THEN
                CALL WipeLine (79)
                '* "{CESearching {CF{G1(<Ctrl-X> aborts){RC"
                LineNum = 967
                CRCount = 0
                GOSUB 49010
                AlreadyPrinted = ZTrue
                PrevTI! = TIMER
                NumDots = 0
             END IF
             CALL MarkTime (NumDots)
          END IF
       END IF
       IF ZWasQ = 0 OR ZYes THEN _
          GOTO 4631
       IF ZNo THEN _
          RETURN
       IF ZSubParm = -1 THEN _
          RETURN 10595
       IF ZRet THEN _
          RETURN
       ZWasZ$ = UCASE$(ZUserInAra$(1))
       IF ZWasZ$ = "M" THEN
          ZLastIndex = ZWasQ
          ZAnsIndex = 1
          '* "msg"
          LineNum = 1011
          GOSUB 49030
          CALL AskItems ("M",ZWasZ$,ZTrue,Strng$,ZMarkedMsgs$)
       END IF
       IF VAL(ZWasZ$) > 0 THEN _
          FOR WasI = ZWasQ TO 1 STEP -1 : _
             ZUserInAra$(WasI + 1) = ZUserInAra$(WasI) : _
          NEXT : _
          ZUserInAra$(1) = MID$(ZAllOpts$,INSTR(ZOrigCommands$,"R"),1) : _
          ZLastIndex = ZWasQ + 1 : _
          ZAnsIndex = 1 : _
          RETURN 1235
4631   IF NOT Forward AND NOT Reverse THEN _
          GOTO 4370
       CALL CheckCarrier
       IF ZSubParm THEN _
          RETURN 10595
       IF ZRet THEN _
          RETURN
4635 IF WasSO = 0 THEN _      ' end msg read loop top is 4552
        WasSO = 1
     IF ZSearchString$ <> "" THEN
        SearchCt = SearchCt + 1
        IF SearchCt > 99 THEN
           SearchCt = 0
           AlreadyPrinted = ZFalse
           IF ScanMsgs OR QuickScanMsgs THEN
              CALL WipeLine (79)
           END IF
           '* "{CRSearched for {SS thru msg {CM. Continue? ([Y],N)"
           LineNum = 139
           GOSUB 49000
           GOSUB 12932
           IF ZNo THEN
              RETURN
           END IF
        END IF
     END IF
     ZMsgDimIndex = ZMsgDimIndex + WasSO
     GOTO 4552
4637 ZLastIndex = 0
     CALL SkipLine (1)
     IF Forward OR Reverse THEN
        CALL NextConf (ZGlobalRead)
        IF ZHomeConf$ <> "" THEN
           LinkNext = ZTrue
           LinkForward = Forward
           ConfMailJoin = ZTrue
           RETURN 1205
        END IF
     END IF
     IF ReadMsgs THEN
        FileAttachName$ = ""
        FileAttach = ZFalse
        ZPswdFailed = ZFalse
        ZSearchString$ = ""
        SearchHeader$ = ""
        SubInHeader$ = ""
        ToRequested = ZFalse
        FromRequested = ZFalse
        AddressedToUser = ZFalse
        GOTO 4370
     END IF
     RETURN
4640 FOR WasJ = WasI to ZLastIndex-1
        ZUserInAra$(WasJ) = ZUserInAra$(WasJ+1)
     NEXT
     ZGlobalRead = ZTrue
     ZLastIndex = ZLastIndex - 1
     RETURN
4650 CALL AskMore ("",ZTrue,ZTrue,WasX,ZTrue)
     GOTO 4380
4651 '****     print current message        ****
     CALL PrintMsg(OutNum$,OutFrom$,OutTo$,OutRe$,OutDate$,OutRcvd$,OutStatus$,OutRec,OutNumRecs,ZFalse,ZFalse,MsgLockLines)
     GOTO 4604
4652 '****     mark current message         ****
     ZMarkedMsgs$ = ZMarkedMsgs$ + STR$(ZCurMsg) + ZCarriageReturn$
     '* "msg"
     LineNum = 1011
     GOSUB 49030
     CALL ReportMarked (ZMarkedMsgs$,Strng$)
     GOTO 4604
4653 '****     download current message     ****
     CALL PrintMsg(OutNum$,OutFrom$,OutTo$,OutRe$,OutDate$,OutRcvd$,OutStatus$,OutRec,OutNumRecs,ZTrue,ZFalse,MsgLockLines)
     GOTO 4604
4654 '****     crosspost current message    ****
     IF ZCanXPost THEN
        CALL PrintMsg(OutNum$,OutFrom$,OutTo$,OutRe$,OutDate$,OutRcvd$,OutStatus$,OutRec,OutNumRecs,ZFalse,ZTrue,MsgLockLines)
     END IF
     GOTO 4604
4655 '****     update last message read     ****
     IF SearchHeader$ <> "" OR ZSearchString$ <> "" OR NOT ReadMsgs THEN _
        RETURN
4656 IF ZMsgPtr(ZMsgDimIndex,2) > ZLastMsgRead THEN _
        ZMailWaiting = ZFalse : _
        ZLastMsgRead = ZMsgPtr(ZMsgDimIndex,2)
     RETURN
4657 '****     download current File Attach ****
     IF FileAttach AND CanDnldAttach THEN
        CALL DownloadFileAttach (FileAttachName$)
     END IF
     GOTO 4604
4658 '****         view current File Attach ****
     IF FileAttach AND CanViewAttach THEN
        CALL ViewFileAttach (ZFileAttachPath$ + FileAttachName$)
     END IF
     GOTO 4604

4660 ZNumHeaders = ASC(MID$(ZMsgRec$,67,1))
     FirstActive = 0
     IF ZNumHeaders < 1 THEN _
        ZNumHeaders = 1
     CurrHeaderRecNum = LOC(1)
     WasI = 1
4661 WasY = (ASC(MID$(ZMsgRec$,116,1)) = 225)
     IF FirstActive = 0 THEN _
        IF WasY THEN _
           FirstActive = LOC(1)
     GOSUB 4662
     GET 1
     CALL ChkIfMsgHeader
     IF NOT ZOK THEN _
        ZNumHeaders = WasI
     IF MsgToCaller AND (WasY OR (ZUserSecLevel < ZSecKillAny)) THEN _
        CurrHeaderRecNum = LOC(1) - 1 _
     ELSE WasI = WasI + 1 : _
          IF WasI <= ZNumHeaders THEN _
              GOTO 4661 _
          ELSE IF FirstActive > 0 THEN _
                  CurrHeaderRecNum = FirstActive
     GET 1, CurrHeaderRecNum
     UserInHeader = (MsgFromCaller OR MsgToCaller)
     RETURN
4662 CALL ChkMsgName (MsgFromCaller,MsgToCaller)
     RETURN
'
' ****  S - CHANGE MESSAGE SECURITY   ***
'
4665 CALL Trim (ZMsgFrom$)
     '* "{RCChange sender's name from {MF to {EX"
     LineNum = 140
     GOSUB 49000
     GOSUB 12995
     IF ZWasQ = 0 THEN _
        GOTO 4666
     IF LEN(ZUserIn$) > 30 THEN
        '* "{CF{G430 Chars max{RC"
        LineNum = 141
        CRCount = 1
        GOSUB 49010
        GOTO 4665
     END IF
     ZUserIn$ = UCASE$(ZUserIn$)
     ZMsgFrom$ = ZUserIn$
4666 CALL Trim (ZMsgTo$)
     '* "{RCChange receiver's name from {MT to {EX"
     LineNum = 142
     GOSUB 49000
     GOSUB 12995
     IF ZWasQ = 0 THEN _
        GOTO 4667
     IF LEN(ZUserIn$) > 30 THEN
        '* "{CF{G430 Chars max{RC"
        LineNum = 141
        CRCount = 1
        GOSUB 49010
        GOTO 4666
     END IF
     ZUserIn$ = UCASE$(ZUserIn$)
     ZMsgTo$ = ZUserIn$
     TempMsgTo$ = ZUserIn$
     CALL SetWhoTo (ZFalse,ZMsgTo$,ZMsgFrom$,RcvrRecNum,Found,ZTrue)
     IF ZMsgTo$ = "" THEN ZMsgTo$ = TempMsgTo$
4667 CALL Trim (ZSubject$)
     '* "{RCChange subject from {SM to {EX"
     LineNum = 143
     GOSUB 49000
     GOSUB 12995
     IF ZWasQ = 0 THEN _
        GOTO 4668
     IF LEN(ZUserIn$) > 25 THEN
        '* "{CF{G425 Chars max{RC"
        LineNum = 144
        CRCount = 1
        GOSUB 49010
        GOTO 4667
     END IF
     ZUserIn$ = UCASE$(ZUserIn$)
     ZSubject$ = ZUserIn$
4668 '* "{RCminimum security to read {EX"
     LineNum = 145
     GOSUB 49030
     CALL ChangeInt (ZTrue,Strng$,MsgSec,-32000,ZSysopSecLevel)
     IF ZWasQ <> 0 THEN _
        MsgSec = ZTestedIntValue
     ZReply = ZTrue
     CALL MsgProt (ZMsgTo$,Found,MsgPswd$,ZTrue,"")
     ZReply = ZFalse
     ZMsgTo$ = LEFT$(ZMsgTo$ + SPACE$(22),22)
     ZMsgFrom$ = LEFT$(ZMsgFrom$ + SPACE$(31),31)
     ZSubject$ = LEFT$(ZSubject$ + SPACE$(25),25)
     MsgPswd$ = LEFT$(MsgPswd$ + SPACE$(15),15)
     ZSubParm = 3
     CALL FileLock
     GET 1,CurHeader
     MID$(ZMsgRec$,37,22) = ZMsgTo$
     MID$(ZMsgRec$,6,31) = ZMsgFrom$
     MID$(ZMsgRec$,76,25) = ZSubject$
     MID$(ZMsgRec$,121,2) = MKI$(MsgSec)
     MID$(ZMsgRec$,101,15) = MsgPswd$
     IF LEFT$(MsgPswd$,6) = "^READ^" THEN _
        MID$(ZMsgRec$,1,1) = STRING$(1,42) _
     ELSE _
        MID$(ZMsgRec$,1,1) = SPACE$(1)
     PUT 1,CurHeader
     ZSubParm = 4
     CALL FileLock
     '* "{CF{G2Message header changed{RC{CR"
     LineNum = 146
     CRCount = 1
     GOSUB 49010
     RETURN
'
' ****  O - COMMAND FROM MAIN MENU (OPERATOR PAGE)   ***
'
4700 CALL InitSysopChat
     IF ZSubParm < 0 THEN _
        GOTO 202
     '* "PG!"
     LineNum = 1012
     GOSUB 49030
     IF ZPageStatus$ <> Strng$ THEN
        RETURN
     END IF
     '* "{RCLeave {SF a message? (Y,[N])"
     LineNum = 147
     GOSUB 49030
     IF Strng$ = "" THEN
        RETURN
     END IF
     ZOutTxt$ = Strng$
     GOSUB 12999
     IF NOT ZYes THEN _
        RETURN
     CALL SkipLine (1)
     '* "While You Were Gone"
     LineNum = 148
     GOSUB 49030
     OrigSubject$ = Strng$
     GOSUB 1805
     RETURN
'
' ****  S - COMMAND FROM UTILITY MENU (STATISTICS)  ***
'
4850 CALL ShowStatistics
     RETURN
4900 '* "Entered {CN"
     LineNum = 149
     CRCount = 3
     GOSUB 49020
     '* "{CR{CF{G1Welcome to {CE{CN{RC"
     LineNum = 150
     CRCount = 1
     GOSUB 49010
     IF NOT ZTurboLogon THEN _
        GOSUB 1790
4910 GOSUB 12986
     GOSUB 5344
     IF LOF(1) = 0 THEN _
        ZWasDFF$ = ZActiveMessageFile$ : _
        CLOSE 1 : _
        KILL ZActiveMessageFile$ : _
        GOSUB 12987 : _
        RETURN 13600
     GOSUB 23000
     RETURN
'
' P - COMMAND FROM UTILITY MENU (CITY/STATE / PASSWORD CHANGE)  ***
'
5110 '* "City and State now {CT"
     LineNum = 151
     CRCount = 1
     GOSUB 49010
     '* "Enter new{SP"
     LineNum = 152
     GOSUB 49030
     WasA1$ = Strng$
     ZMacroMin = 99
     ZParseOff = ZTrue
     GOSUB 12960
     '* "{C2Enter new password{RC{EX"
     LineNum = 153
     GOSUB 49030
     CALL NewPassword (Strng$,ZTrue)
     IF ZSubParm < 0 THEN _
        GOTO 202
     IF ZWasQ = 0 THEN _
        RETURN
     '* "Re-enter new password"
     LineNum = 154
     GOSUB 49000
     GOSUB 45010
     IF ZWasQ = 0 THEN _
        RETURN
     ZUserIn$ = UCASE$(ZUserIn$)
     IF ZWasZ$ <> ZUserIn$ THEN
        '* "Passwords don't match!"
        LineNum = 155
        GOSUB 49000
        GOSUB 12979
        RETURN
     END IF
     IF ZMaxPswdChanges AND _
        ChangeThisSession > ZMaxPswdChanges AND _
        NOT ZSysop THEN
        '* "No changes permitted"
        LineNum = 156
        GOSUB 49000
        GOSUB 12975
        RETURN
     ELSE
        CALL SrchPasswrds (Found)
        IF NOT Found THEN
           GOTO 5129
        ELSE
           '* "Temporary change"
           LineNum = 157
           GOSUB 49000
           GOSUB 12975
           ZPswd$ = ZTempPassword$
           ZSecsPerSession! = ZTempTimeAllowed * 60
           ZUserSecLevel = ZTempSecLevel
           GOSUB 41070
           ZSysop = (ZUserSecLevel >= ZSysopSecLevel)
           CALL SetPrompt
           CALL XferType (2,ZTrue)
        END IF
     END IF
     '* "SYSOP"
     LineNum = 131
     GOSUB 49030
     IF ZActiveUserName$ = Strng$ OR ZActiveUserName$ = ZSysopFullName$ THEN
        ZUserInAra$(1) = STRING$(8,42)
     END IF
     '* "Used temp password {ZU"
     LineNum = 158
     CRCount = 2
     GOSUB 49020
     RETURN
5129 IF ZOrigUserFile$ <> ZActiveUserFile$ THEN
        '* "{CEPlease Quit Conference to change personal info{RC"
        LineNum = 159
        CRCount = 1
        GOSUB 49010
        RETURN
     END IF
     GOSUB 12989
     CALL OpenUser (ZHighestUserRecord)
     GOSUB 9450
     IF ZUserFileIndex < 1 OR _
        ZUserFileIndex > 32767 THEN _
        GOTO 5160
     GET 5,ZUserFileIndex
     ZUserIn$ = UCASE$(ZUserIn$)
     LSET ZPswd$ = ZUserIn$
     GOSUB 9440
     GOSUB 12991
     '* "Password changed"
     LineNum = 160
     GOSUB 49000
     ZStopInterrupts = ZTrue
     GOSUB 12975
     IF ZMaxPswdChanges THEN _
        ChangeThisSession = ChangeThisSession + 1
     '* "New Password {Z1"
     LineNum = 161
     GOSUB 49020
     RETURN
'
' ****  SEARCH "PASSWORDS" FILE FOR TEMPORARY PASSWORDS  ***
'
5135 CALL SetPrivileges
5160 ZErrCode = 0
     RETURN
5200 Call LinesPerPage
     RETURN
5280 CALL BreakFileName (ZActiveMsgFile$,UserDrvPath$,ZWasDFF$,ZWasY$,ZTrue)
     WasX$ = UserDrvPath$ + _
             ZConfName$ + _
             "U.DEF"
     CALL FindIt (WasX$)
     IF NOT ZOK THEN _
        CALL BreakFileName (ZActiveUserFile$,UserDrvPath$,ZWasDFF$,ZWasY$,ZTrue) : _
        WasX$ = UserDrvPath$ + _
                ZConfName$ + _
                "U.DEF"
     RETURN
5290 CALL NextConf (ZTrue)
     IF ZHomeConf$ <> "" THEN _
        ConfMailJoin = ZTrue : _
        RETURN 1205
     IF ZLinkedConf$ = "" THEN
        '* "{CR{CF{G1No conferences Found to Join{RC"
        LineNum = 162
        CRCount = 2
        GOSUB 49010
     END IF
     GOTO 5301
5292 LinkNew = ZTrue
5293 GOSUB 5800
     GOTO 5290
5294 LinkPers = ZTrue
     GOTO 5293
5296 IF ZSubBoard THEN _
        GOSUB 462
5298 RETURN
'
' ****  J - COMMAND FROM MAIN MENU (JOIN CONFERENCE)  ***
'
5300 GOSUB 45020
     WasA1$ = ZConfMenu$
     CALL BreakFileName (ZActiveMessageFile$,MsgDrvPath$,WasX$,ZWasY$,ZTrue)
5301 ZStackC = ZTrue
     '* "Join what, L)ist, M)ain, N)ext, S)ince, P)ers, or Name ([Q]uit)"
     LineNum = 163
     GOSUB 49030
     Strng1$ = Strng$
     '* ",M,MAIN,N,S,P,Q,"
     LineNum = 164
     GOSUB 49030
     Strng2$ = Strng$
     CALL SubMenu (Strng1$,WasA1$,MsgDrvPath$,"M.DEF", _
                   Strng2$,ZTrue,ZFalse,ZFalse,"C.DEF",WasX,ZFalse)
     IF ZWasQ = 0 OR ZWasZ$ = "Q" THEN
        RETURN
     END IF
     CALL WordInFile (ZConfMailList$,ZWasZ$,ZOK,ZFalse)
     IF NOT ZOK THEN
        '* "{CE{ZZ {CCNot Found!{RC"
        LineNum = 165
        CRCount = 1
        GOSUB 49010
        GOTO 5300
     END IF
     ZActiveUserName$ = ZOrigUserNameDgs$
     ZFirstName$ = OrigFirstName$
     IF ZSubParm = -1 THEN _
        RETURN 10595
     CALL SetSysOp
     IF ZWasA AND DgsAlias$ = "N" THEN
        ZActiveUserName$ = ZSysopFullName$
        ZFirstName$ = ZSysopFirstName$
     END IF
5323 '* "MAIN"
     LineNum = 166
     GOSUB 49030
     IF ZWasZ$ = Strng$ THEN
        ZWasZ$ = "M"
     END IF
     WasX = (ZWasZ$ = "M")
     IF ZWasZ$ = ConfNameSave$ OR (WasX AND ZConfName$ = Strng$) THEN
        '* "{CAYou are already in {CB{CN{RC"
        LineNum = 167
        CRCount = 1
        GOSUB 49010
        CALL SmartPause (ZFalse)
        GOSUB 2350
        RETURN
     END IF
     '* "!"
     LineNum = 1013
     GOSUB 49030
     IF ZUserInAra$(ZAnsIndex+1) = Strng$ AND ZAnsIndex < ZLastIndex THEN _
        ZTurboLogon = ZTrue : _
        ZAnsIndex = ZAnsIndex + 1
     '* "MNSPQ"
     LineNum = 168
     GOSUB 49030
     ON INSTR(Strng$,ZWasZ$) GOTO 5350,5290,5292,5294,5298
     IF NOT ZOK THEN _
        GOTO 5300
     CLOSE 2
'
' ****  UPDATE PREVIOUS MESSAGE BASE CHECKPOINT RECORD  ***
'
     PrevConfName$ = ZConfName$
     ZConfName$ = ZWasZ$
     ConfFileName$ = ZConfName$
     PrevMsg$ = ZActiveMessageFile$
     ZActiveMessageFile$ = ZFileName$
     GOSUB 5343
'
' ****  UPDATE PREVIOUS USER RECORD  ***
'
     GOSUB 5380
'
' *****  CHECK WHETHER HAVE SUBBOARD (I.E. CONFIG.DEF EXISTS)  ****
'
     UserRecordHold$ = ZUserRecord$
     ConfModeSave = ZConfMode
     ZConfMode = ZTrue
     PrevUser$ = ZActiveUserFile$
     PrevIndex = ZUserFileIndex
     PrevMainUser$ = ZMainUserFile$
     PrevUSL = ZUserSecLevel
     PrevDef$ = ZCurDef$
     WasX$ = ZConfName$ + _
          "C.DEF"
     CALL FindIt (WasX$)
     ZSubBoard = ZOK
     IF NOT ZSubBoard THEN _
        CALL BreakFileName (ZMainMsgFile$,MsgDrvPath$,ZWasDFF$,ZWasY$,ZTrue) : _
        WasX$ = MsgDrvPath$ + WasX$ : _
        CALL FindIt (WasX$) : _
        ZSubBoard = ZOK
     IF ZSubBoard THEN
        IF LEN(ZConfName$) = 6 THEN
           IF LEFT$(ZConfName$,4) = "RBBS" AND RIGHT$(ZConfName$,1) = "P" THEN
              ZSubBoard = ZFalse
           END IF
        END IF
     END IF
     IF NOT ZSubBoard THEN
        GOSUB 5280
        CALL SetXPost
        ZNetMailSystem = ZFalse
        ZFileName$ = ZWelcomeFileDrvPath$ + _
                     ZConfName$ + _
                     "W.DEF"
     ELSE
        CALL ReadDef (WasX$)
        IF ZErrCode > 0 THEN
           '* "Error {ER reading config file {CNC.DEF"
           LineNum = 169
           CRCount = 2
           GOSUB 49020
           ZErrCode = 0
           ZInConfMenu = ZFalse
           '* "error reading subboard"
           LineNum = 170
           GOSUB 49000
           GOTO 5341
        ELSE
           WasX$ = ZMainUserFile$
           ZFileName$ = ""
           CALL FindIt (ZMainMsgFile$)
           IF NOT ZOK THEN
              '* "msg file missing for"
              LineNum = 171
              GOSUB 49000
              ZInConfMenu = ZFalse
              GOTO 5341
           ELSE
              ZActiveMessageFile$ = ZMainMsgFile$
              GOSUB 5343
           END IF
        END IF
     END IF
     UpdateDate = ZTrue
     CALL FindIt (WasX$)
     IF ZOK THEN _
        GOTO 5330
'
' *****  NO USER FILE - A PUBLIC CONFERENCE   ****
'
     ZMainUserFile$ = PrevMainUser$
     IF (ZUserSecLevel < AutoAddSec) THEN _
        GOTO 5340
     GOTO 5345
'
' ****  CHECK CONFERENCE USER'S FILE  ***
'
5330 ZActiveUserFile$ = WasX$
     IF ZMainUserFileIndex < 1 THEN _
        Found = ZFalse : _
        ZUserFileIndex = 0 : _
        GOTO 5335
     CALL WordInFile (ZConfMenu$,ZConfName$,ZInConfMenu,ZFalse)
     '* "SYSOP"
     LineNum = 131
     GOSUB 49030
     IF ZActiveUserName$ = Strng$ THEN
        TempHashValue$ = ZOrigUserName$
     END IF
     GOSUB 12598
     GOSUB 12984
5335 IF Found THEN
        GOSUB 9500
        ZMainUserFileIndex = -(ZSubBoard * ZUserFileIndex) _
                               -((NOT ZSubBoard) * ZMainUserFileIndex)
        Temp = -(ZSubBoard * ZMinLogonSec) _
               -((NOT ZSubBoard) * AutoAddSec)
        GOSUB 5135
        GOSUB 5296
        WasI = (ZUserSecLevel < OrigMainSec)
        WasJ = (ZUserSecLevel < Temp)
        WasK = (WasI AND WasJ)
        IF WasK THEN
           '* "you have been locked out of"
           LineNum = 172
           GOSUB 49000
           GOTO 5341
        ELSE
           GOSUB 5375
           GOTO 5345
        END IF
     END IF
'
' **** USER NOT FOUND.  AUTO-ADD TO SUBBOARD IF SUFFICIENT SECURITY ***
'
     ZNewUser = ZTrue
     IF ZSubBoard THEN _
        AutoAddSec = ZMinLogonSec
     IF (ZOrigSec >= AutoAddSec) AND _
        (ZUserFileIndex > 0) AND (ZMainUserFileIndex > 0) THEN
        LSET ZUserRecord$ = UserRecordHold$
        '* "{CEMEMBER {C2access granted in {CB{CN{RC"
        LineNum = 173
        CRCount = 1
        GOSUB 49010
        MID$(ZUserOption$,3,2) = MKI$(0)
        MID$(ZUserOption$,1,2) = MKI$(0)
        ZMailWaiting = ZFalse
        ZFileWaiting = ZFalse
        ZLastMsgRead = 0
        CALL DefaultU
        ZActiveUserName$ = LEFT$(UserRecordHold$,30)
        CALL Trim (ZActiveUserName$)
        Temp = -(ZSubBoard * ZDefaultSecLevel) _
               -((NOT ZSubBoard) * ZUserSecSave)
        CALL SetSysOp
        Temp = -(ZWasA * ZSysopSecLevel) - ((NOT ZWasA) * Temp)
        LSET ZSecLevel$ = MKI$(Temp)
        ZUserSecLevel = Temp
        GOSUB 5375
        ZPageLength = ZPageLengthDef
        ZPageLengthHold = ZPageLength
        ZExpertUserHold = ZExpertUser
        ZTurboKeyUserHold = ZTurboKeyUser
        IF (ZBBSOptions AND  16384) = 0 AND ZSubBoard THEN
           LSET ZUserDnlds$ = MKI$(0)
           LSET ZUserUplds$ = MKI$(0)
           IF ZEnforceRatios THEN
              LSET ZTodayDl$ = MKS$(0)
              LSET ZTodayBytes$ = MKS$(0)
              LSET ZDlBytes$ = MKS$(0)
              LSET ZULBytes$ = MKS$(0)
           END IF
        END IF
        GOSUB 12986
        GOSUB 12630
        UpdateDate = ZTrue
        Found = ZTrue
        GOTO 5335
     END IF
     IF ZOrigSec >= AutoAddSec THEN
        '* "{CEGUEST {C2privileges granted in {CB{CN{RC"
        LineNum = 174
        CRCount = 1
        GOSUB 49010
        ZActiveUserFile$ = PrevUser$
        UpdateDate = ZFalse
        ZUserFileIndex = PrevIndex
        GOSUB 5382
        ZUserFileIndex = 0
        GOTO 5345
     END IF
     ZNewUser = ZFalse
5340 '* "Conference NOT available with your Access Level!"
     LineNum = 175
     GOSUB 49000
5341 ZOutTxt$ = ZOutTxt$ + SPACE$(1) + ZConfName$ + "."
'
' ****  CANNOT JOIN THE REQUESTED CONFERENCE.  THEREFORE, GO BACK  ***
'
     GOSUB 1397
     CALL SmartPause (ZFalse)
     ZConfName$ = PrevConfName$
     ConfFileName$ = ZConfName$
     IF ZSubBoard THEN _
        CALL ReadDef (PrevDef$)
     ZActiveMessageFile$ = PrevMsg$
     GOSUB 5343
     ZUserFileIndex = PrevIndex
     ZActiveUserFile$ = PrevUser$
     GOSUB 5382
     ZConfMode = ConfModeSave
     GOSUB 12987
     ZAnsIndex = 0
     ZLastIndex = 0
     GOTO 5301
'
' ****  RESTORE A MESSAGE BASE   ***
'
5343 GOSUB 5344
     GOSUB 23000
     RETURN
'
' *****  OPEN AND SETUP MESSAGE BASE  *****
'
5344 CALL OpenMsg
     IF ZErrCode = 64 THEN _
        ZErrCode = 0 : _
        GOTO 5350
     FIELD 1, 128 AS ZMsgRec$
     RETURN
'
' *****  SUCCESSFUL CONFERENCE JOIN  ****
'
5345 DgsAlias$ = ""
     CALL AliasDgs (ZConfName$,ZOrigUserNameDgs$,DgsAlias$)
     IF ZGlobalSysop AND DgsAlias$ = "N" THEN
        ZActiveUserName$ = ZSysopFullName$
     END IF
     ZNewsFileName$ = ZWelcomeFileDrvPath$ + ZConfName$ + ".NWS"
     CALL DeLink (ZConfName$)
     ConfNameSave$ = ZConfName$
     '* "ConferenceSubboard"
     LineNum = 1014
     GOSUB 49030
     ZConfName$ = ZConfName$ + SPACE$(1) + MID$(Strng$,1-10*ZSubBoard,10)
     ZMarkedMsgs$ = ""
     ZMarkedFiles$ = ""
     GOSUB 4900
     GOSUB 12987
     GOSUB 12990
     BoardCheckDate$ = LEFT$(STRING$(2,48) + "-" + STRING$(2,48) + _
                             "-" + STRING$(2,48),-ZNewUser*8) + _
                       LEFT$(ZLastDateTimeOn$,-(NOT ZNewUser)*8)
     IF ZSubBoard THEN _
        ZHasDoored = ZFalse : _
        ZActiveFMSDir$ = "" : _
        ZTimeLoggedOn$ = TIME$ : _
        CALL SetPrompt : _
        RETURN 108
     ZNewUser = ZFalse
     GOSUB 827
     IF UpdateDate THEN _
        ZTimeLoggedOn$ = TIME$ : _
        LSET ZLastDateTimeOn$ = ZCurDate$ + _
                                  SPACE$(1) + _
                                  ZTimeLoggedOn$ : _
        GOSUB 9440 : _
        GOSUB 12991
     IF PrevUSL <> ZUserSecLevel THEN _
        CALL SetPrompt
     CALL NewsScan (3,BoardCheckDate$,SameUser,WasZ)
     RETURN 852
'
' ****  JOIN M)AIN   ***
'
5350 '* "MAIN"
     LineNum = 166
     GOSUB 49030
     IF ZConfName$ <> Strng$ THEN
        '* "{CR{C2Rejoining {CBMAIN{RC"
        LineNum = 176
        CRCount = 1
        GOSUB 49010
     END IF
     ZActiveUserName$ = ZOrigUserNameDgs$
     ZFirstName$ = OrigFirstName$
     CALL DeLink (ZConfName$)
     ConfFileName$ = OrigMsgName$
     ZNewsFileName$ = OrigNewsFileName$
     ZTurboLogon = ZTrue
     ZMarkedMsgs$ = ""
     ZMarkedFiles$ = ""
     ZWasQ = 0
     ZNewUser = ZFalse
     ZInConfMenu = ZTrue
     '* "SYSOP"
     LineNum = 131
     GOSUB 49030
     IF ZActiveUserName$ = Strng$ THEN _
        ZActiveUserName$ = ZSysopFullName$
     ZConfigFileName$ = ZOrigCnfg$
     CALL ReadDef (ZConfigFileName$)
     IF ZOrigMsgFile$ <> ZActiveMessageFile$ THEN _
        ZActiveMessageFile$ = ZOrigMsgFile$ : _
        GOSUB 5343
     IF ZOrigUserFile$ <> ZActiveUserFile$ THEN _
        GOSUB 5380 : _
        ZActiveUserFile$ = ZOrigUserFile$ : _
        ZActiveUserName$ = ZOrigUserName$ : _
        GOSUB 12598 : _
        GOSUB 12990 : _
        IF Found THEN _
           GOSUB 9500 : _
           ZMainUserFileIndex = ZUserFileIndex : _
           CALL SetPrompt : _
           CALL XferType (2,ZTrue) _
        ELSE ZUserFileIndex = 0 : _
             ZMainUserFileIndex = 0
     '* "Exited {CN"
     LineNum = 177
     CRCount = 3
     GOSUB 49020
     '* "MAIN"
     LineNum = 166
     GOSUB 49030
     ZConfName$ = Strng$
     ConfNameSave$ = ZConfName$
     GOSUB 2350
     CALL SetGlobals
     ZConfMode = ZFalse
     BoardCheckDate$ = ZLastDateTimeOn$
     ZSubBoard = ZTrue
     GOSUB 12987
     RETURN 108
5375 IF ((ZUserSecLevel < ZAutoUpgradeSec) AND ZSubBoard) OR _
        ((ZUserSecLevel < OrigUpgradeSec) AND NOT ZSubBoard) THEN _
           IF ZUserSecLevel <> ZOrigSec THEN _
              ZUserSecLevel = ZOrigSec : _
              LSET ZSecLevel$ = MKI$(ZUserSecLevel)
     RETURN
'
' *****  UPDATE CURRENT USERS RECORD  ****
'
5380 IF ZUserFileIndex < 1 THEN _
        RETURN
     IF ZAdjustedSecurity AND NOT ZSysop THEN _
        LSET ZSecLevel$ = MKI$(ZUserSecLevel) : _
        ZUserSecSave = ZUserSecLevel
     IF ZSubBoard THEN _
        ZActiveUserName$ = ZOrigUserNameDgs$ : _
        ZFirstName$ = OrigFirstName$
     CALL UpdateU (ZFalse)
     RETURN
'
' *****  RESTORE A USER RECORD  ****
'
5382 IF ZUserFileIndex < 1 THEN _
        ZUserSecLevel = ZDefaultSecLevel : _
        RETURN
     CALL OpenUser (ZHighestUserRecord)
     GET 5,ZUserFileIndex
     GOSUB 9500
     RETURN
'
' *****  R - COMMAND FROM UTILITY MENU (REVIEW PROFILE)  ****
'
5400 CALL ReviewProfile
     RETURN
'
' *****  B - COMMAND FROM UTILITY MENU (Bank Time)  ****
'
5500 IF ZUserSecLevel < ZOptSec(27) OR _
        ZTempMaxBank <= 0 THEN RETURN
     GOSUB 5501
     CALL BankTime
     CALL SmartPause (ZFalse)
     RETURN
5501 CALL RptTime
     RETURN
'
' *****  V - COMMAND FROM MAIN MENU (VIEW CONFERENCES)  ****
'
5800 CALL ConfMail (MailCheckConfirm,LinkNew,LinkPers)
     ConfMailJoin = (ZHomeConf$ <> "")
     RETURN
'
' *  FORMAT MESSAGE HEADER INFORMATION FOR DISPLAY
'
8000 IF ZRet THEN _
        RETURN
8020 CALL MessageHeader (OrigSubject$,WasSJ$, _
                         ReadMsgs,JustReplied,MsgSec,SubInHeader$, _
                         QuickScanMsgs,ScanMsgs,MsgToCaller,MsgFromCaller, _
                         CurrHeaderRecNum,Flushed,FileAttachName$)
     IF ZSubParm = -1 THEN
        GOTO 202
     END IF
     RETURN
'
' * UNCOMPRESS MESSAGE PRIOR TO DISPLAY
'
9000 IF NOT ZJustSearching THEN _
        GOSUB 4656 : _
        CALL SkipLine (1) : _
        ZLinesInMsg = 1 : _
        MsgDimXtra = 250 : _
        REDIM ZOutTxtAra$(MsgDimXtra) : _
        Remain$ = "" : _
        HiLitedLine = 0
     RecToRead = ZMsgPtr(ZMsgDimIndex,1) + ZNumHeaders - 1
     OutRec = ZMsgPtr(ZMsgDimIndex,1) + ZNumHeaders - 1
     FOR WasX = ZNumHeaders + 1 TO VAL(MID$(ZMsgRec$,117,4))
        WasJ = 1
        RecToRead = RecToRead + 1
        GET 1, RecToRead
        IF ZJustSearching THEN _
           ZOutTxt$ = UCASE$(ZMsgRec$) : _
           HiLitePos = INSTR(ZOutTxt$,ZSearchString$) : _
           IF HiLitePos > 0 THEN _
              SearchCt = 0 : _
              HiLiteRec = LOC(1) : _
              WasX = 9999 : _
              GOTO 9090 _
           ELSE GOTO 9090
9050    ZWasB = INSTR(WasJ,ZMsgRec$,CHR$(227))
        IF ZRet THEN _
           RETURN
9060    ZWasC = ZWasB - WasJ
        IF ZWasC < 0 THEN _
           ZWasC = 128
        ZOutTxt$ = MID$(ZMsgRec$,WasJ,ZWasC)
        IF HiLiteRec = LOC(1) THEN _
           IF HiLitePos >= WasJ AND HiLitePos < WasJ+ZWasC THEN _
              HiLiteRec = -1 : _
              Bracketed = ZTrue : _
              ZOutTxtAra$(0) = ZOutTxt$ : _
              CALL Bracket (ZOutTxt$,HiLitePos-WasJ+1,HiLitePos+LEN(ZSearchString$)-WasJ,ZEmphasizeOn$,ZEmphasizeOff$)
        IF ZWasB = 0 THEN _
           Remain$ = ZOutTxt$ : _
           GOTO 9090 _
        ELSE ZOutTxt$ = Remain$ + ZOutTxt$ : _
             Remain$ = "" : _
             WasJ = ZWasB + 1
        IF LEFT$(ZOutTxt$,1) = CHR$(1) OR _
           LEFT$(ZOutTxt$,LEN(ZScreenOutMsg$)) = ZScreenOutMsg$ THEN _
           GOTO 9050
        ZOutTxtAra$(ZLinesInMsg) = ZOutTxt$
        IF Bracketed THEN _
           Bracketed = ZFalse : _
           HiLitedLine = ZLinesInMsg
        ZLinesInMsg = ZLinesInMsg + 1
        IF ZLinesInMsg > MsgDimXtra THEN
           ZLinesInMsg = ZLinesInMsg - 1
           '* "{CR{CCMessage too long.{CRTruncated to {CF250 {CClines!{RC"
           LineNum = 178
           CRCount = 1
           GOSUB 49010
           ZOutTxt$ = ""
           RETURN
        END IF
        CALL CheckColor (ZOutTxt$,SubInHeader$,ZEmphasizeOff$)
        CALL ColorInitials (ZOutTxt$)
        IF NOT DontPrint THEN
           IF ZSmartTxtInMsgs THEN
              CALL SmartText(ZoutTxt$,ZFalse,ZFalse,ZTrue)
           END IF
           GOSUB 12979
           IF ZRet THEN
              ZOutTxt$ = ""
              RETURN
           ELSE
              CALL AskMore ("",ZTrue,ZTrue,ZAnsIndex,ZFalse)
              IF ZNo THEN
                 DontPrint = ZTrue
              END IF
           END IF
        END IF
        GOTO 9050
9090 NEXT
     IF DontPrint = ZTrue THEN _
        GOTO 5160
     IF ZJustSearching AND HiLitePos > 0 THEN _
        AlreadyPrinted = ZFalse : _
        ZJustSearching = ZFalse : _
        GET 1,ZMsgPtr(ZMsgDimIndex,1) : _
        GOSUB 8000 : _
        GOTO 9000
     ZOutTxt$ = ""
     RETURN
'
' *  W - COMMAND FROM UTILITY MENU (Who Uploaded What?)
'
9100 CALL WhoDidIt
     '* "End of Listing"
     LineNum = 179
     GOSUB 49030
     CALL AskMore (Strng$,ZTrue,ZFalse,WasX,ZTrue)
     RETURN
'
' * WRITE A RECORD TO THE RBBS-PC "USER" FILE
'
9440 IF ZUserFileIndex > 0 AND ZUserFileIndex < 32768 THEN _
        PUT 5,ZUserFileIndex
     RETURN
'
' * DEFINE USER FILE RECORD VARIABLES TO COMPENSATE FOR THE BUG IN QUICKBASIC
' * THAT REQUIRES A FIELD STATMENT TO BE EXECUTED WITHIN EACH SEPARATELY
' * COMPILED PROGRAM -- EVEN THOUGH A FIELD STATEMENT WAS EXECUTED WHEN THE
' * FILE WAS OPENED IN ANOTHER SEPARATELY COMPILED SUBROUTINE
'
' * SO WHY ARE WE USING MICROSOFT!?
'
9450 IF LOF(5) < 1 THEN _
        ZWasDFF$ = ZActiveUserFile$ : _
        RETURN 13600
     FIELD 5,31 AS ZUserName$, _
             15 AS ZPswd$, _
              2 AS ZSecLevel$, _
             14 AS ZUserOption$,  _
             24 AS ZCityState$, _
              1 AS MachineType$, _
              1 AS ZDropTimes$, _
              1 AS ZBankTime$,_
              4 AS ZTodayDl$, _
              4 AS ZTodayBytes$, _
              4 AS ZDlBytes$, _
              4 AS ZULBytes$, _
             14 AS ZLastDateTimeOn$, _
              3 AS ZListNewDate$, _
              2 AS ZUserDnlds$, _
              2 AS ZUserUplds$, _
              2 AS ZElapsedTime$
     FIELD 5,128 AS ZUserRecord$
     RETURN
'
' * GET USER DEFAULTS
'
9500 GOSUB 9450
     CALL SetSysOp
     CALL SetUserPref
     RETURN
'
' *  B - COMMAND FROM MAIN MENU (READ BULLETINS)
'
9700 '* ",*,S,N,"
     LineNum = 180
     GOSUB 49030
     ReturnOn$ = Strng$
     WasA1$ = ZBulletinMenu$
     IF (ZBBSOptions AND 512) > 0 THEN
        StartTime! = TIMER
     END IF
9701 '* "Read what bulletin(s), L)ist, S)ince, N)ews {EX"
     LineNum = 181
     GOSUB 49030
     CALL SubMenu (Strng$,WasA1$, ZBulletinPrefix$,"",ReturnOn$,_
                   ZFalse,ZFalse,ZFalse,"",WasX,ZTrue)
     IF ZWasQ = 0 THEN
        IF (ZBBSOptions AND 512) > 0 THEN
           GOSUB 48000
        END IF
        RETURN
     END IF
     CALL CheckCarrier
     IF ZSubParm = -1 THEN _
        RETURN 10595
     IF (ZWasZ$ = "*" OR ZWasZ$ = "S") THEN _
        ZPrevPrefix$ = "" : _
        GOTO 9760
     ZStopInterrupts = ZFalse
     IF ZWasZ$ = "N" THEN
        CALL NewsScan (2,BoardCheckDate$,SameUser,WasZ)
        IF WasZ <> 0 THEN
           GOTO 9701
        ELSE
           GOTO 9703
        END IF
     END IF
     CALL BufFile (ZFileName$,ZAnsIndex)
     IF (ZBBSOptions AND 4) > 0 THEN
        CALL SmartPause (ZFalse)
     END IF
9703 '* "Read bulletin {FI"
     LineNum = 182
     CRCount = 1
     GOSUB 49020
     GOTO 9701
'
' *  CHECK AND REVIEW NEW BULLETINS SINCE Last LOGON
'
9750 CALL CheckNewBul (BoardCheckDate$,NumNewBullets,NewBullets$)
     RETURN
9760 ' ****  [entry when want review plus chance to read] *********
     GOSUB 9750
     IF NumNewBullets > 0 THEN
        ZLastIndex = NumNewBullets + 1
        '* "Read what NEW bulletins, A)ll{RC{EX"
        LineNum = 183
        GOSUB 49000
        GOSUB 12999
        ZUserIn$ = UCASE$(ZUserIn$)
        IF ZWasQ > 0 THEN
           GOSUB 9761
           ZAnsIndex = 0
           ZLastIndex = NumNewBullets
           GOTO 9700
        END IF
     END IF
     ZLastIndex = 0
     IF ZAnsIndex < 1 THEN _
        RETURN
     GOTO 9701
9761 IF ZUserIn$ <> "A" THEN _
        NumNewBullets = ZWasQ _
     ELSE _
        FOR Temp = 1 TO NumNewBullets : _
           ZUserInAra$(Temp) = ZOutTxtAra$(Temp+1) : _
        NEXT
     RETURN
'
' *  W - COMMAND FROM MAIN MENU (WHO'S ON THE OTHER NODES)
'
9800 IF NOT ZAvailableForChat THEN
        CALL WhosOn
     ELSE
        CALL PageEm (ZNodeRecIndex - 1, ZMaxNodes)
        REM ** 'ZNodeRecIndex - 1' is the users actual node number.. is there
        REM ** already a variable for this?? I dunno..
        REM **
        REM ** PageEm will call WhosOn, then ask if they want to page someone
        REM ** if so, it'll call CBTrueChat
        REM ** etc..
        CLOSE 10
     END IF
     GOSUB 5344
     RETURN
'
' *  1 - COMMAND FROM SYSOP MENU (DISPLAY COMMENTS)
'
10070 CALL BufFile (ZCmntsFile$,WasX)
      GOSUB 10530
      RETURN
'
' *  U - COMMAND FROM UTILITY MENU (DISPLAY USERS)
' *  2 - COMMAND FROM SYSOP MENU (DISPLAY USERS)
'
10090 '* "{RCList - U)sers, R)ecent callers{EX"
      LineNum = 184
      GOSUB 49000
      ZMacroMin = 2
      CALL SkipLine (1)
      GOSUB 12930
      IF ZWasQ = 0 THEN _
         RETURN
      CALL AraAllCaps (ZUserInAra$(),ZAnsIndex)
      ON INSTR("UR",ZUserInAra$(ZAnsIndex)) + 1 GOTO 10090,10096,10093
10093 CALL DispCall
      RETURN
10096 '* "Name                           City/State              Last On"
      LineNum = 1094
      GOSUB 49000
      GOSUB 12979
      '* "---------------------------------------------------------------------"
      LineNum = 1095
      GOSUB 49000
      IF ZWasGR > 0 THEN
         CALL GlobalSrchRepl (ZOutTxt$,"-",CHR$(196),ZTrue)
      END IF
      GOSUB 12979
      UserRecordHold$ = ZUserRecord$
      CALL OpenUser (ZHighestUserRecord)
      GOSUB 9450
      ZStopInterrupts = ZFalse
      WasI = 1
      ZWasZ$ = ZSysopFullName$
10097 IF WasI > ZHighestUserRecord OR ZRet THEN _
         GOTO 10099
      GET 5,WasI
      WasX$ = MID$(ZUserRecord$,ZStartHash,ZLenHash)
      IF ASC(WasX$)=0 OR LEFT$(WasX$,3)=SPACE$(3) THEN _
         GOTO 10098
      IF INSTR(WasX$,ZWasZ$) > 0 OR ZSysopSecLevel <= CVI(MID$(ZUserRecord$,47,2)) THEN _
         IF NOT ZSysop THEN _
            GOTO 10098
      CALL AskMore ("",ZTrue,ZTrue,WasXX,ZFalse)
      IF ZNo OR ZSubParm = -1 THEN _
         GOTO 10099
      ZOutTxt$ = LEFT$(WasX$,36) + ZCityState$ + ZLastDateTimeOn$
      GOSUB 12979
10098 WasI = WasI + 1
      GOTO 10097
10099 ZOutTxt$ = ""
      LSET ZUserRecord$ = UserRecordHold$
      ZStopInterrupts = ZTrue
      CALL SmartPause (ZFalse)
      RETURN
'
' *  3 - COMMAND FROM SYSOP MENU (RECOVER MESSAGES)
'
10390 MsgRecovered = ZFalse
10391 '* "Recover Msg #"
      LineNum = 185
      GOSUB 49030
      CALL ChangeInt (ZFalse,Strng$,0,1,9999)
      IF ZWasQ = 0 THEN _
         RETURN
      MsgToRecover = ZTestedIntValue
      GOSUB 5344
      ActionFlag = ZFalse
      CALL RecoverMsg (MsgToRecover,FirstMsgRecord,ActionFlag,ZConfName$)
      MsgRecovered = MsgRecovered OR ActionFlag
      GOTO 10391
      IF MsgRecovered THEN _
         ActionFlag = ZTRUE : _
         GOTO 1900
      RETURN
'
' *  4 - COMMAND FROM SYSOP MENU (DELETE COMMENTS)
'
10530 '* "{CR{RCDelete comments (Y,[N])"
      LineNum = 186
      GOSUB 49000
      GOSUB 12995
      IF ZYes THEN _
         CALL OpenOutW (ZCmntsFile$)
      CLOSE 2
      RETURN
'
' *  TIME LIMIT EXCEEDED EXIT
'
10553 '* "Time limit exceeded"
      LineNum = 187
      CRCount = 1
      GOSUB 49020
      '* "{CF{G4Sorry, {CE{FN {CFYour time limit has expired{RC"
      LineNum = 188
      CRCount = 1
      GOSUB 49010
      ZExitCode = 2
      GOTO 10563
'
' *  Q - COMMAND FROM GLOBAL FUNCTIONS
'
10560 GOSUB 41000
      IF ZExpertUser THEN ZLogOff$ = "L"
10563 GOSUB 44000
      '* "Logged off"
      LineNum = 189
      CRCount = 1
      GOSUB 49020
      GOTO 10595
10570 GOSUB 41000
      ZLogoff$ = ""
      GOSUB 45020
      CALL SkipLine (1)
      IF ZExpertUser THEN _
         GOTO 10575
10571 ZStopInterrupts = ZTrue
      ZDeleteInvalid = ZTrue
      HoldOpts$ = ZInvalidOpts$
      ZInvalidOpts$ = ""
      IF ZTempMaxBank < 1 THEN _
         ZInvalidOpts$ = "B"
      IF ZUserSecLevel < ZOptSec(3) THEN _
         ZInvalidOpts$ = ZInvalidOpts$ + "C"
      ZFileName$ = ZWelcomeFileDrvPath$ + "LOGOFF.MNU"
      GOSUB 1790
      ZInvalidOpts$ = HoldOpts$
      ZStopInterrupts = ZFalse
      ZDeleteInvalid = ZFalse
10575 IF ZLastIndex > ZAnsIndex THEN
         ZUserIn$ = ZUserInAra$(ZLastIndex)
         ZLastIndex = 0
         GOTO 10576
      END IF
      CALL DispSectionAndTime
      '* "{CFLOGOFF {C2command{RC"
      LineNum = 191
      GOSUB 49000
      IF NOT ZCmndsInPrompt THEN
         GOSUB 12999
         GOTO 10576
      END IF
      IF ZExpertUser THEN
         IF ZTempMaxBank > 0 AND ZUserSecLevel => ZOptSec(3) THEN
            '* "(?,H,A,B,C,[G])"
            LineNum = 192
         ELSEIF ZTempMaxBank > 0 AND ZUserSecLevel < ZOptSec(3) THEN
            '* "(?,H,A,B,[G])"
            LineNum = 193
         ELSEIF ZTempMaxBank <= 0 AND ZUserSecLevel => ZOptSec(3) THEN
            '* "(?,H,A,C,[G])"
            LineNum = 194
         ELSE
            '* "(?,H,A,[G])"
            LineNum = 195
         END IF
      ELSE
         IF ZTempMaxBank > 0 AND ZUserSecLevel => ZOptSec(3) THEN
            '* "(?,H)elp,A)bort,B)ank,C)omment,[G]oodbye)"
            LineNum = 196
         ELSEIF ZTempMaxBank > 0 AND ZUserSecLevel < ZOptSec(3) THEN
            '* "(?,H)elp,A)bort,B)ank,[G]oodbye)"
            LineNum = 197
         ELSEIF ZTempMaxBank <= 0 AND ZUserSecLevel => ZOptSec(3) THEN
            '* "(?,H)elp,A)bort,C)omment,[G]oodbye)"
            LineNum = 198
         ELSE
            '* "(?,H)elp,A)bort,[G]oodbye)"
            LineNum = 199
         END IF
      END IF
      GOSUB 49030
      ZOutTxt$ = ZOutTxt$ + Strng$
      GOSUB 12999
10576 ZUserIn$ = UCASE$(ZUserIn$)
      '* "ABCGH?"
      LineNum = 200
      GOSUB 49030
      WasX = INSTR(Strng$,ZUserIn$)
      IF ZUserIn$ = "" THEN _
         GetOut = ZTrue : _
         GOTO 10563
      ON WasX GOTO 10580,10583,10581,10582,10571,10571
      GOTO 10575
10580 RETURN
10581 GOSUB 1800
      GOTO 10570
10582 GetOut = ZTrue
      ZLogOff$ = "L"
      GOTO 10560
10583 IF ZTempMaxBank <= 0 THEN
         GOTO 10575
      ELSE
         CALL BankTime
      END IF
      GOTO 10570
10590 '* "Sleep disconnect"
      LineNum = 201
      CRCount = 1
      GOSUB 49020
      ZSubBoard = ZFalse
      ZExitCode = 3
10595 CALL GetTime
      GOSUB 13700
      IF ZDnldCompleted = ZTrue AND ZAutoEnd = 1 THEN
         ZAutoLogoffReq = ZTrue
         GetOut = ZTrue
         GOSUB 46000
      END IF
      ZSubParm = 0
      CALL CheckCarrier
      IF ZSubParm = -1 THEN _
         GOTO 10597
      IF ZConfName$ = OrigMsgName$ THEN _
         GetOut = ZTrue
      IF (ZSubBoard AND _
         (NOT GetOut) AND _
         (NOT ZSleepDisconnect) AND _
         (NOT ZAutoLogoffReq)) THEN
         GOSUB 5380
         ZHomeConf$ = "M"
         '* "{CF{G4Time limit exceeded in {CE{CN{RC"
         LineNum = 202
         CRCount = 1
         GOSUB 49010
         ZSubBoard = ZFalse
         IF GetOut = ZFalse THEN
            GOTO 1205
         END IF
      ELSE
         IF ZSubBoard AND ZAutoLogOffReq THEN
            GOSUB 44000
         END IF
      END IF
10597 CALL SayGoodby
      IF NOT ZDontShowLogOff THEN
         GOSUB 5501
      END IF
      CALL UpdateU (ZTrue)
      ZAvailableForChat = ZFalse
      CALL SaveUserActivity("I", ZNodeRecIndex, ZFalse,WasAV)
      GOTO 13540
10620 CALL UpdtCalr(ZWasLG$(ZLogonErrorIndex),2)
      IF ZExitToDoors THEN _
         CALL UpdateU (ZTrue)
10621 IF ZActiveUserName$ = "" THEN
         '* "NAME UNAVAILABLE"
         LineNum = 203
         GOSUB 49030
         ZActiveUserName$ = Strng$
      END IF
      '* "{AN on at {SD, {TM ** LOGON DENIED **, {BP"
      LineNum = 204
      GOSUB 49030
      ZWasZ$ = Strng$
      ZWasNG$ = ZWasZ$ + _
            SPACE$(128 - LEN(ZWasZ$))
10698 IF ZFunctionKey = 22 OR ZFunctionKey = 23 THEN _
         GOTO 13545
      '* "{CE{G4 ACCESS DENIED! {C7{G0"
      LineNum = 205
      GOSUB 49000
      GOSUB 12976
      CALL DelayTime (8 + ZBPS)
      GOTO 13545
'
' *  M - COMMAND FROM UTILITY MENU (CHANGE MARGINS)
'
10925 '* "Right Margin"
      LineNum = 90
      GOSUB 49030
      CALL ChangeInt (ZTrue,Strng$,ZRightMargin,8,72)
      IF ZWasQ <> 0 THEN _
         ZRightMargin = ZTestedIntValue
      RETURN
'
' *  7 - COMMAND FROM SYSOP MENU (EXIT TO DOS)
'
10930 IF (ZRequiredRings = 0 AND NOT ZNoDoorProtect) THEN
         '* "{CF{G4Remote DOS unavailable{RC"
         LineNum = 206
         CRCount = 1
         GOSUB 49010
         RETURN
      END IF
'10932 IF ZLocalUser AND NOT ZDebug THEN
'         '* "{CF{G4Only for remote SysOps{RC"
'         LineNum = 207
'         CRCount = 1
'         GOSUB 49010
'         RETURN
'      END IF
10932 CALL DosExit
      ZSubParm = -9
      CALL FindFKey
      GOTO 202
'
' *  8 - COMMAND FROM SYSOP MENU (FMS FILE MAINTENANCE)
'
10950 CALL Sysop8
      IF ZGetExtDesc THEN
         GOSUB 2008
         GOTO 10950
      END IF
      RETURN
'
' *  D - COMMAND FROM MAIN MENU (EXIT TO DOORS)
'
10970 IF NOT ZDoorsAvail OR _
         (ZRequiredRings = 0 AND NOT ZNoDoorProtect) THEN
         '* "{CF{G5No doors available{RC"
         LineNum = 208
         CRCount = 1
         GOSUB 49010
         RETURN
      END IF
      IF ZTimeLock AND 1 AND NOT ZHasDoored THEN _
         CALL TimeLock : _
         IF NOT ZOK THEN _
            RETURN
10974 ZDoorCarrierDropOK$ = "N"
      WasA1$ = ZMenu$(5)
      ZStackC = ZTrue
      GOSUB 41000
      '* "{RCOpen which door, L)ist{EX"
      LineNum = 209
      GOSUB 49030
      CALL SubMenu (Strng$,WasA1$,"",ZDefaultBatchExt$,"",_
                    ZTrue,ZFalse,ZFalse,"",InMenu,ZFalse)
      IF ZWasQ = 0 THEN _
         RETURN
      IF ZSubParm = -1 THEN _
         RETURN 10595
      ZWasZ$ = ZFileName$
      ZMenuDoors = ZMenuDoors + 1
      CALL DoorExit (NOT InMenu)
      '* "{CR{CF{G1Welcome back {FN!{RC"
      LineNum = 9
      CRCount = 2
      GOSUB 49010
      GOTO 10974
'
' *  5 - COMMAND FROM SYSOP MENU (USER FILE MAINTENANCE)
'
11000 EditFromRead = 0
11010 WasTU = ZUserFileIndex
      CALL DefaultU
      UserRecordHold$ = ZUserRecord$
      RegDateHold$ = ZRegDate$
      UserSecLevelSave = ZUserSecLevel
      CALL UserEd (EditFromRead,TempHashValue$,UserRecordHold$,RegDateHold$,UserSecLevelSave,WasTU)
      IF EditFromRead = 3 THEN GOTO 4560
      RETURN
'
' *  ALLOW USERS TO ANSWER A "QUESTIONNAIRE" BASED ON THE RBBS-PC SCRIPT
'
11520 CALL AskUsers
      IF NOT ZOK THEN _
         RETURN
      IF ZAdjustedSecurity THEN _
         GOSUB 12989 : _
         LSET ZSecLevel$ = MKI$(ZUserSecLevel) : _
         GOSUB 9440 : _
         GOSUB 12991 : _
         CALL SetPrompt : _
         CALL XferType (2,ZTrue) : _
         GOSUB 5135
      REDIM ZOutTxtAra$(ZMsgDim)
      IF ZSubParm = -1 THEN _
         RETURN 10595
      ZOK = ZTrue
      RETURN
'
' *  GET USER First AND Last NAMES
'
12500 IF Attempts > 5 THEN _
         ZFF = ZTrue : _
         RETURN
      Attempts = Attempts + 1
      ZOutTxt$ = WasA1$ + _
           ZFirstNamePrompt$
      CALL SkipLine (1)
      ZLogonActive = ZTrue

      IF Attempts = 2 AND ZUseCallerIDName THEN
         ZUserInAra$(1) = ZFirstName$
         ZUserInAra$(2) = ZLastName$
         ZWasQ = 2
         ZLastIndex = 2
         ZAnsIndex = 0
      END IF

      GOSUB 12555
      ZLogonActive = ZFalse
      CALL Trim (ZWasZ$)
      ZFirstName$ = ZWasZ$
      ZOutTxt$ = WasA1$ + _
           ZLastNamePrompt$
      ZParseOff = ZTrue
      GOSUB 12555
      CALL Trim (ZWasZ$)
      ZLastName$ = ZWasZ$
      IF LEN(ZLastName$) < 2 THEN _
         IF LEN(ZFirstName$) > 2 THEN _
            GOTO 12500
      IF (LEN(ZFirstName$) + LEN(ZLastName$)) > 30 THEN _
         GOTO 12500
      IF UserSecLevelSave < ZSysopSecLevel THEN _
         IF (LEN(ZFirstName$) < 2 OR LEN(ZLastName$) < 2) THEN _
            GOTO 12500 _
         ELSE IF LEFT$(ZFirstName$,1)=SPACE$(1) OR LEFT$(ZLastName$,1)=SPACE$(1) THEN _
                 GOTO 12500
      ZActiveUserName$ = MID$(ZFirstName$ + SPACE$(1) + ZLastName$,1,31)
      IF HashIndiv > 1 THEN _
         IF ZWasQ < 3 THEN _
            GOSUB 12558 : _
            IF ZNo THEN _
               GOTO 12500
      ZWasZ$ = ZFirstName$
      RETURN
'
' *  CHECK FOR NAMES NOT ALLOWED
'
12555 GOSUB 12932
      IF ZWasQ = 0 THEN _
         RETURN 12500
      ZWasZ$ = UCASE$(ZUserInAra$(ZAnsIndex))
      CALL RemNonAlf (ZWasZ$,31,91)
      RETURN
12558 '* "{CEAre you '{CC{AN{CE'?{RC"
      LineNum = 210
      CRCount = 0
      GOSUB 49010
      ZOutTxt$ = ZYesPrompt$
      GOSUB 12995
      RETURN
'
' *  COMMON SEARCH USER FILE ROUTINE
'
12598 TempHashValue$ = HashValue$
      TempIndivValue$ = ZIndivValue$
      GOSUB 4910
      GOSUB 12988
      IF ZInConfMenu THEN
         IF NOT ZPrivateDoor AND NOT ZSubBoard AND NOT ZConfMode THEN
            '* "{CBChecking {CA{CN {CBUsers...{C7{G0"
            LineNum = 211
            CRCount = 1
            GOSUB 49010
         END IF
      END IF
      CALL OpenUser (ZHighestUserRecord)
      GOSUB 9450
      CALL FindUser (TempHashValue$,TempIndivValue$,ZStartHash,ZLenHash, _
                     ZStartIndiv,ZLenIndiv,ZHighestUserRecord,Found, _
                     ZUserFileIndex,ZWasSL)
      IF Found THEN _
         RETURN
      IF ZCurUserCount < (ZHighestUserRecord-1)*.95 THEN _
         RETURN
      '* "No room for new users in {CN"
      LineNum = 212
      GOSUB 49000
      CRCount = 2
      GOSUB 49020
      IF ZActiveUserFile$ <> ZMainUserFile$ THEN _
         ZUserFileIndex = 0 : _
         RETURN
      IF ZRememberNewUsers AND NOT ZSurviveNoUserRoom THEN _
         GOSUB 1397
      ZUserFileIndex = 0
      IF ZSurviveNoUserRoom THEN _
         ZRememberNewUsers = ZFalse
      RETURN
'
' *  AUGMENT USER COUNT, LOCK 4 REC BLOCK IN USER, UNLOCK FILES
'
12630 GOSUB 23000
      ZCurUserCount = ZCurUserCount + (ZWasSL = 0) * ZRememberNewUsers
      GOSUB 24000
      GOSUB 12985
      IF ZRememberNewUsers THEN _
         GOSUB 12989
      GOSUB 12990
      RETURN
12800 CALL SkipLine (1)
      '* "{C2Enter a {CEPASSWORD {C2you'll use to logon again{RC"
      LineNum = 213
      GOSUB 49030
      CALL NewPassword (Strng$,ZFalse)
      IF ZSubParm < 0 THEN _
         GOTO 202
      IF UserSecLevelSave < ZSysopSecLevel THEN _
         IF ZUserIn$ = SPACE$(LEN(ZUserIn$)) THEN _
            GOTO 12800
      LSET ZPswd$ = ZWasZ$
      RETURN
'
' *  GET HASH VALUE FOR CURRENT USER TO LOOK UP IN THE USER'S FILE
'
12840 IF ZStartHash = 1 THEN _
         HashValue$ = ZActiveUserName$ : _
         RETURN
      WasX$ = WasA1$ + _
           ZPromptHash$
      CALL UntilRight (WasX$,HashValue$,2,ZLenHash)
      RETURN
'
' *  GET FIELD TO INDIVIDUATE ONE USER FROM ANOTHER (NAME FIELD IS DEFAULT)
'
12850 IF ZStartIndiv < 1 OR ZLenIndiv < 1 THEN _
         RETURN
      IF ZStartIndiv = 1 THEN _
         ZIndivValue$ = ZActiveUserName$ : _
         RETURN
      IF ZExitToDoors THEN _
         RETURN
      WasX$ = WasA1$ + _
           ZPromptIndiv$
      CALL UntilRight (WasX$,ZIndivValue$,2,ZLenIndiv)
      RETURN
12930 ZTurboKey = -ZTurboKeyUser
12932 CALL PopCmdStack
      GOTO 12997
'
' *  GET CITY AND STATE
'
12960 '* "{CR{C9What is your {CBCity and State{RC"
      LineNum = 214
      GOSUB 49000
      IF NOT ZNewUser THEN _
         ZOutTxt$ = ZOutTxt$ + ZPressEnterExpert$
      ZParseOff = ZTrue
      GOSUB 12932
      IF ZWasQ = 0 OR ZUserIn$ = SPACE$(LEN(ZUserIn$)) THEN _
         IF ZNewUser THEN _
            GOTO 12960 _
         ELSE RETURN
      ZUserIn$ = UCASE$(ZUserIn$)
      '* "{CBCity and State {C9set to {CB{ZU{RC"
      LineNum = 215
      CRCount = 1
      GOSUB 49010
      LSET ZCityState$ = ZUserIn$
      ZWasCI$ = ZUserIn$
      CALL Trim (ZWasCI$)
      RETURN
'
' * CALLS INTO SEPARATELY COMPILED SUBROUTINES (RBBS-SUB)
'
'
' * STANDARD ENTRY FOR RBBS-PC'S COMMON TERMINAL OUTPUT ROUTINE
'
12975 ZSubParm = 1
      GOTO 12981
12976 ZSubParm = 2
      GOTO 12981
12977 ZSubParm = 3
      GOTO 12981
12978 ZSubParm = 4     ' no cr/lf
      GOTO 12981
12979 ZSubParm = 5     ' cr/lf
12981 CALL TPut
      IF ZSubParm < 0 THEN _
         GOTO 202
      IF ZSubParm = 8 THEN _
         GOSUB 12995
      RETURN
'
' * STANDARD ENTRY FOR RBBS-PC'S FILE LOCKING WHEN RUNNING MULTIPLE RBBS-PC'S
'
12984 ZSubParm = 1  ' LOCK USERS & MESSAGES
      GOTO 12994
12985 ZSubParm = 2  ' UNLOCK MESSAGES AND FLUSH
      Flushed = ZTrue
      GOTO 12994
12986 ZSubParm = 3  ' LOCK MESSAGES
      GOTO 12994
12987 ZSubParm = 4  ' UNLOCK MESSAGES
      GOTO 12994
12988 ZSubParm = 5  ' LOCK USERS
      GOTO 12994
12989 ZSubParm = 6  ' LOCK USER BLOCK
      GOTO 12994
12990 ZSubParm = 7  ' UNLOCK USERS
      GOTO 12994
12991 ZSubParm = 8  ' UNLOCK USER BLOCK
      GOTO 12994
12992 ZSubParm = 9  ' LOCK COMMENTS/UPLOAD DIR
      GOTO 12994
12993 ZSubParm = 10 ' UNLOCK COMMENTS/UPLOAD DIR
12994 CALL FileLock
      IF Flushed THEN _
         FIELD 1,128 AS ZMsgRec$ : _
         Flushed = ZFalse
      IF ZSubParm = -1 THEN _
         ZSubParm = -9 : _
         CALL FindFKey : _
         GOTO 202
      RETURN
'
' * STANDARD ENTRY FOR RBBS-PC'S COMMON TERMINAL INPUT ROUTINE
'
12995 GOSUB 12997
      ZSubParm = 1
      CALL TGet
12997 IF ZSubParm < 0 THEN _
         GOTO 202
      RETURN
12999 ZTurboKey = -ZTurboKeyUser
      GOTO 12995
'
' *  MAIN SYSTEM ERROR TRAP - ALL ERRORS PASS THROUGH THIS ROUTINE
'
13000 IF ZDebug THEN _
         ZOutTxt$ = "DEBUG Trap ERL=" + _
              STR$(ZWasEL) + _
              " ERR=" + _
              STR$(ZErrCode) : _
              CALL Printit(ZOutTxt$) : _
              WasD$ = ZOutTxt$ : _
              GOSUB 1315
      IF ZWasEL = 1905 AND ZErrCode = 63 THEN _
         CLOSE 1 : _
         KILL ZActiveMessageFile$ : _
         GOTO 5350
      IF ZWasEL = 4371 AND ZErrCode = 6 THEN _
         GOTO 1200
      CALL LogError
      CALL QuickTPut1 (ZCallersRecord$)
      GOTO 1200
'
' * COMMON EXIT FROM RBBS-PC (I.E. "ABANDON ALL HOPE OH YE WHO ENTER HERE")
'
13538 '* "No calls.  Recycling."
      LineNum = 216
      CRCount = 1
      GOSUB 49020
      ZExitCode = 0
      GOTO 13549
13540 IF ZLocalUser AND ZSysop THEN _
         IF NOT ZLocalUserMode THEN _
            GOTO 13549
      IF (NOT ZSysop) THEN _
         IF ((ZUserFileIndex = 0 AND ZRememberNewUsers) OR _
            ZNewUser = ZTrue) THEN _
            GOTO 13549
13545 CALL UpdateC
13549 GOSUB 13700
      IF ZLocalUser OR _
         ZModemOffHook THEN _
         GOTO 13555
      IF NOT ZFossil THEN _
         OUT ZModemCntlReg,INP(ZModemCntlReg) AND 254 : _
         CALL DelayTime (ZDTRDropDelay) : _
         OUT ZModemCntlReg,INP(ZModemCntlReg) OR 1 : _
         GOTO 13553
      CALL FosStatus(ZComPortNum,Status)
      Status = Status AND &H4000
      IF Status <> &H4000 THEN _
         CALL DelayTime (8 + ZBPS)
      State=0
      CALL FosDTR(ZComPortNum,State)
      CALL DelayTime (ZDTRDropDelay)
      State=1
      CALL FosDTR(ZComPortNum,State)
13553 CALL DelayTime (ZDTRDropDelay)
      CALL TakeOffHook
13555 ZActiveMessageFile$ = ZOrigMsgFile$
      CALL KillWork (ZArkViewPath$ + "*.*")
      GOSUB 12986
      GOSUB 5344
      GET 1,ZNodeRecIndex
      MID$(ZMsgRec$,57,1) = "I"
      MID$(ZMsgRec$,40,2) = " 0"
      MID$(ZMsgRec$,72,2) = " 0"
      IF MID$(ZMsgRec$,101,2) = ZCarriageReturn$+ZCarriageReturn$ THEN _
         MID$(ZMsgRec$,101,2) = " 0"
      PUT 1,ZNodeRecIndex
      GOSUB 12985
      CLOSE 1,2,4,5,16
      IF NOT ZFossil THEN _
         CLOSE 3
      GOTO 204
13600 CLS
      LOCATE ,,0
      '* "{SPfile missing/invalid.  Run CONFIG"
      LineNum = 217
      GOSUB 49030
      CALL PScrn (ZWasDFF$ + Strng$)
      CALL DelayTime (3)
      ZExitCode = 16
      GOTO 204
13700 IF ZMsgFileLock THEN _
         GOSUB 12987
      IF ZUserFileLock THEN _
         GOSUB 12990
      IF ZUserBlockLock THEN _
         GOSUB 12991
      RETURN
'
' *  V - COMMAND FROM FILES MENU (VIEW ARC CONTENTS)
'
20140 CALL GetArc (ZFalse,ZFalse)
      IF ZSubParm = -1 THEN _
         GOTO 10595
      IF ZDenyAccess THEN _
         GOTO 1386
      RETURN
'
' * GO TO THE FILE SYSTEM TO LIST THE FILE DIRECTORIES
'
20155 ZFileSysParm = 2
      GOTO 20200
'
' * GO TO THE FILE SYSTEM TO DOWNLOAD FILES
'
20160 ZFileSysParm = 3
      GOTO 20200
'
' * GO TO THE FILE SYSTEM WHEN RETURNING FROM EXTERNAL PROTOCOLS
'
20165 ZFileSysParm = 4
      GOTO 20200
'
' * GO TO THE FILE SYSTEM TO UPLOAD FILES
'
20170 IF ZBatchProto OR LEFT$(ZProtoPrompt$,1) = "N" THEN
         '* "Will this be a BATCH Upload? (Y)es,[N]o,A)bort)"
         LineNum = 218
         GOSUB 49000
         '* "YNA"
         LineNum = 219
         GOSUB 49030
         DO
            GOSUB 12999
            ZUserIn$ = UCASE$(ZUserIn$)
         LOOP UNTIL ZWasQ = 0 OR INSTR(Strng$,ZUserIn$) <> 0
         IF ZUserIn$ = "Y" THEN
            GOTO 20195
         ELSEIF ZUserIn$ = "N" OR ZWasQ = 0 THEN
            ZFileSysParm = 5
            GOTO 20200
         ELSE
            GOTO 20205
         END IF
      END IF
      ZFileSysParm = 5
      GOTO 20200
'
' * GO TO THE FILE SYSTEM TO SCAN FILE SYSTEM DIRECTORIES
'
20175 ZFileSysParm = 6
      GOTO 20200
'
' * GO TO THE FILE SYSTEM TO HANDLE "PERSONAL" FILES
'
20180 ZFileSysParm = 7
      GOTO 20200
'
' * GO TO THE FILE SYSTEM TO LIST "NEW" FILES
'
20185 ZFileSysParm = 8
      GOTO 20200
'
' * RETURN TO THE FILE SYSTEM AFTER HANDLING EXTENDED FILE DESCRIPTIONS
'
20190 ZFileSysParm = 9
      GOTO 20200
'
' * Go To the File System to Handle BATCH UPLOADS
'
20195 ZFileSysParm = 10
'
20200 CALL FileSystem
      ZAnsIndex = 0
      ZLastIndex = 0
      ZOutTxt$ = ""
      IF ZDnldCompleted AND ZAutoEnd = 1 AND ZAutoLogoffReq THEN _
         GOTO 20235
      ON ZFileSysParm GOTO 20205, _
                                20210, _
                                20215, _
                                20220, _
                                20225, _
                                20230, _
                                20235
20205 ZFileSysParm = 0
      RETURN
20210 RETURN 202
20215 RETURN 1200
20220 RETURN 1380
20225 ZSysopComment = ZTrue
      ZMaxMsgLines = ZMaxExtendedLines
      GOSUB 2008
      GOTO 20190
20230 RETURN 10553
20235 RETURN 10595
'
' *  GET MESSAGE HEADER RECORD DATA
'
23000 GET 1,1
      ZHighMsgNumber = VAL(LEFT$(ZMsgRec$,8))
      AutoAddSec   = CVI(MID$(ZMsgRec$,9,2))
      ZCallsToDate! = VAL(MID$(ZMsgRec$,11,10))
      ZMsgSecCats$ = LEFT$("U",-(MID$(ZMsgRec$,21,1) <> "/")) + _
                     LEFT$("R",-(MID$(ZMsgRec$,22,1) <> "/")) + _
                     LEFT$("P",-(MID$(ZMsgRec$,23,1) <> "/")) + _
                     "E@"
      IF ZUserSecLevel >= ZSecKillAny THEN _
          ZMsgSecCats$ = "URPE@"
      IF ZMsgSecCats$ = "E" THEN _
         ZMsgSecCats$ = "UE@"
      ZCurUserCount = VAL(MID$(ZMsgRec$,57,5))
      FirstMsgRecord = VAL(MID$(ZMsgRec$,68,7))
      ZNextMsgRec = VAL(MID$(ZMsgRec$,75,7))
      ZHighestMsgRecord = VAL(MID$(ZMsgRec$,82,7))
      Temp = VAL(MID$(ZMsgRec$,127))
      IF ZActiveMessageFile$ = ZOrigMsgFile$ THEN _
         ZMaxNodes = Temp
      IF ZNextMsgRec <= Temp THEN _
         ZNextMsgRec = Temp + 1
      RETURN
23100 GET 1,ZNextMsgRec
      IF MID$(ZMsgRec$,61,1) = ":" THEN _
         CALL CheckInt (MID$(ZMsgRec$,117,4)) : _
         IF ZErrCode = 0 AND (ZTestedIntValue > 1) AND _
            (ZTestedIntValue < 100) THEN _
            WasY = ZTestedIntValue : _
            CALL CheckInt (MID$(ZMsgRec$,2,4)) : _
            IF ZErrCode = 0 AND ZTestedIntValue > ZHighMsgNumber THEN _
               ZHighMsgNumber = ZTestedIntValue : _
               ZNextMsgRec = ZNextMsgRec + WasY : _
               LineNum = 1015 : _
               CRCount = 1 : _
               GOSUB 49010 : _
               MsgCorrected = ZTrue : _
               GOTO 23100
      RETURN
'
' *  UPDATE MESSAGE HEADER RECORD DATA
'
24000 MID$(ZMsgRec$,1,8) = STR$(ZHighMsgNumber)
      MID$(ZMsgRec$,11,10) = STR$(ZCallsToDate!)
      MID$(ZMsgRec$,57,5) = STR$(ZCurUserCount)
      MID$(ZMsgRec$,68,7) = STR$(FirstMsgRecord)
      MID$(ZMsgRec$,75,7) = STR$(ZNextMsgRec)
      MID$(ZMsgRec$,82,7) = STR$(ZHighestMsgRecord)
      PUT 1,1
      RETURN
'
' * A - COMMAND FROM Library MENU (ARCHIVE A SELECTED Library DISK)
'
30000 RETURN
'
' * CALCULATE TIME REMAINING FOR USER
'
41000 CALL CheckTimeRemain (MinsRemaining)
      IF ZSubParm = -1 THEN
         CALL FindFile("XFER-" + ZNodeID$ + ".DEF", ZOK)
         IF ZOK THEN
            TempParm = ZFileSysParm
            ZFileSysParm = 4
            '* "Processing files"
            CALL FormatString (220,ZTrue,ZFalse,0,ZFalse,0,"")
            CALL FileSystem
            ZFileSysParm = TempParm
         END IF
         RETURN 10553
      END IF
      RETURN
'
' * SHOW USER CURRENT ACCESS LEVEL
'
41070 IF ZUserSecLevel < ZSysopSecLevel THEN
         '* "{C2Granted access level {CB{SL{RC"
         LineNum = 221
      ELSE
         '* "{C2Granted access level {CB{SL {CF{G1(SYSOP){RC"
         LineNum = 222
      END IF
      GOSUB 49000
      GOSUB 12975
      RETURN
'
' *  F - COMMAND FROM UTILITY MENU (FILE Transfer DEFAULT MODE)
' *  FILE Transfer DEFAULT SET FOR NEW USERS
'
42800 ZFF = INSTR(ZDefaultXfer$,ZUserXferDefault$)
      '* "{CR{C2Current Protocol: {CE{PR{RC"
      LineNum = 223
      CRCount = 1
      GOSUB 49010
      '* "{CEDefault{SP"
      LineNum = 224
      GOSUB 49000
      CALL XferType (3,ZExpertUser)
      IF ZSubParm = -1 THEN _
         RETURN 10595
      ZUserXferDefault$ = ZWasFT$
      '* "{C2Protocol: {CE{PR{RC"
      LineNum = 225
      GOSUB 49000
      GOSUB 12979
      RETURN
'
' *  C - COMMAND FROM UTILITY MENU (CHANGE CASE Toggle)
' *  UPPER/LOWER CASE SET FOR NEW USERS
'
42850 CALL ChangeEchoToggle
      IF ZSubParm < 0 THEN _
         GOTO 202
      RETURN
'
' *  G - COMMAND FROM UTILITY MENU (GRAPHICS WANTED)
' *  Graphic MENUS SELECTION SET FOR NEW USERS
'
43000 CALL SetGraphicsWanted
      IF ZSubParm = -1 THEN _
         RETURN 10595
      RETURN
43025 CALL Graphic (ZFileName$)

'
' *  DISPLAY NON-BREAKABLE TEXT FILES
'
43027 ZStopInterrupts = ZTrue
      CALL BufFile (ZFileName$,WasX)
      CALL CheckCarrier
      IF ZSubParm = -1 THEN _
         RETURN 10595
      ZStopInterrupts = ZFalse
      RETURN
'
' * Prompt to use Full Screen Editor
'
43030 '* "Use the Full Screen Editor? (Y,[N])"
      LineNum = 226
      GOSUB 49000
      GOSUB 12930
      RETURN
'
' * Run Epilog File
'
44000 IF ZUserSecLevel < ZSecExemptFromEpilog THEN
         ZFileName$ = ZEpilog$
         CALL Graphic (ZFileName$)
         GOSUB 11520
      END IF
      RETURN
'
' * MAKE INPUT STRING HIDDEN (USE *'S TO ECHO INPUT)
'
45010 ZHidden = ZTrue
      GOSUB 12995
      ZHidden = ZFalse
      RETURN
'
' * MARKED FILES WARNING
'
45020 IF ZMarkedFiles$ <> "" THEN
         CALL PutCom(ZBellRinger$)
         CALL CmdStackPushPop (1)
         DO
            '* "{CR{CF{B1You Have Marked Files!{RC{CR{CBDownload them now{RC ([Y],N)"
            LineNum = 227
            GOSUB 49000
            GOSUB 12999
            ZUserIn$ = UCASE$(ZUserIn$)
         LOOP UNTIL ZWasQ = 0 OR INSTR("YN",ZUserIn$) <> 0
         IF ZWasQ = 0 OR UCASE$(ZUserIn$) = "Y" THEN
            ZLastIndex = 1
            ZAnsIndex = 0
            ZWasQ = 1
            ZUserInAra$(1) = "M"
            GOSUB 20160
         ELSE
            ZMarkedFiles$ = ""
         END IF
         CALL CmdStackPushPop (2)
      END IF
      RETURN
'
'  * Maple AutoLogoff Routines ***
'
46000 ZSubParm = 1
      IF ZAutoLogoffReq = ZFalse THEN _
         ZAutoEnd = 0 : _
         RETURN 1205
      IF ZPersonalDnld THEN
         RETURN 10597
      END IF
      CALL SkipLine (1)
      '* "{RCPress [G] for instant Logoff"
      LineNum = 228
      GOSUB 49000
      ZTurboKey = 2
      CALL TGet
      ZUserIn$ = UCASE$(ZUserIn$)
      IF ZUserIn$ = "G" THEN
         GOTO 46050
      ELSE
         '* "{CF{G1Log Off Aborted!{RC"
         LineNum = 229
         CRCount = 1
         GOSUB 49010
         ZAutoLogoffReq = ZFalse
         ZAutoEnd = 0
         RETURN 1205
      END IF
46050 GetOut = ZTrue
      '* "Auto-logoff"
      LineNum = 230
      CRCount = 1
      GOSUB 49020
      RETURN 10597
'
'* RIP message text window display
'
47000 RIPFile$ = "RIPWINL.RIP"
47010 IF ZWasGR = 4 THEN
         CALL BufFile (ZWelcomeFileDrvPath$ + RIPFile$,WasX)
      END IF
      RETURN
47100 CALL MailWait
      RETURN
'
' * restore time when reading messages/bulletins if CONFIG'ed
'
48000 IF NOT SuspendTime THEN
         RETURN
      END IF
      CALL CheckTime (StartTime!,Elapsed!,2)
      ZSecsPerSession! = ZSecsPerSession! + Elapsed!
      SuspendTime = ZFalse
      RETURN
'
' * Get external string for ZOutTxt$
'
49000 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,ZOutTxt$)
      RETURN
'
' * Get external string for QuickTPut
'
49010 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZTrue,CRCount,"")
      RETURN
'
' * Get external string for UpdtCalr
'
49020 CALL FormatString (LineNum,ZFalse,ZTrue,CRCount,ZFalse,0,"")
      RETURN
'
' * Get external string for Strng$
'
49030 CALL FormatString (LineNum,ZFalse,ZFalse,0,ZFalse,0,Strng$)
      RETURN
